// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-5.0.8/src/analyzer/protocol/ssl/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"


#line 2 "functions.bif"

#include <openssl/x509.h>
#include "zeek/analyzer/protocol/ssl/SSL.h"
#include "zeek/Reporter.h"

#line 14 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_ssl_established_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 15 "functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		reporter->Error("set_ssl_established() takes exactly 1 argument(s)");
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());

#line 15 "functions.bif"

	zeek::analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->StartEncryption();
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_ssl_established

#line 25 "functions.bif"

#line 35 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_secret_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 36 "functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		reporter->Error("set_secret() takes exactly 2 argument(s)");
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());
	zeek::StringVal* secret = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 36 "functions.bif"

	analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->SetSecret(*secret);
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_secret

#line 46 "functions.bif"

#line 56 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_keys_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 57 "functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		reporter->Error("set_keys() takes exactly 2 argument(s)");
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());
	zeek::StringVal* keys = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 57 "functions.bif"

	analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->SetKeys(*keys);
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_keys

#line 67 "functions.bif"
