// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"

namespace hilti { namespace detail { class Parser; } }

#include <hilti/compiler/detail/parser/driver.h>

#line 39 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"


#include <hilti/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(hilti::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}


/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));

    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)


#line 100 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 27 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
namespace hilti { namespace detail { namespace parser {
#line 198 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.copy< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.copy< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.copy< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  Parser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.YY_MOVE_OR_COPY< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.YY_MOVE_OR_COPY< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.YY_MOVE_OR_COPY< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.YY_MOVE_OR_COPY< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.YY_MOVE_OR_COPY< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.YY_MOVE_OR_COPY< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.YY_MOVE_OR_COPY< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.YY_MOVE_OR_COPY< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.YY_MOVE_OR_COPY< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.copy< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch > (that.value);
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.copy< hilti::type::Flags > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        value.move< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch > (that.value);
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        value.move< hilti::type::Flags > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 20 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 2011 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute > ();
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        yylhs.value.emplace< hilti::Declaration > ();
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression > ();
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        yylhs.value.emplace< hilti::Function > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement > ();
        break;

      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
        yylhs.value.emplace< hilti::Type > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::declaration::parameter::Kind > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case > ();
        break;

      case symbol_kind::S_try_catch: // try_catch
        yylhs.value.emplace< hilti::statement::try_::Catch > ();
        break;

      case symbol_kind::S_opt_type_flags: // opt_type_flags
        yylhs.value.emplace< hilti::type::Flags > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter > ();
        break;

      case symbol_kind::S_func_result: // func_result
        yylhs.value.emplace< hilti::type::function::Result > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element > ();
        break;

      case symbol_kind::S_const_sint: // const_sint
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< std::optional<hilti::AttributeSet> > ();
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
        yylhs.value.emplace< std::optional<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        yylhs.value.emplace< std::optional<hilti::Statement> > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        yylhs.value.emplace< std::vector<hilti::Declaration> > ();
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< std::vector<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< std::vector<hilti::Statement> > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< std::vector<hilti::ctor::map::Element> > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case symbol_kind::S_try_catches: // try_catches
        yylhs.value.emplace< std::vector<hilti::statement::try_::Catch> > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< std::vector<hilti::type::enum_::Label> > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        yylhs.value.emplace< std::vector<hilti::type::function::Parameter> > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< std::vector<hilti::type::tuple::Element> > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_const_uint: // const_uint
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // module: "module" local_id '{' global_scope_items '}'
#line 280 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto m = hilti::Module(yystack_[3].value.as < hilti::ID > (), std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2393 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 3: // local_id: "identifier"
#line 287 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( name.find('-') != std::string::npos )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" && name != "__str__" )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 2407 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 4: // scoped_id: local_id
#line 297 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2413 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 5: // scoped_id: "scoped identifier"
#line 298 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2419 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 6: // $@1: %empty
#line 300 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                { driver->enableDottedIDMode(); }
#line 2425 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 7: // $@2: %empty
#line 302 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                { driver->disableDottedIDMode(); }
#line 2431 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 8: // dotted_id: $@1 "dotted identifier" $@2
#line 302 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > (), __loc__); }
#line 2437 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 9: // global_scope_items: global_scope_items global_scope_decl
#line 308 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2443 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 10: // global_scope_items: global_scope_items stmt
#line 310 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 2449 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 11: // global_scope_items: %empty
#line 311 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 2455 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 12: // global_scope_decl: type_decl
#line 315 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2461 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_decl: constant_decl
#line 316 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2467 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_decl: global_decl
#line 317 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2473 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_decl: function_decl
#line 318 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2479 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: import_decl
#line 319 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2485 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: property_decl
#line 320 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2491 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 18: // type_decl: opt_linkage "type" scoped_id '=' type opt_attributes ';'
#line 323 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[6].value.as < hilti::declaration::Linkage > ()), __loc__); }
#line 2497 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 19: // constant_decl: opt_linkage "const" scoped_id '=' expr ';'
#line 326 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2503 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 20: // constant_decl: opt_linkage "const" type scoped_id '=' expr ';'
#line 328 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2509 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 21: // local_decl: "local" local_id '=' expr ';'
#line 331 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2515 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 22: // local_decl: "local" type local_id opt_type_arguments ';'
#line 332 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                          { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < std::vector<hilti::Expression> > (), {}, false, __loc__); }
#line 2521 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 23: // local_decl: "local" type local_id '=' expr ';'
#line 334 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2527 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 24: // local_decl: "local" "auto" local_id '=' expr ';'
#line 336 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2533 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 25: // local_init_decl: "local" type local_id '=' expr
#line 341 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2539 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 26: // local_init_decl: "local" "auto" local_id '=' expr
#line 343 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2545 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 27: // global_decl: opt_linkage "global" scoped_id '=' expr ';'
#line 347 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2551 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 28: // global_decl: opt_linkage "global" type scoped_id opt_type_arguments ';'
#line 349 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < std::vector<hilti::Expression> > (), {}, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2557 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 29: // global_decl: opt_linkage "global" type scoped_id '=' expr ';'
#line 351 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2563 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 30: // global_decl: opt_linkage "global" "auto" scoped_id '=' expr ';'
#line 353 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2569 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 31: // opt_type_arguments: '(' opt_exprs ')'
#line 357 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()); }
#line 2575 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 32: // opt_type_arguments: %empty
#line 358 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>{}; }
#line 2581 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 33: // function_decl: opt_linkage "function" function_with_body
#line 361 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2587 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 34: // function_decl: opt_linkage "hook" hook_with_body
#line 362 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                             { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2593 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 35: // function_decl: "method" method_with_body
#line 365 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), hilti::declaration::Linkage::Struct, __loc__); }
#line 2599 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 36: // function_decl: "declare" opt_linkage function_without_body ';'
#line 367 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[1].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2605 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 37: // import_decl: "import" local_id ';'
#line 370 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".hlt"), __loc__); }
#line 2611 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 38: // import_decl: "import" local_id "from" dotted_id ';'
#line 371 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".hlt"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 2617 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 39: // property_decl: "property" ';'
#line 375 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 2623 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 40: // property_decl: "property" '=' expr ';'
#line 376 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2629 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 41: // opt_linkage: "public"
#line 378 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 2635 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 42: // opt_linkage: "private"
#line 379 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2641 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 43: // opt_linkage: "init"
#line 380 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Init; }
#line 2647 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 44: // opt_linkage: "preinit"
#line 381 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::PreInit; }
#line 2653 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 45: // opt_linkage: %empty
#line 382 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2659 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 46: // function_id: local_id
#line 386 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2665 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 47: // function_id: "~finally"
#line 387 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID("~finally", __loc__); }
#line 2671 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 48: // scoped_function_id: function_id
#line 390 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2677 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 49: // scoped_function_id: "scoped identifier"
#line 391 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2683 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 50: // scoped_function_id: "scoped ~finally"
#line 392 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2689 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 51: // function_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 396 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Standard, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2698 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 52: // method_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 403 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Method, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2707 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 53: // hook_with_body: opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 410 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Hook, __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2716 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 54: // function_without_body: opt_func_flavor opt_func_cc func_result scoped_function_id '(' opt_func_params ')' opt_attributes
#line 417 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[5].value.as < hilti::type::function::Result > (), yystack_[2].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[7].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[4].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as < hilti::function::CallingConvention > (), yystack_[0].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2725 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_flavor: func_flavor
#line 422 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = yystack_[0].value.as < hilti::type::function::Flavor > (); }
#line 2731 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_flavor: %empty
#line 423 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 2737 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 57: // func_flavor: "method"
#line 425 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Method; }
#line 2743 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 58: // func_flavor: "hook"
#line 426 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Hook; }
#line 2749 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 59: // opt_func_cc: "extern"
#line 428 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Extern; }
#line 2755 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 60: // opt_func_cc: "extern-no-suspend"
#line 429 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::ExternNoSuspend; }
#line 2761 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_cc: %empty
#line 430 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 2767 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_params: func_params
#line 432 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 2773 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_params: %empty
#line 433 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 2779 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 64: // func_params: func_params ',' func_param
#line 435 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                         { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as < std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter > ()); }
#line 2785 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 65: // func_params: func_param
#line 436 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as < hilti::type::function::Parameter > ()}; }
#line 2791 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 66: // func_param: opt_func_param_kind type local_id opt_func_default_expr opt_attributes
#line 439 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[4].value.as < hilti::declaration::parameter::Kind > (), yystack_[1].value.as < std::optional<hilti::Expression> > (), yystack_[0].value.as < std::optional<hilti::AttributeSet> > (), __loc__); }
#line 2797 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 67: // func_result: type
#line 442 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 2803 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 68: // opt_func_param_kind: "copy"
#line 445 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::Copy; }
#line 2809 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 69: // opt_func_param_kind: "inout"
#line 446 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 2815 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 70: // opt_func_param_kind: %empty
#line 447 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 2821 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 71: // opt_func_default_expr: '=' expr
#line 450 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 2827 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 72: // opt_func_default_expr: %empty
#line 451 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 2833 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 73: // block: braced_block
#line 456 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 2839 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 74: // block: stmt
#line 457 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as < hilti::Statement > ()}, __loc__); }
#line 2845 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 75: // braced_block: '{' opt_stmts '}'
#line 460 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()), __loc__); }
#line 2851 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 76: // opt_stmts: stmts
#line 462 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as < std::vector<hilti::Statement> > ()); }
#line 2857 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 77: // opt_stmts: %empty
#line 463 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 2863 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 78: // stmts: stmts stmt
#line 465 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()); yylhs.value.as < std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 2869 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 79: // stmts: stmt
#line 466 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as < hilti::Statement > ())}; }
#line 2875 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 80: // stmt: stmt_expr ';'
#line 468 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[1].value.as < hilti::Statement > ()); }
#line 2881 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 81: // stmt: stmt_decl
#line 469 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 2887 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 82: // stmt: "return" ';'
#line 470 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 2893 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 83: // stmt: "return" expr ';'
#line 471 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2899 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 84: // stmt: "throw" expr ';'
#line 472 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Throw(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2905 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 85: // stmt: "throw" ';'
#line 473 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Throw(__loc__); }
#line 2911 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 86: // stmt: "yield" ';'
#line 474 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Yield(__loc__); }
#line 2917 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 87: // stmt: "break" ';'
#line 475 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 2923 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 88: // stmt: "continue" ';'
#line 476 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 2929 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 89: // stmt: "if" '(' expr ')' block opt_else_block
#line 478 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2935 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 90: // stmt: "if" '(' local_init_decl ')' block opt_else_block
#line 480 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Declaration > ()), {}, std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2941 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 91: // stmt: "if" '(' local_init_decl ';' expr ')' block opt_else_block
#line 482 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as < hilti::Declaration > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2947 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 92: // stmt: "while" '(' local_init_decl ';' expr ')' block opt_else_block
#line 484 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[5].value.as < hilti::Declaration > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2953 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "while" '(' expr ')' block opt_else_block
#line 486 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2959 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 94: // stmt: "while" '(' local_init_decl ')' block opt_else_block
#line 488 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as < hilti::Declaration > ()), {}, std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 2965 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 95: // stmt: "for" '(' local_id "in" expr ')' block
#line 490 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 2971 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 96: // stmt: "switch" '(' expr ')' '{' opt_switch_cases '}'
#line 492 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 2977 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 97: // stmt: "switch" '(' local_init_decl ')' '{' opt_switch_cases '}'
#line 494 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Declaration > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 2983 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 98: // stmt: "try" block try_catches
#line 496 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Try(std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::vector<hilti::statement::try_::Catch> > ()), __loc__); }
#line 2989 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 99: // stmt: "assert" expr ';'
#line 497 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as < hilti::Expression > ()), {}, __loc__); }
#line 2995 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 100: // stmt: "assert" expr ':' expr ';'
#line 498 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3001 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 101: // stmt: "assert-exception" expr ';'
#line 499 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression > ()), {}, {}, __loc__); }
#line 3007 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 102: // stmt: "assert-exception" expr ':' expr ';'
#line 501 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression > ()), {}, std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3013 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 103: // stmt: "add" expr ';'
#line 503 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3025 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 104: // stmt: "delete" expr ';'
#line 511 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3037 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 105: // stmt: "unset" expr ';'
#line 519 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3049 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 106: // opt_else_block: "else" block
#line 529 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 3055 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 107: // opt_else_block: %empty
#line 530 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = {}; }
#line 3061 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 108: // opt_switch_cases: switch_cases
#line 533 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[0].value.as < std::vector<hilti::statement::switch_::Case> > ()); }
#line 3067 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 109: // opt_switch_cases: %empty
#line 534 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = {}; }
#line 3073 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 110: // switch_cases: switch_cases switch_case
#line 536 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as < std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ())); }
#line 3079 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 111: // switch_cases: switch_case
#line 537 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ()) }); }
#line 3085 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 112: // switch_case: "case" exprs ':' block
#line 539 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3091 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 113: // switch_case: "default" ':' block
#line 540 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3097 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 114: // try_catches: try_catches try_catch
#line 542 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::try_::Catch> > () = std::move(yystack_[1].value.as < std::vector<hilti::statement::try_::Catch> > ()); yylhs.value.as < std::vector<hilti::statement::try_::Catch> > ().push_back(std::move(yystack_[0].value.as < hilti::statement::try_::Catch > ())); }
#line 3103 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 115: // try_catches: try_catch
#line 543 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::try_::Catch> > () = std::vector<hilti::statement::try_::Catch>({ std::move(yystack_[0].value.as < hilti::statement::try_::Catch > ()) }); }
#line 3109 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 116: // try_catch: "catch" '(' type local_id ')' block
#line 546 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(declaration::Parameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), declaration::parameter::Kind::In, {}, __loc__), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3115 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 117: // try_catch: "catch" block
#line 547 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3121 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 118: // stmt_decl: local_decl
#line 549 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3127 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 119: // stmt_decl: type_decl
#line 550 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3133 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 120: // stmt_decl: constant_decl
#line 551 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3139 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 121: // stmt_expr: expr
#line 554 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as < hilti::Expression > (), __loc__); }
#line 3145 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 122: // base_type_no_attrs: "any"
#line 559 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Any(__loc__); }
#line 3151 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_attrs: "addr"
#line 560 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Address(__loc__); }
#line 3157 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_attrs: "auto"
#line 561 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::auto_; }
#line 3163 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_attrs: "bool"
#line 562 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bool(__loc__); }
#line 3169 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_attrs: "bytes"
#line 563 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 3175 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_attrs: "error"
#line 564 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Error(__loc__); }
#line 3181 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_attrs: "interval"
#line 565 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Interval(__loc__); }
#line 3187 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_attrs: "net"
#line 566 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Network(__loc__); }
#line 3193 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_attrs: "port"
#line 567 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Port(__loc__); }
#line 3199 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_attrs: "real"
#line 568 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Real(__loc__); }
#line 3205 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_attrs: "regexp"
#line 569 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 3211 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_attrs: "stream"
#line 570 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Stream(__loc__); }
#line 3217 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_attrs: "string"
#line 571 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::String(__loc__); }
#line 3223 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_attrs: "time"
#line 572 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Time(__loc__); }
#line 3229 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_attrs: "void"
#line 573 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::void_; }
#line 3235 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_attrs: "int" type_param_begin "unsigned integer value" type_param_end
#line 575 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3241 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_attrs: "int" type_param_begin '*' type_param_end
#line 576 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3247 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_attrs: "uint" type_param_begin "unsigned integer value" type_param_end
#line 577 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3253 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_attrs: "uint" type_param_begin '*' type_param_end
#line 578 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3259 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_attrs: "optional" type_param_begin type type_param_end
#line 580 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Optional(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3265 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_attrs: "result" type_param_begin type type_param_end
#line 581 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Result(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3271 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_attrs: "view" type_param_begin type type_param_end
#line 582 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = viewForType(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3277 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_attrs: "iterator" type_param_begin type type_param_end
#line 583 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), false, __loc__); }
#line 3283 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_attrs: "const_iterator" type_param_begin type type_param_end
#line 584 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), true, __loc__); }
#line 3289 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_attrs: "strong_ref" type_param_begin type type_param_end
#line 585 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3295 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_attrs: "strong_ref" type_param_begin '*' type_param_end
#line 586 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(hilti::type::Wildcard(), __loc__); }
#line 3301 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 148: // base_type_no_attrs: "value_ref" type_param_begin type type_param_end
#line 587 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::ValueReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3307 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 149: // base_type_no_attrs: "value_ref" type_param_begin '*' type_param_end
#line 588 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::ValueReference(hilti::type::Wildcard(), __loc__); }
#line 3313 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 150: // base_type_no_attrs: "weak_ref" type_param_begin type type_param_end
#line 589 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::WeakReference(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3319 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 151: // base_type_no_attrs: "weak_ref" type_param_begin '*' type_param_end
#line 590 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::WeakReference(hilti::type::Wildcard(), __loc__); }
#line 3325 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 152: // base_type_no_attrs: "list" type_param_begin '*' type_param_end
#line 592 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::List(hilti::type::Wildcard(), __loc__); }
#line 3331 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 153: // base_type_no_attrs: "list" type_param_begin type type_param_end
#line 593 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::List(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3337 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 154: // base_type_no_attrs: "vector" type_param_begin '*' type_param_end
#line 594 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Vector(hilti::type::Wildcard(), __loc__); }
#line 3343 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 155: // base_type_no_attrs: "vector" type_param_begin type type_param_end
#line 595 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3349 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 156: // base_type_no_attrs: "set" type_param_begin '*' type_param_end
#line 596 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Set(hilti::type::Wildcard(), __loc__); }
#line 3355 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 157: // base_type_no_attrs: "set" type_param_begin type type_param_end
#line 597 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3361 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 158: // base_type_no_attrs: "map" type_param_begin '*' type_param_end
#line 598 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Map(hilti::type::Wildcard(), __loc__); }
#line 3367 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 159: // base_type_no_attrs: "map" type_param_begin type ',' type type_param_end
#line 599 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3373 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 160: // base_type_no_attrs: "exception"
#line 601 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Exception(__loc__); }
#line 3379 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 161: // base_type_no_attrs: "exception" ':' type
#line 602 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Exception(std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3385 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 162: // base_type_no_attrs: "library type" '(' "string value" ')'
#line 604 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3391 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 163: // base_type_no_attrs: tuple_type
#line 606 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3397 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 164: // base_type_no_attrs: struct_type
#line 607 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3403 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 165: // base_type_no_attrs: union_type
#line 608 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3409 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 166: // base_type_no_attrs: enum_type
#line 609 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3415 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 167: // base_type: base_type_no_attrs opt_type_flags
#line 613 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = type::addFlags(yystack_[1].value.as < hilti::Type > (), yystack_[0].value.as < hilti::type::Flags > ()); }
#line 3421 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 168: // type: base_type
#line 616 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3427 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 169: // type: function_type
#line 617 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3433 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 170: // type: scoped_id
#line 618 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3439 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 171: // type_param_begin: '<'
#line 623 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
              { driver->disableExpressionMode(); }
#line 3445 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 172: // type_param_end: '>'
#line 627 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
              { driver->enableExpressionMode(); }
#line 3451 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 173: // opt_type_flags: %empty
#line 629 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::Flags > () = hilti::type::Flags(); }
#line 3457 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 174: // function_type: opt_func_flavor "function" '(' opt_func_params ')' "->" func_result
#line 633 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Function(yystack_[0].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[6].value.as < hilti::type::function::Flavor > (), __loc__); }
#line 3463 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 175: // tuple_type: "tuple" type_param_begin '*' type_param_end
#line 636 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 3469 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 176: // tuple_type: "tuple" type_param_begin tuple_type_elems type_param_end
#line 637 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 3475 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 177: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 642 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as < std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element > ())); }
#line 3481 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 178: // tuple_type_elems: tuple_type_elem
#line 643 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::vector<hilti::type::tuple::Element>{ std::move(yystack_[0].value.as < hilti::type::tuple::Element > ()) }; }
#line 3487 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 179: // tuple_type_elem: type
#line 647 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = hilti::type::tuple::Element(hilti::ID(), std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3493 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 180: // tuple_type_elem: local_id ':' type
#line 648 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = hilti::type::tuple::Element(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3499 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 181: // struct_type: "struct" opt_struct_params '{' struct_fields '}'
#line 651 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                   { yylhs.value.as < hilti::Type > () = hilti::type::Struct(std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()), __loc__); }
#line 3505 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 182: // opt_struct_params: '(' opt_func_params ')'
#line 654 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 3511 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 183: // opt_struct_params: %empty
#line 655 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 3517 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 184: // struct_fields: struct_fields struct_field
#line 657 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 3523 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 185: // struct_fields: %empty
#line 658 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 3529 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 186: // struct_field: type local_id opt_attributes ';'
#line 660 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3535 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 187: // struct_field: func_flavor opt_func_cc func_result function_id '(' opt_func_params ')' opt_attributes ';'
#line 661 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                                                           {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as < hilti::type::function::Result > ()), std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), std::move(ftype), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 3544 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 188: // struct_field: func_flavor opt_func_cc func_result function_id '(' opt_func_params ')' opt_attributes braced_block
#line 665 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                                                                    {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as < hilti::type::function::Result > ()), std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   auto func = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), std::move(yystack_[0].value.as < hilti::Statement > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), {});
                                                   yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(yystack_[5].value.as < hilti::ID > (), std::move(func), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 3554 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 189: // union_type: "union" opt_attributes '{' opt_union_fields '}'
#line 672 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Union(std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()), __loc__); }
#line 3560 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 190: // opt_union_fields: union_fields
#line 674 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = yystack_[0].value.as < std::vector<hilti::Declaration> > (); }
#line 3566 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 191: // opt_union_fields: %empty
#line 675 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>(); }
#line 3572 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 192: // union_fields: union_fields ',' union_field
#line 677 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::move(yystack_[2].value.as < std::vector<hilti::Declaration> > ()); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration > ())); }
#line 3578 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 193: // union_fields: union_field
#line 678 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>(); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration > ())); }
#line 3584 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 194: // union_field: type local_id opt_attributes
#line 680 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3590 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 195: // enum_type: "enum" '{' enum_labels '}'
#line 682 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 3596 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 196: // enum_type: "enum" '<' '*' '>'
#line 683 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Enum(type::Wildcard(), __loc__); }
#line 3602 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 197: // enum_labels: enum_labels ',' enum_label
#line 685 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3608 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 198: // enum_labels: enum_labels ','
#line 686 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()); }
#line 3614 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 199: // enum_labels: enum_label
#line 687 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3620 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 200: // enum_label: local_id
#line 690 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3626 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 201: // enum_label: local_id '=' "unsigned integer value"
#line 691 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3632 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 202: // expr: expr_0
#line 696 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3638 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 203: // opt_exprs: exprs
#line 699 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as < std::vector<hilti::Expression> > ()); }
#line 3644 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 204: // opt_exprs: %empty
#line 700 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 3650 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 205: // exprs: exprs ',' expr
#line 702 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()); yylhs.value.as < std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 3656 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 206: // exprs: expr
#line 703 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 3662 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 207: // expr_0: expr_1
#line 705 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3668 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 208: // expr_1: expr_2 '=' expr_1
#line 708 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3674 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 209: // expr_1: expr_2 "-=" expr_1
#line 709 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3680 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 210: // expr_1: expr_2 "+=" expr_1
#line 710 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3686 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 211: // expr_1: expr_2 "*=" expr_1
#line 711 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3692 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 212: // expr_1: expr_2 "/=" expr_1
#line 712 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3698 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 213: // expr_1: expr_2 '?' expr_1 ':' expr_1
#line 713 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3704 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 214: // expr_1: expr_2
#line 714 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3710 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 215: // expr_2: expr_2 "||" expr_3
#line 716 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3716 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 216: // expr_2: expr_3
#line 717 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3722 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 217: // expr_3: expr_3 "&&" expr_4
#line 719 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3728 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 218: // expr_3: expr_4
#line 720 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3734 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 219: // expr_4: expr_4 "==" expr_5
#line 722 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3740 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 220: // expr_4: expr_4 "!=" expr_5
#line 723 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3746 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 221: // expr_4: expr_5
#line 724 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3752 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 222: // expr_5: expr_5 '<' expr_6
#line 726 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3758 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 223: // expr_5: expr_5 '>' expr_6
#line 727 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3764 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 224: // expr_5: expr_5 ">=" expr_6
#line 728 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3770 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 225: // expr_5: expr_5 "<=" expr_6
#line 729 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3776 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 226: // expr_5: expr_6
#line 730 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3782 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 227: // expr_6: expr_6 '|' expr_7
#line 732 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3788 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 228: // expr_6: expr_7
#line 733 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3794 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 229: // expr_7: expr_7 '^' expr_8
#line 735 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3800 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 230: // expr_7: expr_8
#line 736 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3806 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 231: // expr_8: expr_8 '&' expr_9
#line 738 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3812 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 232: // expr_8: expr_9
#line 739 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3818 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 233: // expr_9: expr_9 "<<" expr_a
#line 741 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3824 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 234: // expr_9: expr_9 ">>" expr_a
#line 742 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3830 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 235: // expr_9: expr_a
#line 743 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3836 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 236: // expr_a: expr_a '+' expr_b
#line 745 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3842 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 237: // expr_a: expr_a '-' expr_b
#line 746 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3848 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 238: // expr_a: expr_b
#line 747 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3854 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 239: // expr_b: expr_b '%' expr_c
#line 749 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3860 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 240: // expr_b: expr_b '*' expr_c
#line 750 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3866 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 241: // expr_b: expr_b '/' expr_c
#line 751 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3872 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 242: // expr_b: expr_b "**" expr_c
#line 752 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3878 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 243: // expr_b: expr_c
#line 753 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3884 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 244: // expr_c: '!' expr_c
#line 755 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 3890 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 245: // expr_c: '*' expr_c
#line 756 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3896 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 246: // expr_c: '~' expr_c
#line 757 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3902 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 247: // expr_c: '|' expr_c '|'
#line 758 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3908 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 248: // expr_c: "--" expr_c
#line 759 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3914 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 249: // expr_c: "++" expr_c
#line 760 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3920 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 250: // expr_c: expr_d
#line 761 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3926 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 251: // expr_d: expr_d '(' opt_exprs ')'
#line 763 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 3932 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 252: // expr_d: expr_d '.' member_expr
#line 764 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3938 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 253: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 765 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 3944 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 254: // expr_d: expr_d '[' expr ']'
#line 766 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3950 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 255: // expr_d: expr_d "?." member_expr
#line 767 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3956 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 256: // expr_d: expr_d "in" expr_d
#line 768 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3962 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 257: // expr_d: expr_d "!in" expr_d
#line 769 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__)); }
#line 3968 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 258: // expr_d: expr_d "--"
#line 770 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3974 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 259: // expr_d: expr_d "++"
#line 771 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3980 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 260: // expr_d: expr_d ".?" member_expr
#line 772 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 3986 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 261: // expr_d: expr_e
#line 773 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3992 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 262: // expr_e: "begin" '(' expr ')'
#line 775 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 3998 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 263: // expr_e: "cast" type_param_begin type type_param_end '(' expr ')'
#line 776 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as < hilti::Type > ()))}, __loc__); }
#line 4004 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 264: // expr_e: "end" '(' expr ')'
#line 777 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4010 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 265: // expr_e: "move" '(' expr ')'
#line 778 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Move(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4016 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 266: // expr_e: "unpack" type_param_begin type type_param_end tuple_expr
#line 779 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unpack, {hilti::expression::Type_(std::move(yystack_[2].value.as < hilti::Type > ())), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4022 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 267: // expr_e: "new" expr
#line 780 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {std::move(yystack_[0].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 4028 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 268: // expr_e: "new" type
#line 781 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[0].value.as < hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 4034 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 269: // expr_e: "new" type '(' opt_exprs ')'
#line 782 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[3].value.as < hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 4040 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 270: // expr_e: "typeinfo" '(' expr ')'
#line 783 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::TypeInfo(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4046 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 271: // expr_e: "typeinfo" '(' base_type ')'
#line 784 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::TypeInfo(expression::Type_(std::move(yystack_[1].value.as < hilti::Type > ())), __loc__); }
#line 4052 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 272: // expr_e: expr_f
#line 785 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4058 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 273: // expr_f: ctor
#line 787 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__); }
#line 4064 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 274: // expr_f: "port" '(' expr ',' expr ')'
#line 788 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::port(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4070 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 275: // expr_f: '-' expr_g
#line 789 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4076 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 276: // expr_f: '[' expr "for" local_id "in" expr ']'
#line 791 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4082 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 277: // expr_f: '[' expr "for" local_id "in" expr "if" expr ']'
#line 793 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[7].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression > ()),  __loc__); }
#line 4088 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 278: // expr_f: expr_g
#line 794 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4094 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 279: // expr_g: '(' expr ')'
#line 796 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as < hilti::Expression > ())); }
#line 4100 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 280: // expr_g: scoped_id
#line 797 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4106 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 281: // member_expr: local_id
#line 800 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4112 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 282: // member_expr: "error"
#line 801 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Member(ID("error", __loc__), __loc__); }
#line 4118 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 283: // ctor: "bool value"
#line 805 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as < bool > (), __loc__); }
#line 4124 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 284: // ctor: "bytes value"
#line 806 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4130 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 285: // ctor: "string value"
#line 807 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as < std::string > (), __loc__); }
#line 4136 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 286: // ctor: const_real
#line 808 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as < double > (), __loc__); }
#line 4142 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 287: // ctor: "unsigned integer value"
#line 809 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 4148 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 288: // ctor: '+' "unsigned integer value"
#line 810 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__), 64, __loc__); }
#line 4154 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 289: // ctor: '-' "unsigned integer value"
#line 811 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__), 64, __loc__); }
#line 4160 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 290: // ctor: "Null"
#line 812 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 4166 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 291: // ctor: "address value"
#line 814 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4172 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 292: // ctor: "address value" '/' "unsigned integer value"
#line 815 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 4178 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 293: // ctor: "port value"
#line 816 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4184 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 294: // ctor: "interval" '(' const_real ')'
#line 817 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as < double > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4192 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 295: // ctor: "interval" '(' const_sint ')'
#line 820 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as < int64_t > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4200 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 296: // ctor: "time" '(' const_real ')'
#line 823 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as < double > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4208 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 297: // ctor: "time" '(' const_uint ')'
#line 826 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as < uint64_t > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4216 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 298: // ctor: "stream" '(' "bytes value" ')'
#line 829 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Stream(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 4222 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 299: // ctor: "error" '(' "string value" ')'
#line 831 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Error(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 4228 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 300: // ctor: "optional" '(' expr ')'
#line 832 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4234 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 301: // ctor: "default" type_param_begin type type_param_end '(' opt_exprs ')'
#line 834 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Default(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4240 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 302: // ctor: "uint" '<' "unsigned integer value" '>' '(' "unsigned integer value" ')'
#line 837 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as < uint64_t > (), yystack_[4].value.as < uint64_t > (), __loc__); }
#line 4246 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 303: // ctor: "int" '<' "unsigned integer value" '>' '(' "unsigned integer value" ')'
#line 839 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[1].value.as < uint64_t > (), true, __loc__), yystack_[4].value.as < uint64_t > (), __loc__); }
#line 4252 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 304: // ctor: "int" '<' "unsigned integer value" '>' '(' '-' "unsigned integer value" ')'
#line 841 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[1].value.as < uint64_t > (), false, __loc__), yystack_[5].value.as < uint64_t > (), __loc__); }
#line 4258 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 305: // ctor: list
#line 843 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4264 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 306: // ctor: map
#line 844 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4270 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 307: // ctor: regexp
#line 845 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4276 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 308: // ctor: set
#line 846 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4282 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 309: // ctor: struct_
#line 847 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4288 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 310: // ctor: tuple
#line 848 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4294 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 311: // const_real: "real value"
#line 851 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = yystack_[0].value.as < double > (); }
#line 4300 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 312: // const_real: '+' "real value"
#line 852 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = yystack_[0].value.as < double > (); }
#line 4306 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 313: // const_real: '-' "real value"
#line 853 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = -yystack_[0].value.as < double > (); }
#line 4312 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 314: // const_sint: "unsigned integer value"
#line 855 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4318 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 315: // const_sint: '+' "unsigned integer value"
#line 856 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4324 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 316: // const_sint: '-' "unsigned integer value"
#line 857 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = -check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__); }
#line 4330 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 317: // const_uint: "unsigned integer value"
#line 859 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4336 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 318: // const_uint: '+' "unsigned integer value"
#line 860 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4342 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 319: // tuple: '(' opt_tuple_elems1 ')'
#line 863 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4348 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 320: // opt_tuple_elems1: tuple_elem
#line 866 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4354 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 321: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 867 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4360 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 322: // opt_tuple_elems1: %empty
#line 868 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4366 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 323: // opt_tuple_elems2: tuple_elem
#line 871 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4372 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 324: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 872 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4378 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 325: // opt_tuple_elems2: %empty
#line 873 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4384 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 326: // tuple_elem: expr
#line 876 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4390 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 327: // tuple_expr: tuple
#line 879 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__); }
#line 4396 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 328: // list: '[' opt_exprs ']'
#line 881 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4402 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 329: // list: "list" '(' opt_exprs ')'
#line 882 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4408 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 330: // list: "list" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 884 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4414 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 331: // list: "vector" '(' opt_exprs ')'
#line 885 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4420 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 332: // list: "vector" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 887 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4426 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 333: // set: "set" '(' opt_exprs ')'
#line 889 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4432 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 334: // set: "set" type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 891 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4438 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 335: // map: "map" '(' opt_map_elems ')'
#line 893 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 4444 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 336: // map: "map" type_param_begin type ',' type type_param_end '(' opt_map_elems ')'
#line 895 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as < hilti::Type > ()), std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 4450 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 337: // struct_: '[' struct_elems ']'
#line 897 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                             { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as < std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 4456 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 338: // struct_elems: struct_elems ',' struct_elem
#line 899 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field > ()); }
#line 4462 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 339: // struct_elems: struct_elem
#line 900 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field > ()) }; }
#line 4468 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 340: // struct_elem: '$' local_id '=' expr
#line 902 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 4474 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 341: // regexp: re_patterns opt_attributes
#line 904 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[1].value.as < std::vector<std::string> > ()), std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4480 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 342: // re_patterns: re_patterns '|' re_pattern_constant
#line 907 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 4486 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 343: // re_patterns: re_pattern_constant
#line 908 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 4492 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 344: // $@3: %empty
#line 911 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                    { driver->enablePatternMode(); }
#line 4498 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 345: // $@4: %empty
#line 911 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                             { driver->disablePatternMode(); }
#line 4504 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 346: // re_pattern_constant: '/' $@3 "regular expression value" $@4 '/'
#line 912 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 4510 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 347: // opt_map_elems: map_elems
#line 914 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as < std::vector<hilti::ctor::map::Element> > ()); }
#line 4516 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 348: // opt_map_elems: %empty
#line 915 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 4522 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 349: // map_elems: map_elems ',' map_elem
#line 917 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 4528 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 350: // map_elems: map_elem
#line 918 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 4534 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 351: // map_elem: expr ':' expr
#line 920 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as < hilti::Expression > (), yystack_[0].value.as < hilti::Expression > (), __loc__); }
#line 4540 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 352: // attribute: "attribute"
#line 923 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4546 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 353: // attribute: "attribute" '=' expr
#line 924 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4552 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 354: // opt_attributes: opt_attributes attribute
#line 927 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), yystack_[0].value.as < hilti::Attribute > ()); }
#line 4558 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 355: // opt_attributes: %empty
#line 928 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = {}; }
#line 4564 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"
    break;


#line 4568 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -598;

  const short Parser::yytable_ninf_ = -323;

  const short
  Parser::yypact_[] =
  {
     -38,    71,   107,  -598,     9,  -598,  -598,  1656,  -598,   -53,
    -598,  -598,   -12,  -598,  -598,  -598,  -598,  3236,  3236,  3236,
      56,    74,    65,  -598,    94,    -4,    65,  3236,    97,   103,
     125,   132,    71,  -598,    82,   140,    10,  4634,    63,   221,
    3236,   145,  1814,   152,  3236,   157,  -598,  -598,  -598,  2762,
      99,   160,   175,   178,  2920,  2130,   180,   182,    65,  3236,
     124,   183,   199,  -598,  3236,  3236,  3236,   283,    31,  -598,
    3236,  3236,  1022,  -598,  -598,  -598,  1182,  1340,  -598,  -598,
    -598,  -598,  -598,     8,  -598,  -598,   205,  -598,  -598,  -598,
     112,   326,     4,    55,   200,   209,   201,   194,   154,    78,
    -598,   230,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,   212,  -598,  3236,  -598,   351,   229,   -79,
     -60,  3236,  -598,  -598,  4748,  -598,    -8,  4748,   234,  3236,
     362,    71,  3078,   -32,   361,    12,  3236,  4748,  -598,  -598,
     375,  -598,  -598,  -598,   -10,  -598,   235,  -598,    65,  -598,
      65,    65,   237,    65,    65,  -598,  -598,    65,  -598,    65,
    -598,    65,    65,  -598,  -598,   239,  -598,    65,    65,  -598,
      65,    65,  -598,    65,    65,   242,  -598,   320,  -598,  -598,
    -598,    71,  -598,  -598,  -598,  -598,  -598,  3236,  4748,  -598,
    -598,  -598,  4748,  -598,  3236,  -598,   243,   240,   244,    10,
      63,   128,   252,    99,   254,   257,   253,   124,  3334,   259,
    -598,  3236,  -598,  3236,  -598,   261,  3236,  4748,   393,  3078,
      14,  -598,   263,  2288,  -598,  -598,     1,   371,  -598,  -598,
    1972,   395,  4748,   271,  3236,  4748,  3078,  -598,   270,   274,
     277,  -598,   264,  -598,  -598,  -598,  -598,  3236,  -598,   415,
    -598,  -598,    71,   372,   273,   292,   -67,  -598,  4748,   221,
    4862,   221,   323,  -598,  3236,  3236,  3236,  3236,  3236,  3236,
    3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,
    3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,    48,
     102,  -598,   102,  -598,    48,  3236,    48,  3236,   281,   435,
     302,  -598,  -598,  -598,  3236,  -598,  3236,   303,   297,   307,
     221,   297,  -598,   306,   308,   380,  4976,   -33,   309,  -598,
    -598,   305,  -598,   317,   319,   311,   327,  -598,   330,   297,
     328,    71,   314,  4748,    17,  4748,  4748,   453,  3488,  3602,
    4748,  3716,  4748,  3830,   -20,   331,  3944,    24,    34,  4058,
    4748,  4172,  4286,  3236,   324,  -598,    20,   318,   332,   335,
    -598,   339,    88,  -598,   333,   459,  3488,  3602,  3830,   463,
    4058,  3236,   343,   344,  -598,   346,   297,   347,   348,   350,
    -598,   321,   473,   352,   353,  -598,   355,  2446,  -598,  2604,
     462,  -598,   356,   357,   354,   297,  -598,   358,   297,   -21,
     364,  -598,  -598,  3236,  -598,   366,  -598,   373,    71,  -598,
    3236,   336,  -598,   374,   323,  -598,  4748,   334,   376,   323,
    -598,  4748,   377,  -598,  -598,   489,  -598,  -598,  -598,   359,
       5,   117,   121,   365,   368,   370,   378,   379,   360,   231,
     190,   202,   104,   163,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,   322,   325,  -598,   382,   381,   383,  -598,   386,  -598,
    -598,   388,   390,  -598,  -598,   385,  -598,  4748,   392,  -598,
    -598,  3236,   518,    71,  3236,  2130,  2130,   391,   516,   394,
    -598,  -598,  -598,  -598,  -598,   397,  3236,   401,    44,  -598,
     387,  -598,   297,   297,   297,   297,   400,   297,   297,   297,
     402,   297,   297,   297,   297,   297,   297,  -598,  -598,   404,
     405,  -598,  4748,  -598,   297,   403,  -598,    46,  -598,   297,
     297,  4400,   297,   297,   297,   297,   297,   297,   297,   409,
     -20,  3236,  3236,   410,  3236,  -598,  3236,  4748,  -598,  -598,
    -598,  -598,  -598,   411,  -598,   297,   408,   297,   297,   412,
    -598,  3236,  -598,   416,  -598,   407,   421,  -598,  -598,  -598,
    -598,  -598,  1498,  -598,  -598,  -598,  -598,   418,   419,  -598,
     420,  3236,  2130,  2130,  -598,  -598,   422,   398,  3236,   494,
    -598,  -598,  3236,   425,    88,   427,  3236,    37,    88,  4748,
    3236,  -598,  3236,  -598,  3236,  -598,  -598,  3236,    88,  3236,
     426,   430,   431,   429,   524,   525,  -598,  -598,    -9,  3236,
     437,   561,  -598,    71,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,  4748,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,    11,    71,  4517,  -598,  4748,  4748,  -598,  -598,  -598,
      71,   440,   436,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,   438,   441,   442,  -598,  -598,  -598,   297,   -20,
     444,  4748,   447,   448,  -598,   450,  3236,    80,    80,    71,
     579,  3236,  -598,  -598,  3236,   452,   546,   549,  3236,  -598,
    -598,  3236,   461,  3236,   465,  3236,   467,  3236,   475,   472,
    -598,  -598,   474,  -598,   477,   479,   480,  2130,  3236,  3236,
    2130,  2130,  -598,  -598,  -598,   481,   589,   484,  -598,  -598,
    -598,   297,  -598,   485,  -598,   191,    71,  -598,  -598,  -598,
    -598,  -598,  4748,   598,  -598,  -598,   486,   487,   297,  -598,
     490,  3236,   491,   493,    80,  -598,   495,   497,   498,   499,
    2130,  -598,  -598,  -598,   -57,  -598,   488,   -20,   496,  -598,
     502,  -598,   -20,     2,  -598,  -598,   -20,  -598,  -598,  -598,
    -598,   594,  -598,  -598,   503,  -598,  -598,  3236,  -598,  4748,
    -598,   638,  -598,  4748,  3236,  -598,   505,  -598,   213,  2130,
    -598,  -598,  -598,  2130,  -598,  -598,   599,  3236,  -598,  -598,
     507,  -598,  -598,   509,  -598,   513,  -598,  -598,  -598,   638,
      41,    30,  -598,   515,    36,  2130,  -598,  -598,  -598,   500,
    -598,  -598,  -598,   506,  -598,  -598,  -598,  -598,  -598,    36,
      36,   638,   -20,  -598,  -598,   519,  -598,    13,  -598,  -598
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,     0,     3,     0,     1,    11,    45,     5,     0,
     285,   284,   291,   293,   311,   287,   283,     0,     0,     0,
       0,     0,     0,   290,     0,    45,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,    56,     0,    61,
       0,     0,    56,     0,     0,     0,    44,    42,    41,     0,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     2,   322,     0,     0,     0,     0,   344,
       0,     0,   204,     4,   280,     9,    12,    13,   118,    14,
      15,    16,    17,     0,    10,    81,     0,   121,   202,   207,
     214,   216,   218,   221,   226,   228,   230,   232,   235,   238,
     243,   250,   261,   272,   278,   273,   286,   310,   305,   308,
     306,   309,   307,   355,   343,     0,    39,     0,     0,     0,
       0,     0,    87,   171,    56,    88,    56,    56,     0,     0,
       0,     0,     0,     0,     0,     0,   204,    56,   123,   122,
       0,   125,   126,   131,     0,   127,   160,    58,     0,   128,
       0,     0,     0,     0,     0,    57,   129,     0,   130,     0,
     132,     0,     0,   133,   134,   183,   135,     0,     0,   355,
       0,     0,   136,     0,     0,     4,   170,     0,    55,   173,
     168,     0,   169,   163,   164,   165,   166,   348,    56,    59,
      60,    35,    56,   248,     0,   124,   127,     0,   128,     0,
       0,     0,   130,     0,   133,   135,     0,     0,   170,   268,
     267,     0,   249,     0,    82,     0,   204,    56,     0,     0,
       0,    85,     0,    45,   119,   120,     0,     0,    73,    74,
       0,     0,    56,     0,   204,    56,     0,    86,   326,     0,
     320,   245,     0,   312,   288,   313,   289,     0,   275,     0,
     244,   246,     0,   206,     0,   203,     0,   339,    56,    61,
      56,    61,     0,    80,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   258,     0,   259,     0,   204,     0,     0,     0,   341,
       0,   292,   103,    99,     0,   101,     0,     0,     0,     0,
      61,     0,   104,     0,     0,     0,    56,     0,     0,     6,
      37,     0,   314,     0,     0,     0,     0,   206,     0,     0,
       0,     0,     0,    56,     0,    56,    56,     0,    56,    56,
      56,    56,    56,    56,    70,     0,    56,     0,     0,    56,
      56,    56,    56,     0,     0,   167,    32,     0,     0,   347,
     350,     0,     0,    67,     0,   171,    56,    56,    56,   171,
      56,   204,     0,     0,    83,     0,     0,     0,     0,     0,
     317,     0,     0,     0,     0,    84,     0,    45,    79,    45,
      98,   115,     0,     0,     0,     0,   105,     0,     0,     0,
       0,   279,   319,   325,   247,     0,   345,     0,     0,   328,
       0,     0,   337,   170,     0,    33,    56,     0,   170,     0,
      34,    56,     0,   212,   209,   215,   210,   211,   208,     0,
     217,   219,   220,   224,   225,   222,   223,   227,   229,   231,
     233,   234,   236,   237,   242,   240,   239,   241,   282,   281,
     255,   256,   257,   260,     0,   252,     0,   342,   352,   354,
      40,     0,     0,   262,   172,     0,    36,    56,     0,   264,
     299,     0,     0,     0,     0,    45,    45,     0,     0,     0,
     315,   316,   294,   295,   329,     0,     0,   200,     0,   199,
       0,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    68,    69,     0,
      62,    65,    56,   185,     0,     4,   179,     0,   178,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
      70,     0,   204,     0,     0,   335,     0,    56,    49,    50,
      47,    46,    48,     0,   265,     0,     0,     0,     0,     0,
     300,     0,   333,     0,   298,     0,     0,   318,   296,   297,
      75,    78,    56,   117,   114,   271,   270,     0,     0,   331,
       0,     0,    45,    45,   326,   321,   323,     0,     0,     0,
     205,   338,     0,     0,     0,     0,     0,    32,     0,    56,
       0,   251,   204,   254,     0,   100,   102,     0,     0,   204,
       0,     0,     0,     0,   107,   107,    38,     7,     0,   322,
       0,     0,   195,   198,   196,   137,   138,   144,   145,   162,
     152,   153,   158,    56,   141,   147,   146,   142,   156,   157,
     182,    70,     0,    56,   175,    56,    56,   176,   139,   140,
       0,     0,   190,   193,   154,   155,   143,   149,   148,   151,
     150,    21,     0,     0,     0,    22,   351,   349,     0,    70,
     153,    56,   157,   155,   269,     0,   322,   109,   109,     0,
       0,   322,   327,   266,   322,     0,   107,   107,   325,   346,
     340,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     355,   213,     0,   353,     0,     0,     0,    45,     0,     0,
      45,    45,    90,    89,     8,     0,     0,     0,    24,   201,
     197,     0,    64,    72,   181,    61,     0,   184,   180,   177,
     355,   189,    56,     0,    23,    31,     0,     0,     0,   274,
       0,     0,     0,     0,   108,   111,     0,     0,     0,     0,
      45,    94,    93,   324,     0,    19,     0,    70,     0,    27,
       0,    28,    70,     0,   253,   263,    70,   301,    95,    26,
      25,   107,   106,   303,     0,   330,   159,     0,   355,    56,
     355,   194,   192,    56,   348,   355,   159,   334,     0,    45,
      97,   110,    96,    45,   302,   332,   107,     0,   276,    20,
       0,    30,    29,     0,    18,     0,    91,   304,    71,    66,
       0,     0,   174,     0,     0,    45,   113,   116,    92,     0,
     355,   355,   355,     0,   186,   336,    52,   112,   277,     0,
       0,    54,    70,    51,    53,     0,   355,     0,   187,   188
  };

  const short
  Parser::yypgoto_[] =
  {
    -598,  -598,    -1,    89,  -598,  -598,  -598,  -598,  -598,   652,
     656,  -598,  -133,  -598,    77,  -598,  -598,  -598,    47,  -135,
    -429,  -598,  -598,  -598,  -598,   540,    38,  -254,  -509,  -598,
      42,  -406,  -598,  -598,  -386,  -547,  -598,  -598,    -3,  -597,
       7,  -598,   -58,  -598,   284,  -598,  -598,  -598,   449,   482,
     815,   262,  -598,  -598,  -598,  -598,    45,  -598,  -598,  -598,
    -598,  -598,  -598,  -598,   -55,  -598,  -598,    69,     6,  -134,
     -48,  -598,  -251,  -598,   424,   414,    92,    15,   417,   413,
     406,    87,    90,    -2,   -84,  -598,  -598,   620,   -73,  -598,
     -86,  -598,  -598,   126,  -525,    18,  -402,  -598,  -598,  -598,
    -598,  -598,  -598,   286,  -598,  -598,   423,  -598,  -598,   -76,
    -598,   164,  -598,  -157
  };

  const short
  Parser::yydefgoto_[] =
  {
      -1,     2,    73,    74,   477,   478,   704,     7,    75,   224,
     225,    78,   317,    79,   533,    80,    81,    82,   226,   542,
     543,   415,   191,   420,   309,   177,   178,   192,   509,   510,
     511,   362,   512,   768,   227,   228,   386,   387,   229,   702,
     733,   734,   735,   390,   391,    85,    86,   179,   180,   363,
     334,   465,   355,   182,   183,   517,   518,   184,   345,   633,
     717,   185,   641,   642,   643,   186,   488,   489,    87,   254,
     255,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   450,   105,
     106,   326,   384,   107,   239,   575,   240,   673,   108,   109,
     110,   111,   256,   257,   112,   113,   114,   249,   577,   358,
     359,   360,   459,   299
  };

  const short
  Parser::yytable_[] =
  {
       4,   576,   328,   563,    84,   416,   705,   421,   703,   458,
     584,   787,   348,   423,   424,   588,   426,   427,   428,   429,
     458,   652,   507,   118,   119,   120,    14,   322,    14,   380,
     319,   133,   492,   128,     3,     8,   175,   458,   193,   519,
     258,   458,   212,   458,     3,   245,   246,   258,   210,   325,
       1,     3,   508,   507,    83,   215,   467,   272,   272,   147,
     222,   598,   303,   241,   242,   233,   304,    33,   250,   251,
     238,   259,   126,   260,     3,   261,   155,   411,   253,   741,
     742,   305,   375,   508,   707,   306,   378,   115,   116,   604,
     605,     3,   538,   539,   412,   273,   273,    46,    47,    48,
     397,   540,   448,   399,   788,     3,     8,     5,   474,   320,
     475,    10,    11,   731,    12,    13,    14,    15,    16,   274,
     571,   300,   572,   -63,   732,   262,   176,   307,   331,    20,
     315,   208,   262,   275,   383,   313,    22,   332,   318,   330,
      23,   730,   327,   794,   117,   706,    26,     6,   540,   739,
     727,   223,   136,    28,   828,   684,    29,   123,   264,   689,
     531,   454,   532,   493,   796,   323,   324,   381,   382,   695,
     520,   814,   521,   247,   223,    34,    35,   687,   285,   532,
     356,   274,    36,   612,    38,   274,   676,   677,   613,   808,
     636,    41,    42,   357,   464,   275,    43,   265,   121,   275,
     364,    45,   276,   277,   285,   187,   451,   266,   452,   267,
     123,    50,   123,   176,    51,   122,   176,   372,    53,   373,
     388,   453,   327,   455,   286,   379,   176,    56,    57,   134,
      58,   268,    60,   287,   288,   125,   393,   549,   790,   129,
     327,   216,   400,   793,    64,   130,   123,   795,   189,   190,
     286,   407,   269,   405,   -55,    67,    68,   816,    69,   287,
     288,   270,    72,   285,   276,   277,   234,   131,   276,   277,
     211,   123,   823,   824,   132,   123,   576,   176,   189,   190,
     829,   176,   135,   444,   445,   446,   447,   194,   449,   433,
     434,   435,   436,   449,   211,   449,   289,   243,   244,   213,
     290,   327,   218,   456,   281,   282,   176,   283,   284,   286,
     461,   758,   462,   825,   761,   762,   291,   219,   287,   288,
     220,   176,   230,   292,   176,   236,     3,     8,   293,   231,
     487,   243,   480,   245,   481,   243,   557,     3,     8,   691,
     237,   281,   282,   283,   284,   515,   263,   413,   271,   418,
     278,   422,   294,   280,   786,   283,   284,   410,   805,   529,
     279,   541,   298,   800,   431,   432,   301,   802,   440,   441,
     302,   314,   295,   442,   443,   312,   321,   327,     3,   337,
     333,   344,   353,   354,   561,   130,   135,   365,   289,   296,
     297,   289,   290,   806,   213,   290,   218,   807,   654,   220,
     369,   371,   374,   377,   385,   176,   389,   579,   291,   574,
     394,   291,   396,   401,   404,   292,   580,   402,   292,   817,
     293,   403,   176,   293,   176,   176,   406,   176,   176,   176,
     176,   176,   176,   408,   409,   176,   410,    69,   176,   176,
     176,   176,   458,   460,   294,   464,   463,   294,   466,   469,
     471,   470,   476,   479,   482,   176,   176,   176,   692,   176,
     490,   769,   496,   534,   295,   696,   530,   295,   486,   513,
     483,   601,   602,   484,   321,   535,   544,   600,   394,   536,
     603,   296,   297,   537,   296,   297,   550,   245,   551,   552,
     554,   555,   610,   556,   560,   558,   559,   389,   252,   565,
     566,   569,   567,   583,   590,   176,   585,   573,   587,   401,
     176,   271,   280,   578,   582,   278,   586,   589,   278,   181,
     278,     3,   607,   592,   209,   591,   594,   597,   278,   595,
     279,   596,   606,   753,   599,   614,   608,   653,   327,   609,
     656,   611,   357,   619,   593,   667,   623,   630,   635,   631,
     651,   655,   661,   659,   679,   664,   176,   665,   666,   668,
     670,   671,   674,   771,   681,   683,   678,   685,   238,   697,
     698,   699,   700,   468,   701,   701,   709,   675,   708,   721,
     722,   723,   724,   541,   680,   725,   609,   541,   682,   666,
     674,   485,   686,   729,   738,   740,   701,   541,   327,   701,
     693,   176,   745,   694,   764,   327,   308,   747,   749,   311,
     176,   799,   487,   801,   752,   574,   751,   754,   804,   329,
     755,   756,   773,   757,   763,   767,   176,   765,   774,   789,
     775,   713,   780,   777,   782,   515,   779,   791,   553,   720,
     783,   784,   785,   792,   701,   458,   797,   774,   822,   701,
     810,   208,   811,   819,   820,   821,   812,   568,   815,    76,
     570,   818,   826,    77,   688,   813,   310,   772,   737,   827,
     361,   715,   574,   712,   564,   736,   781,   574,   176,   392,
     574,   719,   710,   778,   574,   430,   439,   744,   248,   746,
     425,   748,   438,   750,   672,   437,   743,   581,   803,   376,
     657,     0,     0,     0,   759,   760,     0,     0,     0,     0,
       0,     0,   176,     0,   395,   770,     0,   398,     0,     0,
       0,   457,   176,     0,   176,   176,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   327,     0,     0,
     414,     0,   419,     0,     0,     0,     0,     0,     0,     0,
     176,     0,     0,     0,   615,   616,   617,   618,     0,   620,
     621,   622,     0,   624,   625,   626,   627,   628,   629,     0,
       0,     0,     0,   798,     0,     0,   634,     0,     0,   637,
     357,   638,   639,     0,   644,   645,   646,   647,   648,   649,
     650,     0,     0,   809,     0,     0,     0,     0,   473,   541,
       0,     0,     0,     0,     0,     0,     0,   660,     0,   662,
     663,   176,     0,     0,     0,   491,     0,   494,   495,     0,
     498,   500,   501,   503,   504,   506,     0,     0,   516,     0,
       0,   523,   524,   526,   528,     0,     0,   124,     0,     0,
       0,   127,     0,     0,     0,     0,     0,     0,   545,   546,
     547,   137,   548,   188,     0,     0,     0,     0,   176,     0,
       0,     0,   176,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,   232,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     726,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   335,   336,     0,   338,   339,
       0,     0,   340,   766,   341,     0,   342,   343,     0,     0,
       0,     0,   346,   347,     0,   349,   350,     0,   351,   352,
     776,     0,     0,     0,   632,     0,     0,     0,     0,     0,
       0,     0,     0,   640,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   366,   367,   340,     0,   368,   658,
       0,   347,   370,     0,     0,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,   669,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,   690,     0,    28,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,     0,     0,     0,
       0,     0,    36,     0,    38,   711,     0,     0,    40,     0,
       0,    41,    42,     0,     0,   716,    43,   718,   516,     0,
      44,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,    51,     0,     0,     0,    53,     0,
       0,     0,     0,   728,     0,     0,     0,    56,    57,     0,
      58,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     0,   252,   -12,   -12,     0,     0,     0,
     -12,   -12,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,     0,     0,   640,     0,     0,     0,     0,   -12,
       0,   -12,     0,     0,     0,     0,   -12,     0,     0,     0,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,     0,     0,
       0,     0,     0,   -12,     0,     0,   -12,     0,     0,     0,
       0,     0,     0,   -12,     0,   -12,     0,   -12,     0,   -12,
     -12,   -12,     0,   -12,     0,   -12,   -12,     0,     0,     0,
       0,     0,   -12,   -12,   -12,     0,   -12,     0,   -12,     0,
       0,   -12,   -12,     0,     0,     0,   -12,     0,     0,     0,
     -12,   -12,     0,   -12,   -12,   -12,     0,     0,     0,   -12,
       0,   -12,     0,     0,   -12,     0,     0,   -12,   -12,     0,
       0,     0,   -12,   -12,     0,     0,   -12,   -12,   -12,     0,
     -12,   -12,   -12,     0,     0,   -12,     0,     0,     0,   -12,
       0,   -12,     0,     0,   -12,     0,     0,     0,   -12,     0,
       0,     0,   -12,     0,     0,   -12,   -12,     0,   -12,   -12,
     -12,     0,   -12,   -13,   -13,     0,     0,     0,   -13,   -13,
     -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,     0,     0,     0,   -13,     0,   -13,
       0,     0,     0,     0,   -13,     0,     0,     0,   -13,   -13,
     -13,     0,     0,   -13,   -13,   -13,     0,     0,     0,     0,
       0,   -13,     0,     0,   -13,     0,     0,     0,     0,     0,
       0,   -13,     0,   -13,     0,   -13,     0,   -13,   -13,   -13,
       0,   -13,     0,   -13,   -13,     0,     0,     0,     0,     0,
     -13,   -13,   -13,     0,   -13,     0,   -13,     0,     0,   -13,
     -13,     0,     0,     0,   -13,     0,     0,     0,   -13,   -13,
       0,   -13,   -13,   -13,     0,     0,     0,   -13,     0,   -13,
       0,     0,   -13,     0,     0,   -13,   -13,     0,     0,     0,
     -13,   -13,     0,     0,   -13,   -13,   -13,     0,   -13,   -13,
     -13,     0,     0,   -13,     0,     0,     0,   -13,     0,   -13,
       0,     0,   -13,     0,     0,     0,   -13,     0,     0,     0,
     -13,     0,     0,   -13,   -13,     0,   -13,   -13,   -13,     0,
     -13,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,     0,     0,     0,   138,     0,
       0,   139,     0,   195,     0,    20,   141,     0,   142,     0,
       0,     0,    22,     0,     0,     0,    23,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,   143,     0,    28,
     144,     0,   196,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   197,   198,     0,   150,   151,     0,   152,   199,     0,
     200,     0,   155,     0,    40,     0,     0,    41,    42,     0,
     156,     0,   201,     0,     0,     0,    44,   202,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   203,     0,     0,
     204,   164,   165,     0,   205,     0,     0,     0,     0,     0,
       0,   167,     0,    56,   206,   169,    58,     0,   207,   171,
     172,     0,     0,   173,   174,     0,     0,     0,     0,     0,
      64,  -322,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     9,    10,    11,     0,    12,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,    24,     0,     0,    25,
      26,    27,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,    31,    32,     0,    33,     0,    34,
      35,     0,     0,     0,     0,     0,    36,    37,    38,     0,
      39,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,    46,    47,    48,
       0,     0,     0,    49,     0,    50,     0,     0,    51,     0,
       0,    52,    53,     0,     0,     0,    54,    55,     0,     0,
       0,    56,    57,     0,    58,    59,    60,     0,     0,    61,
       0,     0,     0,    62,     0,    63,     0,     0,    64,     0,
       0,     0,    65,     0,     0,     0,    66,     0,     0,    67,
      68,     0,    69,    70,    71,     0,    72,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,     0,     0,     0,   138,     0,     0,   139,     0,   195,
       0,    20,   141,     0,   142,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,   143,     0,    28,   144,     0,   196,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   197,   198,     0,
     150,   151,     0,   152,   199,     0,   200,     0,   155,     0,
      40,     0,     0,    41,    42,     0,   156,     0,   201,     0,
       0,     0,    44,   202,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   203,     0,     0,   204,   164,   165,     0,
     205,     0,     0,     0,     0,     0,     0,   167,     0,    56,
     206,   169,    58,     0,   207,   171,   172,     0,     0,   173,
     174,     0,     0,     0,     0,     0,    64,     0,     0,     0,
      65,     0,     0,     0,    66,     0,     0,    67,    68,     0,
      69,    70,    71,     0,    72,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,   138,     0,     0,   139,     0,   195,     0,    20,
     141,     0,   142,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,   143,     0,    28,   144,     0,   196,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,     0,   150,   151,
       0,   152,   199,     0,   200,     0,     0,     0,    40,     0,
       0,    41,    42,     0,   156,     0,   201,     0,     0,     0,
      44,   202,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   203,     0,     0,   204,   164,   165,     0,   205,     0,
       0,     0,     0,     0,     0,   167,     0,    56,   206,   169,
      58,     0,   207,   171,   172,     0,     0,   173,   174,     0,
       0,     0,     0,     0,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     3,     8,     0,     0,     0,     0,    10,
      11,     0,    12,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,    20,     0,    21,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
      24,     0,     0,     0,    26,    27,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,    31,     0,
       0,    33,     0,    34,    35,     0,     0,     0,     0,     0,
      36,    37,    38,     0,     0,     0,    40,     0,     0,    41,
      42,     0,     0,     0,    43,     0,     0,     0,    44,    45,
       0,    46,    47,    48,     0,     0,     0,    49,     0,    50,
       0,     0,    51,     0,     0,    52,    53,     0,     0,     0,
      54,    55,     0,     0,     0,    56,    57,     0,    58,    59,
      60,     0,     0,    61,     0,     0,     0,    62,   223,     0,
       0,     0,    64,     0,     0,     0,    65,     0,     0,     0,
      66,     0,     0,    67,    68,     0,    69,    70,    71,     0,
      72,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,    22,     0,     0,     0,    23,     0,    24,     0,
       0,     0,    26,    27,     0,     0,     0,     0,     0,    28,
       0,     0,    29,     0,     0,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,    31,     0,     0,    33,
       0,    34,    35,     0,     0,     0,     0,     0,    36,    37,
      38,     0,     0,     0,    40,     0,     0,    41,    42,     0,
       0,     0,    43,     0,     0,     0,    44,    45,     0,    46,
      47,    48,     0,     0,     0,    49,     0,    50,     0,     0,
      51,     0,     0,    52,    53,     0,     0,     0,    54,    55,
       0,     0,     0,    56,    57,     0,    58,    59,    60,     0,
       0,    61,     0,     0,     0,    62,     0,   -77,     0,     0,
      64,     0,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     0,    10,    11,     0,    12,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,    24,     0,     0,     0,
      26,    27,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,    31,     0,     0,    33,     0,    34,
      35,     0,     0,     0,     0,     0,    36,    37,    38,     0,
       0,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,    46,    47,    48,
       0,     0,     0,    49,     0,    50,     0,     0,    51,     0,
       0,    52,    53,     0,     0,     0,    54,    55,     0,     0,
       0,    56,    57,     0,    58,    59,    60,     0,     0,    61,
       0,     0,     0,    62,     0,   -76,     0,     0,    64,     0,
       0,     0,    65,     0,     0,     0,    66,     0,     0,    67,
      68,     0,    69,    70,    71,     0,    72,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,     0,
       0,    20,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,     0,     0,     0,     0,    28,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,     0,    31,     0,     0,    33,     0,    34,    35,     0,
       0,     0,     0,     0,    36,    37,    38,     0,     0,     0,
      40,     0,     0,    41,    42,     0,     0,     0,    43,     0,
       0,     0,    44,    45,     0,    46,    47,    48,     0,     0,
       0,    49,     0,    50,     0,     0,    51,     0,     0,    52,
      53,     0,     0,     0,    54,    55,     0,     0,     0,    56,
      57,     0,    58,    59,    60,     0,     0,    61,     0,     0,
       0,    62,   223,     0,     0,     0,   562,     0,     0,     0,
      65,     0,     0,     0,    66,     0,     0,    67,    68,     0,
      69,    70,    71,     0,    72,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,    28,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,     0,     0,     0,
       0,     0,    36,     0,    38,     0,     0,     0,    40,     0,
       0,    41,    42,     0,     0,     0,    43,     0,     0,     0,
      44,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,    51,     0,     0,     0,    53,     0,
       0,     0,     0,     0,     0,     0,     0,    56,    57,     0,
      58,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     3,     8,     0,     0,     0,     0,    10,
      11,     0,    12,    13,    14,    15,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    34,    35,     0,     0,     0,     0,     0,
      36,     0,    38,     0,     0,     0,    40,     0,     0,    41,
      42,     0,     0,     0,    43,     0,     0,     0,    44,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
       0,     0,    51,     0,     0,     0,    53,     0,     0,     0,
       0,     0,     0,     0,     0,    56,    57,     0,    58,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   221,    64,     0,     0,     0,    65,     0,     0,     0,
      66,     0,     0,    67,    68,     0,    69,    70,    71,     0,
      72,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,    23,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,    28,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    34,    35,     0,     0,     0,     0,     0,    36,   316,
      38,     0,     0,     0,    40,     0,     0,    41,    42,     0,
       0,     0,    43,     0,     0,     0,    44,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,     0,     0,
      51,     0,     0,     0,    53,     0,     0,     0,     0,     0,
       0,     0,     0,    56,    57,     0,    58,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      64,     0,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     0,    10,    11,     0,    12,    13,
      14,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    34,
      35,     0,     0,     0,     0,     0,    36,     0,    38,     0,
       0,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,     0,     0,     0,
       0,  -170,     0,     0,     0,    50,     0,     0,    51,     0,
       0,     0,    53,     0,     0,     0,  -170,     0,     0,     0,
       0,    56,    57,     0,    58,     0,    60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    64,     0,
    -170,     0,    65,     0,     0,     0,    66,  -170,     0,    67,
      68,     0,    69,    70,    71,  -170,    72,     0,  -170,     0,
    -170,     0,  -170,     0,  -170,     0,     0,     0,     0,     0,
       0,     0,  -170,     0,     0,     0,     0,     0,     0,  -170,
    -170,     0,     0,     0,     0,  -170,     0,  -170,     0,  -170,
       0,  -170,  -170,     0,  -170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -170,  -170,     0,     0,     0,     0,
       0,     0,     0,  -170,     0,     0,  -170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,     3,     8,  -170,  -170,  -170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   138,     0,
       0,   139,     0,   195,     0,     0,   141,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   195,     0,     0,
     141,     0,   142,     0,   497,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   195,     0,     0,   141,     0,   142,     0,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     3,     8,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
     138,   173,   174,   139,     0,   195,     0,     0,   141,     0,
     142,     0,   502,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,   144,     0,   145,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,   148,   149,     0,   150,   151,     0,   152,
     153,     0,   154,     0,   155,     0,     0,     0,     0,     0,
       0,     0,   156,     0,   157,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,   160,   161,     0,     0,   162,
       0,     0,   163,   164,   165,     0,   166,     3,     8,     0,
       0,     0,     0,   167,     0,     0,   168,   169,     0,     0,
     170,   171,   172,     0,   138,   173,   174,   139,     0,   195,
       0,     0,   141,     0,   142,     0,   505,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,   144,     0,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   148,   149,     0,
     150,   151,     0,   152,   153,     0,   154,     0,   155,     0,
       0,     0,     0,     0,     0,     0,   156,     0,   157,     0,
       0,     0,     0,   158,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   162,     0,     0,   163,   164,   165,     0,
     166,     3,     8,     0,     0,     0,     0,   167,     0,     0,
     168,   169,     0,     0,   170,   171,   172,     0,   138,   173,
     174,   139,     0,   195,     0,     0,   141,     0,   142,     0,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   195,     0,     0,
     141,     0,   142,     0,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   195,     0,     0,   141,     0,   142,     0,   525,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     3,     8,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
     138,   173,   174,   139,     0,   195,     0,     0,   141,     0,
     142,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,   144,     0,   145,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,   148,   149,     0,   150,   151,     0,   152,
     153,     0,   154,     0,   155,     0,     0,     0,     0,     0,
       0,     0,   156,     0,   157,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,   160,   161,     0,     0,   162,
       0,     0,   163,   164,   165,     0,   166,     0,     0,     0,
       3,     8,     0,   167,     0,     0,   168,   169,     0,     0,
     170,   171,   172,     0,     0,   173,   174,   138,     0,  -191,
     139,     0,   195,     0,     0,   141,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,     0,     0,   144,
       0,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   147,     0,     0,     0,     0,     0,
     148,   149,     0,   150,   151,     0,   152,   153,     0,   154,
       0,   155,     0,     0,     0,     0,     0,     0,     0,   156,
       0,   157,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   159,   160,   161,     0,     0,   162,     0,     0,   163,
     164,   165,     0,   166,     0,     0,     0,     3,     8,     0,
     167,     0,     0,   168,   169,     0,     0,   170,   171,   172,
       0,     0,   173,   174,   138,     0,   714,   139,     0,   140,
       0,     0,   141,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,   144,     0,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   148,   149,     0,
     150,   151,     0,   152,   153,     0,   154,     0,   155,     0,
       0,     0,     0,     0,     0,     0,   156,     0,   157,     0,
       0,     0,     0,   158,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   162,     0,     0,   163,   164,   165,     0,
     166,     3,     8,     0,     0,     0,     0,   167,     0,     0,
     168,   169,     0,     0,   170,   171,   172,     0,   138,   173,
     174,   139,     0,   195,     0,     0,   141,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   417,     0,     0,
     141,     0,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   472,     0,     0,   141,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     0,     0,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
       0,   173,   174
  };

  const short
  Parser::yycheck_[] =
  {
       1,   403,   136,   389,     7,   259,    15,   261,   605,     7,
     416,    68,   169,   264,   265,   421,   267,   268,   269,   270,
       7,   530,    42,    17,    18,    19,    14,    15,    14,    15,
      62,    32,    15,    27,     3,     4,    37,     7,    40,    15,
      39,     7,    44,     7,     3,    14,    15,    39,    42,   135,
      88,     3,    72,    42,     7,    49,   310,    53,    53,    67,
      54,   467,   141,    65,    66,    59,   145,    71,    70,    71,
      64,    63,    25,    65,     3,    67,    84,   144,    72,   676,
     677,   141,   216,    72,   609,   145,   219,   140,   141,   475,
     476,     3,     4,     5,   161,    91,    91,   101,   102,   103,
     234,    60,    54,   236,   161,     3,     4,     0,   141,   141,
     143,     9,    10,    33,    12,    13,    14,    15,    16,    64,
     141,   115,   143,   143,    44,   124,    37,   121,   138,    27,
     131,    42,   124,    78,   220,   129,    34,   147,   132,   140,
      38,   666,   136,   141,   156,   154,    44,   138,    60,   674,
     659,   138,   142,    51,   141,   584,    54,   147,    46,   588,
     140,   295,   142,   146,   761,   153,   154,   153,   154,   598,
     146,   141,   138,   142,   138,    73,    74,   140,   100,   142,
     181,    64,    80,   139,    82,    64,   572,   573,   144,   786,
     144,    89,    90,   187,   148,    78,    94,    85,   142,    78,
     194,    99,   147,   148,   100,   142,   290,    95,   292,    97,
     147,   109,   147,   124,   112,   141,   127,   211,   116,   213,
     223,   294,   216,   296,   146,   219,   137,   125,   126,   147,
     128,   119,   130,   155,   156,   141,   230,   371,   747,   142,
     234,   142,   236,   752,   142,   142,   147,   756,    57,    58,
     146,   252,   140,   247,    63,   153,   154,   804,   156,   155,
     156,   149,   160,   100,   147,   148,   142,   142,   147,   148,
     142,   147,   819,   820,   142,   147,   678,   188,    57,    58,
     827,   192,   142,   285,   286,   287,   288,   142,   289,   274,
     275,   276,   277,   294,   142,   296,    66,    14,    15,   142,
      70,   295,   142,   297,   110,   111,   217,   153,   154,   146,
     304,   697,   306,   822,   700,   701,    86,   142,   155,   156,
     142,   232,   142,    93,   235,   142,     3,     4,    98,   147,
     331,    14,    15,    14,    15,    14,    15,     3,     4,   590,
     141,   110,   111,   153,   154,   346,   141,   258,    22,   260,
     150,   262,   122,   152,   740,   153,   154,   144,   145,   353,
     151,   362,   150,   769,   272,   273,    15,   773,   281,   282,
     141,     9,   142,   283,   284,   141,    15,   371,     3,   142,
     145,   142,   140,    63,   387,   142,   142,   147,    66,   159,
     160,    66,    70,   779,   142,    70,   142,   783,   532,   142,
     147,   142,   141,    10,   141,   316,    35,   408,    86,   403,
      15,    86,   141,   143,   150,    93,   410,   143,    93,   805,
      98,   144,   333,    98,   335,   336,    11,   338,   339,   340,
     341,   342,   343,    61,   161,   346,   144,   156,   349,   350,
     351,   352,     7,   141,   122,   148,   143,   122,   141,   143,
      70,   143,   143,   148,   143,   366,   367,   368,   592,   370,
     146,   715,     9,   145,   142,   599,   142,   142,   140,   138,
     143,   472,   473,   143,    15,   143,   143,   471,    15,   144,
     474,   159,   160,   144,   159,   160,   143,    14,   144,   143,
     143,   143,   486,   143,   139,   143,   143,    35,   162,   143,
     143,   143,   148,   414,   145,   416,   417,   143,   419,   143,
     421,    22,   152,   140,   140,   150,   140,   140,   150,    37,
     150,     3,     6,   142,    42,   143,   140,   142,   150,   141,
     151,   141,   141,   690,   142,   148,   142,   531,   532,   142,
     534,   140,   536,   143,   161,   138,   144,   143,   145,   144,
     141,   141,   144,   142,   156,   143,   467,   551,   142,   138,
     142,   142,   142,   720,    70,   140,   144,   140,   562,   143,
     140,   140,   143,   311,    50,    50,    15,   571,   141,   139,
     144,   143,   141,   584,   578,   143,   142,   588,   582,   142,
     142,   329,   586,   143,    15,   143,    50,   598,   592,    50,
     594,   512,   141,   597,    15,   599,   124,   142,   141,   127,
     521,   768,   613,   770,   142,   609,   141,   143,   775,   137,
     143,   142,    24,   143,   143,   140,   537,   143,   142,   141,
     143,   632,   139,   143,   139,   636,   145,   141,   376,   640,
     143,   143,   143,   141,    50,     7,   143,   142,   142,    50,
     143,   562,   143,   810,   811,   812,   143,   395,   143,     7,
     398,   161,   143,     7,   587,   800,   126,   722,   669,   826,
     188,   633,   666,   631,   390,   668,   734,   671,   589,   230,
     674,   636,   613,   731,   678,   271,   280,   681,    68,   683,
     266,   685,   279,   687,   568,   278,   678,   411,   774,   217,
     536,    -1,    -1,    -1,   698,   699,    -1,    -1,    -1,    -1,
      -1,    -1,   623,    -1,   232,   716,    -1,   235,    -1,    -1,
      -1,   298,   633,    -1,   635,   636,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,
     258,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     661,    -1,    -1,    -1,   492,   493,   494,   495,    -1,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,   767,    -1,    -1,   514,    -1,    -1,   517,
     774,   519,   520,    -1,   522,   523,   524,   525,   526,   527,
     528,    -1,    -1,   787,    -1,    -1,    -1,    -1,   316,   800,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   545,    -1,   547,
     548,   722,    -1,    -1,    -1,   333,    -1,   335,   336,    -1,
     338,   339,   340,   341,   342,   343,    -1,    -1,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    22,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,   366,   367,
     368,    36,   370,    38,    -1,    -1,    -1,    -1,   769,    -1,
      -1,    -1,   773,    -1,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,   151,    -1,   153,   154,
      -1,    -1,   157,   711,   159,    -1,   161,   162,    -1,    -1,
      -1,    -1,   167,   168,    -1,   170,   171,    -1,   173,   174,
     728,    -1,    -1,    -1,   512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   521,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   199,   200,   201,    -1,   203,   537,
      -1,   206,   207,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,   562,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,   589,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    82,   623,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,   633,    94,   635,   636,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,   661,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,    -1,   162,     3,     4,    -1,    -1,    -1,
       8,     9,    10,    -1,    12,    13,    14,    15,    16,    17,
      18,    19,    -1,    -1,   722,    -1,    -1,    -1,    -1,    27,
      -1,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    39,    40,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    71,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    81,    82,    -1,    84,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,   109,    -1,    -1,   112,    -1,    -1,   115,   116,    -1,
      -1,    -1,   120,   121,    -1,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,
      -1,   139,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    71,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    81,    82,    -1,    84,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,   107,    -1,   109,
      -1,    -1,   112,    -1,    -1,   115,   116,    -1,    -1,    -1,
     120,   121,    -1,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,    -1,    -1,    -1,   137,    -1,   139,
      -1,    -1,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    -1,    -1,    -1,    20,    -1,
      -1,    23,    -1,    25,    -1,    27,    28,    -1,    30,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,    -1,   135,   136,    -1,    -1,    -1,    -1,    -1,
     142,   143,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,     8,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    69,    -1,    71,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      84,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,   109,    -1,    -1,   112,    -1,
      -1,   115,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,   146,    -1,    -1,    -1,   150,    -1,    -1,   153,
     154,    -1,   156,   157,   158,    -1,   160,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,
      -1,    27,    28,    -1,    30,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    49,    -1,    51,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    94,    -1,
      -1,    -1,    98,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,    -1,    -1,    -1,    -1,    -1,    -1,   123,    -1,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,    -1,   135,
     136,    -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
     146,    -1,    -1,    -1,   150,    -1,    -1,   153,   154,    -1,
     156,   157,   158,    -1,   160,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,
      28,    -1,    30,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    49,    -1,    51,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,   123,    -1,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,    -1,   135,   136,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,    -1,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    71,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,   107,    -1,   109,
      -1,    -1,   112,    -1,    -1,   115,   116,    -1,    -1,    -1,
     120,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,    -1,    -1,    -1,   137,   138,    -1,
      -1,    -1,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    40,    -1,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
      -1,    73,    74,    -1,    -1,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,   109,    -1,    -1,
     112,    -1,    -1,   115,   116,    -1,    -1,    -1,   120,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,    -1,    -1,    -1,   137,    -1,   139,    -1,    -1,
     142,    -1,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,   109,    -1,    -1,   112,    -1,
      -1,   115,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,   146,    -1,    -1,    -1,   150,    -1,    -1,   153,
     154,    -1,   156,   157,   158,    -1,   160,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    40,    -1,    -1,    -1,    44,    45,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    71,    -1,    73,    74,    -1,
      -1,    -1,    -1,    -1,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    -1,    -1,    94,    -1,
      -1,    -1,    98,    99,    -1,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,    -1,   115,
     116,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,    -1,    -1,
      -1,   137,   138,    -1,    -1,    -1,   142,    -1,    -1,    -1,
     146,    -1,    -1,    -1,   150,    -1,    -1,   153,   154,    -1,
     156,   157,   158,    -1,   160,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   141,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,    -1,     9,
      10,    -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   125,   126,    -1,   128,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   141,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    -1,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   125,   126,    -1,   128,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     142,    -1,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    -1,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,    -1,    -1,    -1,
      -1,     7,    -1,    -1,    -1,   109,    -1,    -1,   112,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,   125,   126,    -1,   128,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,
      46,    -1,   146,    -1,    -1,    -1,   150,    53,    -1,   153,
     154,    -1,   156,   157,   158,    61,   160,    -1,    64,    -1,
      66,    -1,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    91,    -1,    93,    -1,    95,
      -1,    97,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,     3,     4,   159,   160,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,     3,     4,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      20,   135,   136,    23,    -1,    25,    -1,    -1,    28,    -1,
      30,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    76,    77,    -1,    79,
      80,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    94,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,   114,    -1,   116,     3,     4,    -1,
      -1,    -1,    -1,   123,    -1,    -1,   126,   127,    -1,    -1,
     130,   131,   132,    -1,    20,   135,   136,    23,    -1,    25,
      -1,    -1,    28,    -1,    30,    -1,   146,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    94,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,     3,     4,    -1,    -1,    -1,    -1,   123,    -1,    -1,
     126,   127,    -1,    -1,   130,   131,   132,    -1,    20,   135,
     136,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,     3,     4,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      20,   135,   136,    23,    -1,    25,    -1,    -1,    28,    -1,
      30,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    76,    77,    -1,    79,
      80,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    94,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,   114,    -1,   116,    -1,    -1,    -1,
       3,     4,    -1,   123,    -1,    -1,   126,   127,    -1,    -1,
     130,   131,   132,    -1,    -1,   135,   136,    20,    -1,   139,
      23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      73,    74,    -1,    76,    77,    -1,    79,    80,    -1,    82,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
      -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,
     113,   114,    -1,   116,    -1,    -1,    -1,     3,     4,    -1,
     123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,
      -1,    -1,   135,   136,    20,    -1,   139,    23,    -1,    25,
      -1,    -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    94,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,     3,     4,    -1,    -1,    -1,    -1,   123,    -1,    -1,
     126,   127,    -1,    -1,   130,   131,   132,    -1,    20,   135,
     136,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      -1,   135,   136
  };

  const short
  Parser::yystos_[] =
  {
       0,    88,   164,     3,   165,     0,   138,   170,     4,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      27,    29,    34,    38,    40,    43,    44,    45,    51,    54,
      61,    68,    69,    71,    73,    74,    80,    81,    82,    84,
      86,    89,    90,    94,    98,    99,   101,   102,   103,   107,
     109,   112,   115,   116,   120,   121,   125,   126,   128,   129,
     130,   133,   137,   139,   142,   146,   150,   153,   154,   156,
     157,   158,   160,   165,   166,   171,   172,   173,   174,   176,
     178,   179,   180,   181,   201,   208,   209,   231,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   252,   253,   256,   261,   262,
     263,   264,   267,   268,   269,   140,   141,   156,   231,   231,
     231,   142,   141,   147,   213,   141,   181,   213,   231,   142,
     142,   142,   142,   165,   147,   142,   142,   213,    20,    23,
      25,    28,    30,    49,    52,    54,    55,    67,    73,    74,
      76,    77,    79,    80,    82,    84,    92,    94,    99,   104,
     105,   106,   109,   112,   113,   114,   116,   123,   126,   127,
     130,   131,   132,   135,   136,   165,   166,   188,   189,   210,
     211,   212,   216,   217,   220,   224,   228,   142,   213,    57,
      58,   185,   190,   246,   142,    25,    54,    73,    74,    80,
      82,    94,    99,   109,   112,   116,   126,   130,   166,   212,
     231,   142,   246,   142,   141,   231,   142,   213,   142,   142,
     142,   141,   231,   138,   172,   173,   181,   197,   198,   201,
     142,   147,   213,   231,   142,   213,   142,   141,   231,   257,
     259,   246,   246,    14,    15,    14,    15,   142,   250,   270,
     246,   246,   162,   231,   232,   233,   265,   266,    39,    63,
      65,    67,   124,   141,    46,    85,    95,    97,   119,   140,
     149,    22,    53,    91,    64,    78,   147,   148,   150,   151,
     152,   110,   111,   153,   154,   100,   146,   155,   156,    66,
      70,    86,    93,    98,   122,   142,   159,   160,   150,   276,
     231,    15,   141,   141,   145,   141,   145,   231,   212,   187,
     188,   212,   141,   231,     9,   165,    81,   175,   231,    62,
     141,    15,    15,   153,   154,   253,   254,   231,   232,   212,
     165,   138,   147,   145,   213,   213,   213,   142,   213,   213,
     213,   213,   213,   213,   142,   221,   213,   213,   276,   213,
     213,   213,   213,   140,    63,   215,   165,   231,   272,   273,
     274,   212,   194,   212,   231,   147,   213,   213,   213,   147,
     213,   142,   231,   231,   141,   232,   212,    10,   175,   231,
      15,   153,   154,   253,   255,   141,   199,   200,   201,    35,
     206,   207,   211,   231,    15,   212,   141,   232,   212,   175,
     231,   143,   143,   144,   150,   231,    11,   165,    61,   161,
     144,   144,   161,   166,   212,   184,   190,    25,   166,   212,
     186,   190,   166,   235,   235,   237,   235,   235,   235,   235,
     238,   239,   239,   240,   240,   240,   240,   241,   242,   243,
     244,   244,   245,   245,   246,   246,   246,   246,    54,   165,
     251,   247,   247,   251,   232,   251,   231,   269,     7,   275,
     141,   231,   231,   143,   148,   214,   141,   190,   214,   143,
     143,    70,    25,   212,   141,   143,   143,   167,   168,   148,
      15,    15,   143,   143,   143,   214,   140,   165,   229,   230,
     146,   212,    15,   146,   212,   212,     9,   146,   212,   146,
     212,   212,   146,   212,   212,   146,   212,    42,    72,   191,
     192,   193,   195,   138,   146,   165,   212,   218,   219,    15,
     146,   138,   146,   212,   212,   146,   212,   146,   212,   231,
     142,   140,   142,   177,   145,   143,   144,   144,     4,     5,
      60,   165,   182,   183,   143,   212,   212,   212,   212,   232,
     143,   144,   143,   214,   143,   143,   143,    15,   143,   143,
     139,   201,   142,   197,   207,   143,   143,   148,   214,   143,
     214,   141,   143,   143,   231,   258,   259,   271,   140,   165,
     231,   266,   140,   166,   194,   166,   140,   166,   194,   140,
     145,   143,   142,   161,   140,   141,   141,   142,   194,   142,
     231,   165,   165,   231,   197,   197,   141,     6,   142,   142,
     231,   140,   139,   144,   148,   214,   214,   214,   214,   143,
     214,   214,   214,   144,   214,   214,   214,   214,   214,   214,
     143,   144,   212,   222,   214,   145,   144,   214,   214,   214,
     212,   225,   226,   227,   214,   214,   214,   214,   214,   214,
     214,   141,   191,   231,   232,   141,   231,   274,   212,   142,
     214,   144,   214,   214,   143,   231,   142,   138,   138,   212,
     142,   142,   256,   260,   142,   231,   197,   197,   144,   156,
     231,    70,   231,   140,   183,   140,   231,   140,   177,   183,
     212,   235,   232,   231,   231,   183,   232,   143,   140,   140,
     143,    50,   202,   202,   169,    15,   154,   257,   141,    15,
     230,   212,   193,   165,   139,   189,   212,   223,   212,   219,
     165,   139,   144,   143,   141,   143,   214,   191,   212,   143,
     257,    33,    44,   203,   204,   205,   203,   165,    15,   257,
     143,   202,   202,   258,   231,   141,   231,   142,   231,   141,
     231,   141,   142,   276,   143,   143,   142,   143,   197,   231,
     231,   197,   197,   143,    15,   143,   214,   140,   196,   190,
     165,   276,   227,    24,   142,   143,   214,   143,   233,   145,
     139,   205,   139,   143,   143,   143,   197,    68,   161,   141,
     191,   141,   141,   191,   141,   191,   202,   143,   231,   276,
     194,   276,   194,   272,   276,   145,   197,   197,   202,   231,
     143,   143,   143,   182,   141,   143,   198,   197,   161,   276,
     276,   276,   142,   198,   198,   191,   143,   276,   141,   198
  };

  const short
  Parser::yyr1_[] =
  {
       0,   163,   164,   165,   166,   166,   168,   169,   167,   170,
     170,   170,   171,   171,   171,   171,   171,   171,   172,   173,
     173,   174,   174,   174,   174,   175,   175,   176,   176,   176,
     176,   177,   177,   178,   178,   178,   178,   179,   179,   180,
     180,   181,   181,   181,   181,   181,   182,   182,   183,   183,
     183,   184,   185,   186,   187,   188,   188,   189,   189,   190,
     190,   190,   191,   191,   192,   192,   193,   194,   195,   195,
     195,   196,   196,   197,   197,   198,   199,   199,   200,   200,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   202,   202,   203,   203,
     204,   204,   205,   205,   206,   206,   207,   207,   208,   208,
     208,   209,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   211,   212,   212,
     212,   213,   214,   215,   216,   217,   217,   218,   218,   219,
     219,   220,   221,   221,   222,   222,   223,   223,   223,   224,
     225,   225,   226,   226,   227,   228,   228,   229,   229,   229,
     230,   230,   231,   232,   232,   233,   233,   234,   235,   235,
     235,   235,   235,   235,   235,   236,   236,   237,   237,   238,
     238,   238,   239,   239,   239,   239,   239,   240,   240,   241,
     241,   242,   242,   243,   243,   243,   244,   244,   244,   245,
     245,   245,   245,   245,   246,   246,   246,   246,   246,   246,
     246,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   249,   249,   249,   249,   249,   249,   250,
     250,   251,   251,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   253,   253,   253,   254,   254,   254,   255,   255,   256,
     257,   257,   257,   258,   258,   258,   259,   260,   261,   261,
     261,   261,   261,   262,   262,   263,   263,   264,   265,   265,
     266,   267,   268,   268,   270,   271,   269,   272,   272,   273,
     273,   274,   275,   275,   276,   276
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     5,     1,     1,     1,     0,     0,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     1,     7,     6,
       7,     5,     5,     6,     6,     5,     5,     6,     6,     7,
       7,     3,     0,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     8,     8,     8,     8,     1,     0,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     5,     1,     1,     1,
       0,     2,     0,     1,     1,     3,     1,     0,     2,     1,
       2,     1,     2,     3,     3,     2,     2,     2,     2,     6,
       6,     8,     8,     6,     6,     7,     7,     7,     3,     3,
       5,     3,     5,     3,     3,     3,     2,     0,     1,     0,
       2,     1,     4,     3,     2,     1,     6,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       1,     3,     4,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     7,     4,     4,     3,     1,     1,
       3,     5,     3,     0,     2,     0,     4,     9,     9,     5,
       1,     0,     3,     1,     3,     4,     4,     3,     2,     1,
       1,     3,     1,     1,     0,     3,     1,     1,     3,     3,
       3,     3,     3,     5,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     2,     2,     2,     3,     2,     2,
       1,     4,     3,     6,     4,     3,     3,     3,     2,     2,
       3,     1,     4,     7,     4,     4,     5,     2,     2,     5,
       4,     4,     1,     1,     6,     2,     7,     9,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     3,     1,     4,     4,     4,     4,     4,     4,
       4,     7,     7,     7,     8,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     2,     3,
       1,     3,     0,     1,     3,     0,     1,     1,     3,     4,
       7,     4,     7,     4,     7,     4,     9,     3,     3,     1,
       4,     2,     3,     1,     0,     0,     5,     1,     0,     3,
       1,     3,     1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"scoped ~finally\"", "\"dotted identifier\"",
  "\"attribute\"", "\"property\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"bool value\"",
  "\"add\"", "\"assert\"", "\"assert-exception\"", "\"addr\"", "\"after\"",
  "\"&&\"", "\"any\"", "\"->\"", "\"auto\"", "\"at\"", "\"begin\"",
  "\"bool\"", "\"break\"", "\"bytes\"", "\"caddr\"", "\"callable\"",
  "\"case\"", "\"cast\"", "\"catch\"", "\"channel\"", "\"classifier\"",
  "\"Null\"", "\"const\"", "\"continue\"", "\"context\"", "\"copy\"",
  "\"declare\"", "\"default\"", "\"delete\"", "\"/=\"", "\"$$\"", "\"..\"",
  "\"real\"", "\"else\"", "\"end\"", "\"enum\"", "\"==\"", "\"error\"",
  "\"exception\"", "\"export\"", "\"extern\"", "\"extern-no-suspend\"",
  "\"file\"", "\"~finally\"", "\"for\"", "\"from\"", "\"function\"",
  "\">=\"", "\"global\"", "\"?.\"", "\"hook\"", "\"if\"", "\"import\"",
  "\"in\"", "\"init\"", "\"inout\"", "\"int\"", "\"interval\"",
  "\"iosrc\"", "\"iterator\"", "\"const_iterator\"", "\"<=\"",
  "\"library type\"", "\"list\"", "\"local\"", "\"map\"",
  "\"match_token_state\"", "\"method\"", "\"-=\"", "\"--\"", "\"%\"",
  "\"module\"", "\"move\"", "\"new\"", "\"!=\"", "\"net\"", "\"!in\"",
  "\"optional\"", "\"||\"", "\"overlay\"", "\"+=\"", "\"++\"", "\"port\"",
  "\"**\"", "\"preinit\"", "\"private\"", "\"public\"", "\"strong_ref\"",
  "\"regexp\"", "\"result\"", "\"return\"", "\"scope\"", "\"set\"",
  "\"<<\"", "\">>\"", "\"stream\"", "\"string\"", "\"struct\"",
  "\"switch\"", "\"time\"", "\"timer\"", "\"timer_mgr\"", "\"*=\"",
  "\"throw\"", "\"try\"", "\".?\"", "\"tuple\"", "\"type\"",
  "\"typeinfo\"", "\"uint\"", "\"union\"", "\"unpack\"", "\"unset\"",
  "\"vector\"", "\"view\"", "\"void\"", "\"while\"", "\"with\"",
  "\"value_ref\"", "\"weak_ref\"", "\"yield\"", "'{'", "'}'", "'='", "';'",
  "'('", "')'", "','", "':'", "'*'", "'<'", "'>'", "'?'", "'|'", "'^'",
  "'&'", "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "'['", "']'",
  "'$'", "$accept", "module", "local_id", "scoped_id", "dotted_id", "$@1",
  "$@2", "global_scope_items", "global_scope_decl", "type_decl",
  "constant_decl", "local_decl", "local_init_decl", "global_decl",
  "opt_type_arguments", "function_decl", "import_decl", "property_decl",
  "opt_linkage", "function_id", "scoped_function_id", "function_with_body",
  "method_with_body", "hook_with_body", "function_without_body",
  "opt_func_flavor", "func_flavor", "opt_func_cc", "opt_func_params",
  "func_params", "func_param", "func_result", "opt_func_param_kind",
  "opt_func_default_expr", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "opt_switch_cases", "switch_cases",
  "switch_case", "try_catches", "try_catch", "stmt_decl", "stmt_expr",
  "base_type_no_attrs", "base_type", "type", "type_param_begin",
  "type_param_end", "opt_type_flags", "function_type", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type",
  "opt_struct_params", "struct_fields", "struct_field", "union_type",
  "opt_union_fields", "union_fields", "union_field", "enum_type",
  "enum_labels", "enum_label", "expr", "opt_exprs", "exprs", "expr_0",
  "expr_1", "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7",
  "expr_8", "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e",
  "expr_f", "expr_g", "member_expr", "ctor", "const_real", "const_sint",
  "const_uint", "tuple", "opt_tuple_elems1", "opt_tuple_elems2",
  "tuple_elem", "tuple_expr", "list", "set", "map", "struct_",
  "struct_elems", "struct_elem", "regexp", "re_patterns",
  "re_pattern_constant", "$@3", "$@4", "opt_map_elems", "map_elems",
  "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   279,   279,   287,   297,   298,   300,   302,   300,   307,
     309,   311,   315,   316,   317,   318,   319,   320,   322,   325,
     327,   331,   332,   333,   335,   340,   342,   346,   348,   350,
     352,   357,   358,   360,   362,   365,   366,   370,   371,   375,
     376,   378,   379,   380,   381,   382,   386,   387,   390,   391,
     392,   395,   402,   409,   416,   422,   423,   425,   426,   428,
     429,   430,   432,   433,   435,   436,   438,   442,   445,   446,
     447,   450,   451,   456,   457,   460,   462,   463,   465,   466,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     479,   481,   483,   485,   487,   489,   491,   493,   495,   497,
     498,   499,   500,   503,   511,   519,   529,   530,   533,   534,
     536,   537,   539,   540,   542,   543,   545,   547,   549,   550,
     551,   554,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   575,   576,   577,
     578,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   592,   593,   594,   595,   596,   597,   598,   599,
     601,   602,   604,   606,   607,   608,   609,   612,   616,   617,
     618,   622,   626,   629,   632,   636,   637,   641,   643,   647,
     648,   651,   654,   655,   657,   658,   660,   661,   665,   671,
     674,   675,   677,   678,   680,   682,   683,   685,   686,   687,
     690,   691,   696,   699,   700,   702,   703,   705,   708,   709,
     710,   711,   712,   713,   714,   716,   717,   719,   720,   722,
     723,   724,   726,   727,   728,   729,   730,   732,   733,   735,
     736,   738,   739,   741,   742,   743,   745,   746,   747,   749,
     750,   751,   752,   753,   755,   756,   757,   758,   759,   760,
     761,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   787,   788,   789,   790,   792,   794,   796,
     797,   800,   801,   805,   806,   807,   808,   809,   810,   811,
     812,   814,   815,   816,   817,   820,   823,   826,   829,   831,
     832,   833,   836,   838,   840,   843,   844,   845,   846,   847,
     848,   851,   852,   853,   855,   856,   857,   859,   860,   863,
     866,   867,   868,   871,   872,   873,   876,   879,   881,   882,
     883,   885,   886,   889,   890,   893,   894,   897,   899,   900,
     902,   904,   906,   908,   911,   911,   911,   914,   915,   917,
     918,   920,   923,   924,   927,   928
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   157,     2,     2,   162,   155,   152,     2,
     142,   143,   146,   153,   144,   154,   159,   156,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   145,   141,
     147,   140,   148,   149,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   160,     2,   161,   151,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   138,   150,   139,   158,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137
    };
    // Last valid token kind.
    const int code_max = 392;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 27 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"
} } } // hilti::detail::parser
#line 6534 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc"

#line 930 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp"


void hilti::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
