// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"

namespace spicy { namespace detail { class Parser; } }

#include <spicy/compiler/detail/parser/driver.h>

#line 40 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"


#include <spicy/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(spicy::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}

/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));

    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)

static int _field_width = 0;


#line 101 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 28 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
namespace spicy { namespace detail { namespace parser {
#line 199 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.copy< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.copy< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.copy< spicy::Engine > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::Hook > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.copy< spicy::type::unit::Item > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.move< hilti::Expression > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::Type > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.move< hilti::type::function::Result > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.move< spicy::Engine > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::Hook > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.move< spicy::type::unit::Item > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< std::vector<spicy::Hook> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  Parser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.YY_MOVE_OR_COPY< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.YY_MOVE_OR_COPY< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.YY_MOVE_OR_COPY< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.YY_MOVE_OR_COPY< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.YY_MOVE_OR_COPY< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.YY_MOVE_OR_COPY< spicy::Engine > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.YY_MOVE_OR_COPY< spicy::Hook > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.YY_MOVE_OR_COPY< spicy::type::bitfield::Bits > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.YY_MOVE_OR_COPY< spicy::type::unit::Item > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.YY_MOVE_OR_COPY< spicy::type::unit::item::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.YY_MOVE_OR_COPY< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.YY_MOVE_OR_COPY< std::optional<hilti::ID> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.YY_MOVE_OR_COPY< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.YY_MOVE_OR_COPY< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.YY_MOVE_OR_COPY< std::vector<spicy::Hook> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.YY_MOVE_OR_COPY< std::vector<spicy::type::bitfield::Bits> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.YY_MOVE_OR_COPY< std::vector<spicy::type::unit::Item> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.YY_MOVE_OR_COPY< std::vector<spicy::type::unit::item::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.move< hilti::Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.move< hilti::type::function::Result > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.move< spicy::Engine > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::Hook > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.move< spicy::type::unit::Item > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< std::vector<hilti::Declaration> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< std::vector<spicy::Hook> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.copy< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.copy< spicy::Engine > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::Hook > (that.value);
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.copy< spicy::type::unit::Item > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        value.move< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        value.move< hilti::Expression > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::Type > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        value.move< spicy::Engine > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::Hook > (that.value);
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        value.move< spicy::type::unit::Item > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (that.value);
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< std::vector<spicy::Hook> > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 20 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
    yyla.location.begin.line = yyla.location.end.line = driver->currentLine();
}

#line 2283 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
      case symbol_kind::S_const_real: // const_real
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute > ();
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        yylhs.value.emplace< hilti::Declaration > ();
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
        yylhs.value.emplace< hilti::Expression > ();
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        yylhs.value.emplace< hilti::Function > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement > ();
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        yylhs.value.emplace< hilti::Type > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::declaration::parameter::Kind > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter > ();
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
        yylhs.value.emplace< hilti::type::function::Result > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element > ();
        break;

      case symbol_kind::S_const_sint: // const_sint
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_opt_unit_field_engine: // opt_unit_field_engine
      case symbol_kind::S_opt_hook_engine: // opt_hook_engine
        yylhs.value.emplace< spicy::Engine > ();
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        yylhs.value.emplace< spicy::Hook > ();
        break;

      case symbol_kind::S_bitfield_bits_spec: // bitfield_bits_spec
        yylhs.value.emplace< spicy::type::bitfield::Bits > ();
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
        yylhs.value.emplace< spicy::type::unit::Item > ();
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        yylhs.value.emplace< spicy::type::unit::item::switch_::Case > ();
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< std::optional<hilti::AttributeSet> > ();
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
        yylhs.value.emplace< std::optional<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
        yylhs.value.emplace< std::optional<hilti::ID> > ();
        break;

      case symbol_kind::S_opt_else_block: // opt_else_block
        yylhs.value.emplace< std::optional<hilti::Statement> > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        yylhs.value.emplace< std::vector<hilti::Declaration> > ();
        break;

      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< std::vector<hilti::Expression> > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< std::vector<hilti::Statement> > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< std::vector<hilti::ctor::map::Element> > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< std::vector<hilti::type::enum_::Label> > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        yylhs.value.emplace< std::vector<hilti::type::function::Parameter> > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< std::vector<hilti::type::tuple::Element> > ();
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        yylhs.value.emplace< std::vector<spicy::Hook> > ();
        break;

      case symbol_kind::S_opt_bitfield_bits: // opt_bitfield_bits
      case symbol_kind::S_bitfield_bits: // bitfield_bits
        yylhs.value.emplace< std::vector<spicy::type::bitfield::Bits> > ();
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
        yylhs.value.emplace< std::vector<spicy::type::unit::Item> > ();
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        yylhs.value.emplace< std::vector<spicy::type::unit::item::switch_::Case> > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 4: // start_expr: expr
#line 299 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { driver->setDestinationExpression(std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 2708 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 5: // module: MODULE local_id ';' global_scope_items
#line 302 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { auto m = hilti::Module(yystack_[2].value.as < hilti::ID > (), std::move(yystack_[0].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[0].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2716 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 6: // local_id: "identifier"
#line 309 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( name.find('-') != std::string::npos)
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" )
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 2730 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 7: // scoped_id: local_id
#line 319 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2736 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 8: // scoped_id: "scoped identifier"
#line 320 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > (), __loc__); }
#line 2742 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 9: // $@1: %empty
#line 322 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                { driver->enableDottedIDMode(); }
#line 2748 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 10: // $@2: %empty
#line 324 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                { driver->disableDottedIDMode(); }
#line 2754 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 11: // dotted_id: $@1 "dotted identifier" $@2
#line 324 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > (), __loc__); }
#line 2760 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 12: // global_scope_items: global_scope_items global_scope_decl
#line 330 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2766 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_items: global_scope_items stmt
#line 332 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 2772 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_items: %empty
#line 333 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 2778 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_decl: type_decl
#line 337 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2784 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: constant_decl
#line 338 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2790 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: global_decl
#line 339 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2796 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 18: // global_scope_decl: function_decl
#line 340 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2802 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 19: // global_scope_decl: import_decl
#line 341 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2808 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 20: // global_scope_decl: property_decl
#line 342 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2814 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 21: // global_scope_decl: hook_decl
#line 343 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = std::move(yystack_[0].value.as < hilti::Declaration > ()); }
#line 2820 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 22: // type_decl: opt_linkage TYPE scoped_id '=' type opt_attributes ';'
#line 345 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                       {
                                                   if ( auto x = yystack_[2].value.as < hilti::Type > ().isA<type::Unit>(); x && yystack_[1].value.as < std::optional<hilti::AttributeSet> > () && *yystack_[1].value.as < std::optional<hilti::AttributeSet> > () ) {
                                                       yystack_[2].value.as < hilti::Type > ().as<type::Unit>().setAttributes(*yystack_[1].value.as < std::optional<hilti::AttributeSet> > ());
                                                       yystack_[1].value.as < std::optional<hilti::AttributeSet> > () = {}; // don't associate with declaration
                                                       }

                                                   yylhs.value.as < hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[6].value.as < hilti::declaration::Linkage > ()), __loc__);
                                                 }
#line 2833 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 23: // constant_decl: opt_linkage CONST scoped_id '=' expr ';'
#line 355 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2839 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 24: // constant_decl: opt_linkage CONST scoped_id ':' type '=' expr ';'
#line 357 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Constant(yystack_[5].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[7].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2845 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 25: // local_decl: LOCAL scoped_id '=' expr ';'
#line 360 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2851 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 26: // local_decl: LOCAL scoped_id ':' type ';'
#line 361 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Type > (), {}, false, __loc__); }
#line 2857 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 27: // local_decl: LOCAL scoped_id ':' type '=' expr ';'
#line 363 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[5].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), false, __loc__); }
#line 2863 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 28: // local_init_decl: LOCAL local_id ':' type '=' expr
#line 368 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[4].value.as < hilti::ID > (), yystack_[2].value.as < hilti::Type > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2869 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 29: // local_init_decl: LOCAL local_id '=' expr
#line 370 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression > (), false, __loc__); }
#line 2875 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 30: // global_decl: opt_linkage GLOBAL scoped_id '=' expr ';'
#line 374 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2881 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 31: // global_decl: opt_linkage GLOBAL scoped_id ':' type ';'
#line 376 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Type > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2887 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 32: // global_decl: opt_linkage GLOBAL scoped_id ':' type '=' expr ';'
#line 378 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[5].value.as < hilti::ID > (), yystack_[3].value.as < hilti::Type > (), yystack_[1].value.as < hilti::Expression > (), yystack_[7].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2893 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 33: // function_decl: opt_linkage function_with_body
#line 382 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as < hilti::Function > (), yystack_[1].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2899 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 34: // function_decl: opt_linkage function_without_body ';'
#line 384 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Function(yystack_[1].value.as < hilti::Function > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2905 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 35: // import_decl: IMPORT local_id ';'
#line 387 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".spicy"), __loc__); }
#line 2911 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 36: // import_decl: IMPORT local_id FROM dotted_id ';'
#line 388 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                   { yylhs.value.as < hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".spicy"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 2917 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 37: // property_decl: "property" ';'
#line 391 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 2923 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 38: // property_decl: "property" '=' expr ';'
#line 392 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 2929 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 39: // property_decl: "property" '=' base_type ';'
#line 393 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as < std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as < hilti::Type > ())), __loc__); }
#line 2935 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 40: // hook_decl: ON unit_hook_id unit_hook
#line 396 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { ID unit = yystack_[1].value.as < hilti::ID > ().namespace_();
                                                   if ( unit.empty() )
                                                      error(yylhs.location, "hook requires unit namespace");

                                                   yylhs.value.as < hilti::Declaration > () = spicy::declaration::UnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::Hook > ()), __loc__);
                                                 }
#line 2946 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 41: // opt_linkage: PUBLIC
#line 404 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 2952 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 42: // opt_linkage: PRIVATE
#line 405 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2958 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 43: // opt_linkage: %empty
#line 406 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2964 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 44: // function_with_body: FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes braced_block
#line 412 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[2].value.as < hilti::type::function::Result > (), yystack_[4].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[6].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2973 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 45: // function_without_body: FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes
#line 419 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 {
                                                    auto ftype = hilti::type::Function(yystack_[1].value.as < hilti::type::function::Result > (), yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > (), yystack_[7].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function > () = hilti::Function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as < hilti::function::CallingConvention > (), yystack_[0].value.as < std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 2982 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 46: // opt_func_flavor: %empty
#line 425 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 2988 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 47: // opt_func_cc: "string value"
#line 427 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { try {
                                                       yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::calling_convention::from_string(yystack_[0].value.as < std::string > ());
                                                   } catch ( std::out_of_range& e ) {
                                                       error(yylhs.location, "unknown calling convention");
                                                   }
                                                 }
#line 2999 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 48: // opt_func_cc: %empty
#line 433 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 3005 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 49: // opt_func_params: func_params
#line 437 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 3011 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 50: // opt_func_params: %empty
#line 438 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 3017 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 51: // func_params: func_params ',' func_param
#line 440 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as < std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter > ()); }
#line 3023 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 52: // func_params: func_param
#line 441 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as < hilti::type::function::Parameter > ()}; }
#line 3029 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 53: // func_param: opt_func_param_kind local_id ':' type opt_init_expression
#line 444 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Type > (), yystack_[4].value.as < hilti::declaration::parameter::Kind > (), yystack_[0].value.as < std::optional<hilti::Expression> > (), __loc__); }
#line 3035 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 54: // func_result: ':' type
#line 446 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as < hilti::Type > ()), __loc__); }
#line 3041 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_result: func_result
#line 448 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Result > () = std::move(yystack_[0].value.as < hilti::type::function::Result > ()); }
#line 3047 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_result: %empty
#line 449 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::function::Result > () = hilti::type::function::Result(hilti::type::void_, __loc__); }
#line 3053 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 57: // opt_func_param_kind: INOUT
#line 452 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 3059 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 58: // opt_func_param_kind: %empty
#line 453 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 3065 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 59: // opt_init_expression: '=' expr
#line 456 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                               { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 3071 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 60: // opt_init_expression: %empty
#line 457 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 3077 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 61: // block: braced_block
#line 462 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 3083 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 62: // block: stmt
#line 463 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as < hilti::Statement > ()}, __loc__); }
#line 3089 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 63: // braced_block: '{' opt_stmts '}'
#line 466 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()), __loc__); }
#line 3095 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 64: // opt_stmts: stmts
#line 468 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as < std::vector<hilti::Statement> > ()); }
#line 3101 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 65: // opt_stmts: %empty
#line 469 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 3107 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 66: // stmts: stmts stmt
#line 471 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as < std::vector<hilti::Statement> > ()); yylhs.value.as < std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as < hilti::Statement > ()); }
#line 3113 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 67: // stmts: stmt
#line 472 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as < hilti::Statement > ())}; }
#line 3119 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 68: // stmt: stmt_expr ';'
#line 474 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[1].value.as < hilti::Statement > ()); }
#line 3125 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 69: // stmt: stmt_decl
#line 475 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 3131 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 70: // stmt: "assert" expr ';'
#line 476 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as < hilti::Expression > ()), {}, __loc__); }
#line 3137 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 71: // stmt: "assert" expr ':' expr ';'
#line 477 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3143 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 72: // stmt: "assert-exception" expr ';'
#line 478 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression > ()), {}, {}, __loc__); }
#line 3149 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 73: // stmt: "assert-exception" expr ':' expr ';'
#line 480 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression > ()), {}, std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3155 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 74: // stmt: BREAK ';'
#line 481 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 3161 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 75: // stmt: CONTINUE ';'
#line 482 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 3167 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 76: // stmt: FOR '(' local_id IN expr ')' block
#line 484 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3173 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 77: // stmt: IF '(' expr ')' block opt_else_block
#line 486 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 3179 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 78: // stmt: IF '(' local_init_decl ')' block opt_else_block
#line 488 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as < hilti::Declaration > ()), {}, std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 3185 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 79: // stmt: IF '(' local_init_decl ';' expr ')' block opt_else_block
#line 490 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as < hilti::Declaration > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Statement > ()), std::move(yystack_[0].value.as < std::optional<hilti::Statement> > ()), __loc__); }
#line 3191 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 80: // stmt: PRINT opt_exprs ';'
#line 491 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = spicy::statement::Print(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 3197 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 81: // stmt: RETURN ';'
#line 492 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 3203 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 82: // stmt: RETURN expr ';'
#line 493 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 3209 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 83: // stmt: STOP ';'
#line 494 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = spicy::statement::Stop(__loc__); }
#line 3215 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 84: // stmt: THROW expr ';'
#line 495 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Throw(hilti::builder::exception(hilti::builder::typeByID("spicy_rt::ParseError"), yystack_[1].value.as < hilti::Expression > (), __loc__), __loc__); }
#line 3221 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 85: // stmt: SWITCH '(' expr ')' '{' switch_cases '}'
#line 497 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 3227 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 86: // stmt: SWITCH '(' local_init_decl ')' '{' switch_cases '}'
#line 499 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as < hilti::Declaration > ()), std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 3233 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 87: // stmt: "confirm" ';'
#line 500 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = spicy::statement::Confirm(__loc__); }
#line 3239 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 88: // stmt: "reject" ';'
#line 501 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = spicy::statement::Reject(__loc__); }
#line 3245 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 89: // stmt: WHILE '(' local_init_decl ';' expr ')' block
#line 503 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[4].value.as < hilti::Declaration > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), std::nullopt, __loc__); }
#line 3251 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 90: // stmt: WHILE '(' expr ')' block
#line 505 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), std::nullopt, __loc__); }
#line 3257 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 91: // stmt: WHILE '(' local_init_decl ')' block
#line 507 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as < hilti::Declaration > ()), {}, std::move(yystack_[0].value.as < hilti::Statement > ()), std::nullopt, __loc__); }
#line 3263 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 92: // stmt: ADD expr ';'
#line 509 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3275 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 93: // stmt: DELETE expr ';'
#line 517 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3287 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 94: // stmt: UNSET expr ';'
#line 525 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { auto op = yystack_[1].value.as < hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 3299 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 95: // opt_else_block: ELSE block
#line 536 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as < hilti::Statement > ()); }
#line 3305 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 96: // opt_else_block: %empty
#line 537 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Statement> > () = {}; }
#line 3311 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 97: // switch_cases: switch_cases switch_case
#line 539 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as < std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as < std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ())); }
#line 3317 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 98: // switch_cases: switch_case
#line 540 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as < hilti::statement::switch_::Case > ()) }); }
#line 3323 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 99: // switch_case: CASE exprs ':' block
#line 542 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3329 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 100: // switch_case: DEFAULT ':' block
#line 543 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement > ()), __loc__); }
#line 3335 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 101: // stmt_decl: local_decl
#line 545 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3341 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 102: // stmt_decl: type_decl
#line 546 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3347 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 103: // stmt_decl: constant_decl
#line 547 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as < hilti::Declaration > (), __loc__); }
#line 3353 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 104: // stmt_expr: expr
#line 550 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as < hilti::Expression > (), __loc__); }
#line 3359 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 105: // base_type_no_ref: ANY
#line 555 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Any(__loc__); }
#line 3365 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 106: // base_type_no_ref: ADDRESS
#line 556 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Address(__loc__); }
#line 3371 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 107: // base_type_no_ref: BOOL
#line 557 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bool(__loc__); }
#line 3377 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 108: // base_type_no_ref: BYTES
#line 558 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 3383 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 109: // base_type_no_ref: INTERVAL
#line 559 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Interval(__loc__); }
#line 3389 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 110: // base_type_no_ref: NETWORK
#line 560 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Network(__loc__); }
#line 3395 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 111: // base_type_no_ref: PORT
#line 561 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Port(__loc__); }
#line 3401 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 112: // base_type_no_ref: REAL
#line 562 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Real(__loc__); }
#line 3407 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 113: // base_type_no_ref: REGEXP
#line 563 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 3413 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 114: // base_type_no_ref: "stream"
#line 564 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Stream(__loc__); }
#line 3419 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 115: // base_type_no_ref: STRING
#line 565 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::String(__loc__); }
#line 3425 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 116: // base_type_no_ref: TIME
#line 566 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Time(__loc__); }
#line 3431 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 117: // base_type_no_ref: VOID
#line 567 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::void_; }
#line 3437 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 118: // base_type_no_ref: INT8
#line 569 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(8, __loc__); }
#line 3443 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 119: // base_type_no_ref: INT16
#line 570 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(16, __loc__); }
#line 3449 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 120: // base_type_no_ref: INT32
#line 571 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(32, __loc__); }
#line 3455 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 121: // base_type_no_ref: INT64
#line 572 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::SignedInteger(64, __loc__); }
#line 3461 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 122: // base_type_no_ref: UINT8
#line 573 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(8, __loc__); }
#line 3467 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_ref: UINT16
#line 574 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(16, __loc__); }
#line 3473 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_ref: UINT32
#line 575 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(32, __loc__); }
#line 3479 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_ref: UINT64
#line 576 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnsignedInteger(64, __loc__); }
#line 3485 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_ref: CONST_ITERATOR type_param_begin type type_param_end
#line 578 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), true, __loc__); }
#line 3491 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_ref: ITERATOR type_param_begin type type_param_end
#line 579 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as < hilti::Type > ()), false, __loc__); }
#line 3497 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_ref: OPTIONAL type_param_begin type type_param_end
#line 580 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Optional(yystack_[1].value.as < hilti::Type > (), __loc__); }
#line 3503 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_ref: VIEW type_param_begin type type_param_end
#line 581 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = viewForType(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3509 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_ref: MAP type_param_begin type ',' type type_param_end
#line 583 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3515 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_ref: SET type_param_begin type type_param_end
#line 584 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3521 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_ref: VECTOR type_param_begin type type_param_end
#line 585 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3527 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_ref: SINK
#line 587 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = spicy::type::Sink(__loc__); }
#line 3533 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_ref: "library type" '(' "string value" ')'
#line 589 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3539 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_ref: tuple_type
#line 591 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3545 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_ref: struct_type
#line 592 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3551 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_ref: enum_type
#line 593 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3557 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_ref: bitfield_type
#line 594 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3563 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_ref: unit_type
#line 595 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3569 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 140: // reference_type: type '&'
#line 600 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3575 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 141: // base_type: base_type_no_ref
#line 602 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3581 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 142: // reference_type: type '&'
#line 603 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as < hilti::Type > ()), __loc__); }
#line 3587 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 143: // type: base_type
#line 606 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3593 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 144: // type: reference_type
#line 607 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = std::move(yystack_[0].value.as < hilti::Type > ()); }
#line 3599 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 145: // type: scoped_id
#line 608 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3605 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 146: // type_param_begin: '<'
#line 613 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->disableExpressionMode(); }
#line 3611 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 147: // type_param_end: '>'
#line 617 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->enableExpressionMode(); }
#line 3617 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 148: // tuple_type: TUPLE type_param_begin '*' type_param_end
#line 619 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 3623 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 149: // tuple_type: TUPLE type_param_begin tuple_type_elems type_param_end
#line 620 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 3629 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 150: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 625 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as < std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element > ())); }
#line 3635 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 151: // tuple_type_elems: tuple_type_elems ','
#line 626 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::tuple::Element> > ()); }
#line 3641 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 152: // tuple_type_elems: tuple_type_elem
#line 627 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::tuple::Element> > () = std::vector<type::tuple::Element>{ std::move(yystack_[0].value.as < hilti::type::tuple::Element > ()) }; }
#line 3647 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 153: // tuple_type_elem: type
#line 631 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[0].value.as < hilti::Type > ())); }
#line 3653 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 154: // tuple_type_elem: local_id ':' type
#line 632 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Type > ())); }
#line 3659 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 155: // struct_type: STRUCT '{' struct_fields '}'
#line 635 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Struct(std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()), __loc__); }
#line 3665 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 156: // struct_fields: struct_fields struct_field
#line 637 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as < std::vector<hilti::Declaration> > ()); yylhs.value.as < std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as < hilti::Declaration > ()); }
#line 3671 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 157: // struct_fields: %empty
#line 638 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 3677 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 158: // struct_field: local_id ':' type opt_attributes ';'
#line 640 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                     { yylhs.value.as < hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3683 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 159: // enum_type: ENUM '{' enum_labels '}'
#line 642 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 3689 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 160: // enum_labels: enum_labels ',' enum_label
#line 644 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as < std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3695 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 161: // enum_labels: enum_labels ','
#line 645 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::enum_::Label> > ()); }
#line 3701 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 162: // enum_labels: enum_label
#line 646 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as < std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label > ())); }
#line 3707 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 163: // enum_label: local_id
#line 649 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3713 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 164: // enum_label: local_id '=' "unsigned integer value"
#line 650 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3719 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 165: // $@3: %empty
#line 654 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { _field_width = yystack_[1].value.as < uint64_t > (); }
#line 3725 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 166: // bitfield_type: BITFIELD '(' const_uint ')' $@3 '{' opt_bitfield_bits '}'
#line 656 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = spicy::type::Bitfield(yystack_[5].value.as < uint64_t > (), yystack_[1].value.as < std::vector<spicy::type::bitfield::Bits> > (), __loc__); }
#line 3731 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 167: // opt_bitfield_bits: bitfield_bits
#line 660 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[0].value.as < std::vector<spicy::type::bitfield::Bits> > ()); }
#line 3737 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 168: // opt_bitfield_bits: %empty
#line 661 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); }
#line 3743 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 169: // bitfield_bits: bitfield_bits bitfield_bits_spec
#line 665 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[1].value.as < std::vector<spicy::type::bitfield::Bits> > ()); yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as < spicy::type::bitfield::Bits > ()));  }
#line 3749 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 170: // bitfield_bits: bitfield_bits_spec
#line 666 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); yylhs.value.as < std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as < spicy::type::bitfield::Bits > ())); }
#line 3755 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 171: // bitfield_bits_spec: local_id ':' const_uint DOTDOT const_uint opt_attributes ';'
#line 670 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[6].value.as < hilti::ID > ()), yystack_[4].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3761 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 172: // bitfield_bits_spec: local_id ':' const_uint opt_attributes ';'
#line 672 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[4].value.as < hilti::ID > ()), yystack_[2].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3767 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 173: // unit_type: UNIT opt_unit_params '{' opt_unit_items '}'
#line 677 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Type > () = spicy::type::Unit(std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as < std::vector<spicy::type::unit::Item> > ()), {}, __loc__); }
#line 3773 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 174: // opt_unit_params: '(' opt_func_params ')'
#line 680 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 3779 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 175: // opt_unit_params: %empty
#line 681 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 3785 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 176: // unit_items: unit_items unit_item
#line 683 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::Item> > () = std::move(yystack_[1].value.as < std::vector<spicy::type::unit::Item> > ()); yylhs.value.as < std::vector<spicy::type::unit::Item> > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::Item > ())); }
#line 3791 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 177: // unit_items: unit_item
#line 684 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>(); yylhs.value.as < std::vector<spicy::type::unit::Item> > ().push_back(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3797 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 178: // opt_unit_items: unit_items
#line 686 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::Item> > () = std::move(yystack_[0].value.as < std::vector<spicy::type::unit::Item> > ());}
#line 3803 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 179: // opt_unit_items: %empty
#line 687 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>{}; }
#line 3809 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 180: // unit_item: unit_field
#line 690 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3815 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 181: // unit_item: unit_variable
#line 691 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3821 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 182: // unit_item: unit_wide_hook
#line 692 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3827 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 183: // unit_item: unit_property
#line 693 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3833 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 184: // unit_item: unit_sink
#line 694 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3839 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 185: // unit_item: unit_switch
#line 695 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = std::move(yystack_[0].value.as < spicy::type::unit::Item > ()); }
#line 3845 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 186: // unit_variable: VAR local_id ':' type opt_init_expression opt_attributes ';'
#line 700 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::Variable(std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::Type > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3851 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 187: // unit_sink: SINK local_id opt_attributes ';'
#line 702 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::Sink(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 3857 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 188: // unit_property: "property" opt_attributes ';'
#line 704 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 3863 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 189: // unit_property: "property" '=' expr opt_attributes ';'
#line 706 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[4].value.as < std::string > ())), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 3869 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 190: // unit_property: "property" '=' base_type_no_ref ';'
#line 707 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                        { yylhs.value.as < spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[3].value.as < std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as < hilti::Type > ())), {}, false, __loc__); }
#line 3875 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 191: // unit_field: opt_unit_field_id opt_unit_field_engine base_type opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 711 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 {   if ( yystack_[5].value.as < hilti::Type > ().isA<type::Vector>() )
                                                         error(yylhs.location, "vector<T> syntax is no longer supported for parsing sequences; use T[] instead.");
                                                     yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[7].value.as < std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as < hilti::Type > ()), std::move(yystack_[6].value.as < spicy::Engine > ()), {}, std::move(yystack_[4].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as < std::vector<spicy::Hook> > ()), __loc__);
                                                 }
#line 3884 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 192: // unit_field: opt_unit_field_id opt_unit_field_engine ctor opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 717 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[7].value.as < std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as < hilti::Ctor > ()), std::move(yystack_[6].value.as < spicy::Engine > ()), {}, std::move(yystack_[4].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as < std::vector<spicy::Hook> > ()), __loc__); }
#line 3890 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 193: // unit_field: opt_unit_field_id opt_unit_field_engine scoped_id opt_unit_field_args opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 720 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[8].value.as < std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as < hilti::ID > ()), std::move(yystack_[7].value.as < spicy::Engine > ()), std::move(yystack_[5].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[4].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as < std::vector<spicy::Hook> > ()), __loc__); }
#line 3896 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 194: // unit_field: opt_unit_field_id opt_unit_field_engine '(' unit_field_in_container ')' opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 723 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[9].value.as < std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as < spicy::type::unit::Item > ()), std::move(yystack_[8].value.as < spicy::Engine > ()), {}, std::move(yystack_[4].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as < std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as < std::vector<spicy::Hook> > ()), __loc__); }
#line 3902 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 195: // unit_field_in_container: ctor opt_unit_field_args opt_attributes
#line 727 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[2].value.as < hilti::Ctor > ()), {}, std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), {}, {}, std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 3908 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 196: // unit_field_in_container: scoped_id opt_unit_field_args opt_unit_field_repeat opt_attributes
#line 729 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as < hilti::ID > ()), {}, std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[1].value.as < std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 3914 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 197: // unit_field_in_container: base_type opt_unit_field_repeat opt_unit_field_args opt_attributes
#line 731 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as < hilti::Type > ()), {}, std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), std::move(yystack_[2].value.as < std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as < std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 3920 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 198: // unit_wide_hook: ON unit_hook_id unit_hook
#line 733 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::UnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::Hook > ()), __loc__); }
#line 3926 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 199: // opt_unit_field_id: local_id
#line 736 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::ID> > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 3932 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 200: // opt_unit_field_id: %empty
#line 737 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::ID> > () = std::nullopt; }
#line 3938 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 201: // opt_unit_field_engine: ':'
#line 740 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::All; }
#line 3944 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 202: // opt_unit_field_engine: '<'
#line 741 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::Parser; }
#line 3950 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 203: // opt_unit_field_engine: '>'
#line 742 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::Composer; }
#line 3956 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 204: // opt_unit_field_engine: %empty
#line 743 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::All; }
#line 3962 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 205: // opt_unit_field_args: '(' opt_exprs ')'
#line 746 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()); }
#line 3968 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 206: // opt_unit_field_args: %empty
#line 747 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 3974 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 207: // unit_field_repeat: '[' expr ']'
#line 750 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as < hilti::Expression > ()); }
#line 3980 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 208: // unit_field_repeat: '[' ']'
#line 751 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = hilti::builder::null(); }
#line 3986 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 209: // opt_unit_field_repeat: unit_field_repeat
#line 754 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as < std::optional<hilti::Expression> > ()); }
#line 3992 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 210: // opt_unit_field_repeat: %empty
#line 755 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 3998 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 211: // opt_unit_field_condition: IF '(' expr ')'
#line 758 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as < hilti::Expression > ()); }
#line 4004 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 212: // opt_unit_field_condition: %empty
#line 759 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 4010 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 213: // opt_unit_field_sinks: ARROW exprs
#line 762 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as < std::vector<hilti::Expression> > ()); }
#line 4016 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 214: // opt_unit_field_sinks: %empty
#line 763 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4022 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 215: // opt_unit_item_hooks: unit_hooks
#line 766 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::Hook> > () = std::move(yystack_[0].value.as < std::vector<spicy::Hook> > ()); }
#line 4028 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 216: // opt_unit_item_hooks: ';'
#line 767 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::Hook> > () = std::vector<spicy::Hook>(); }
#line 4034 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 217: // unit_hooks: unit_hooks unit_hook
#line 769 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::Hook> > () = std::move(yystack_[1].value.as < std::vector<spicy::Hook> > ()); yylhs.value.as < std::vector<spicy::Hook> > ().push_back(std::move(yystack_[0].value.as < spicy::Hook > ())); }
#line 4040 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 218: // unit_hooks: unit_hook
#line 770 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::Hook> > () = std::vector<spicy::Hook>{std::move(yystack_[0].value.as < spicy::Hook > ())}; }
#line 4046 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 219: // unit_hook: opt_unit_hook_params opt_unit_hook_attributes opt_hook_engine braced_block
#line 773 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Hook > () = spicy::Hook(std::move(yystack_[3].value.as < std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[0].value.as < hilti::Statement > ()), std::move(yystack_[1].value.as < spicy::Engine > ()), std::move(yystack_[2].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4052 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 220: // opt_unit_hook_params: '(' opt_func_params ')'
#line 776 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as < std::vector<hilti::type::function::Parameter> > ()); }
#line 4058 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 221: // opt_unit_hook_params: %empty
#line 777 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 4064 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 222: // opt_unit_hook_attributes: opt_unit_hook_attributes unit_hook_attribute
#line 781 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), yystack_[0].value.as < hilti::Attribute > ()); }
#line 4070 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 223: // opt_unit_hook_attributes: %empty
#line 782 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::AttributeSet> > () = {}; }
#line 4076 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 224: // $@4: %empty
#line 784 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->enableHookIDMode(); }
#line 4082 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 225: // $@5: %empty
#line 786 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->disableHookIDMode(); }
#line 4088 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 226: // unit_hook_id: $@4 "hook identifier" $@5
#line 786 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                               { yylhs.value.as < hilti::ID > () = hilti::ID(hilti::util::replace(yystack_[1].value.as < std::string > (), "%", "0x25_"), __loc__); }
#line 4094 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 227: // unit_hook_attribute: FOREACH
#line 789 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Attribute > () = hilti::Attribute("foreach", __loc__); }
#line 4100 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 228: // unit_hook_attribute: PRIORITY '=' expr
#line 790 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Attribute > () = hilti::Attribute("priority", std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4106 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 229: // unit_hook_attribute: "property"
#line 791 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { if ( yystack_[0].value.as < std::string > () != "%debug" ) error(yylhs.location, "unexpected hook property, only %debug permitted");
                                                   yylhs.value.as < hilti::Attribute > () = hilti::Attribute("%debug", __loc__);
                                                 }
#line 4114 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 230: // opt_hook_engine: HOOK_COMPOSE
#line 796 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::Composer; }
#line 4120 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 231: // opt_hook_engine: HOOK_PARSE
#line 797 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::Parser; }
#line 4126 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 232: // opt_hook_engine: %empty
#line 798 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::Engine > () = spicy::Engine::Parser; }
#line 4132 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 233: // unit_switch: SWITCH opt_unit_switch_expr '{' unit_switch_cases '}' opt_attributes opt_unit_field_condition ';'
#line 801 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::Item > () = spicy::type::unit::item::Switch(std::move(yystack_[6].value.as < std::optional<hilti::Expression> > ()), std::move(yystack_[4].value.as < std::vector<spicy::type::unit::item::switch_::Case> > ()), spicy::Engine::All, std::move(yystack_[1].value.as < std::optional<hilti::Expression> > ()), {}, std::move(yystack_[2].value.as < std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4138 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 234: // opt_unit_switch_expr: '(' expr ')'
#line 803 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as < hilti::Expression > ()); }
#line 4144 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 235: // opt_unit_switch_expr: %empty
#line 804 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::optional<hilti::Expression> > () = {}; }
#line 4150 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 236: // unit_switch_cases: unit_switch_cases unit_switch_case
#line 808 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::item::switch_::Case> > () = std::move(yystack_[1].value.as < std::vector<spicy::type::unit::item::switch_::Case> > ()); yylhs.value.as < std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case > ())); }
#line 4156 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 237: // unit_switch_cases: unit_switch_case
#line 809 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<spicy::type::unit::item::switch_::Case> > () = std::vector<spicy::type::unit::item::switch_::Case>(); yylhs.value.as < std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case > ())); }
#line 4162 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 238: // unit_switch_case: exprs ARROW '{' unit_items '}'
#line 812 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[4].value.as < std::vector<hilti::Expression> > (), yystack_[1].value.as < std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 4168 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 239: // unit_switch_case: '*' ARROW '{' unit_items '}'
#line 813 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[1].value.as < std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 4174 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 240: // unit_switch_case: exprs ARROW unit_item
#line 814 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[2].value.as < std::vector<hilti::Expression> > (), {yystack_[0].value.as < spicy::type::unit::Item > ()}, __loc__); }
#line 4180 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 241: // unit_switch_case: '*' ARROW unit_item
#line 815 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(std::vector<type::unit::Item>{yystack_[0].value.as < spicy::type::unit::Item > ()}, __loc__); }
#line 4186 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 242: // unit_switch_case: ARROW unit_field
#line 816 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[0].value.as < spicy::type::unit::Item > (), __loc__); }
#line 4192 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 243: // $@6: %empty
#line 823 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->enableExpressionMode(); }
#line 4198 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 244: // $@7: %empty
#line 825 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
              { driver->disableExpressionMode(); }
#line 4204 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 245: // expr: $@6 expr_0 $@7
#line 826 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[1].value.as < hilti::Expression > ()); }
#line 4210 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 246: // opt_exprs: exprs
#line 829 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as < std::vector<hilti::Expression> > ()); }
#line 4216 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 247: // opt_exprs: %empty
#line 830 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 4222 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 248: // exprs: exprs ',' expr
#line 832 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as < std::vector<hilti::Expression> > ()); yylhs.value.as < std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 4228 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 249: // exprs: expr
#line 833 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4234 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 250: // expr_0: expr_1
#line 835 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4240 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 251: // expr_1: expr_2 '=' expr_1
#line 838 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4246 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 252: // expr_1: expr_2 MINUSASSIGN expr_1
#line 839 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4252 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 253: // expr_1: expr_2 PLUSASSIGN expr_1
#line 840 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4258 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 254: // expr_1: expr_2 TIMESASSIGN expr_1
#line 841 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4264 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 255: // expr_1: expr_2 DIVIDEASSIGN expr_1
#line 842 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4270 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 256: // expr_1: expr_2 '?' expr ':' expr
#line 843 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as < hilti::Expression > ()), std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4276 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 257: // expr_1: expr_2
#line 844 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4282 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 258: // expr_2: expr_2 OR expr_3
#line 846 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4288 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 259: // expr_2: expr_3
#line 847 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4294 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 260: // expr_3: expr_3 AND expr_4
#line 849 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4300 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 261: // expr_3: expr_4
#line 850 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4306 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 262: // expr_4: expr_4 EQ expr_5
#line 852 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4312 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 263: // expr_4: expr_4 NEQ expr_5
#line 853 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4318 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 264: // expr_4: expr_5
#line 854 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4324 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 265: // expr_5: expr_5 '<' expr_6
#line 856 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4330 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 266: // expr_5: expr_5 '>' expr_6
#line 857 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4336 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 267: // expr_5: expr_5 GEQ expr_6
#line 858 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4342 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 268: // expr_5: expr_5 LEQ expr_6
#line 859 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4348 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 269: // expr_5: expr_6
#line 860 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4354 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 270: // expr_6: expr_6 '|' expr_7
#line 862 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4360 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 271: // expr_6: expr_7
#line 863 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4366 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 272: // expr_7: expr_7 '^' expr_8
#line 865 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4372 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 273: // expr_7: expr_8
#line 866 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4378 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 274: // expr_8: expr_8 '&' expr_9
#line 868 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4384 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 275: // expr_8: expr_9
#line 869 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4390 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 276: // expr_9: expr_9 SHIFTLEFT expr_a
#line 871 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4396 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 277: // expr_9: expr_9 SHIFTRIGHT expr_a
#line 872 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4402 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 278: // expr_9: expr_a
#line 873 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4408 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 279: // expr_a: expr_a '+' expr_b
#line 875 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4414 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 280: // expr_a: expr_a '-' expr_b
#line 876 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4420 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 281: // expr_a: expr_b
#line 877 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4426 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 282: // expr_b: expr_b '%' expr_c
#line 879 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4432 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 283: // expr_b: expr_b '*' expr_c
#line 880 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4438 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 284: // expr_b: expr_b '/' expr_c
#line 881 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4444 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 285: // expr_b: expr_b POW expr_c
#line 882 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4450 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 286: // expr_b: expr_c
#line 883 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4456 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 287: // expr_c: '!' expr_c
#line 885 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 4462 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 288: // expr_c: '*' expr_c
#line 886 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4468 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 289: // expr_c: '~' expr_c
#line 887 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4474 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 290: // expr_c: '|' expr_c '|'
#line 888 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4480 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 291: // expr_c: MINUSMINUS expr_c
#line 889 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4486 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 292: // expr_c: PLUSPLUS expr_c
#line 890 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4492 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 293: // expr_c: expr_d
#line 891 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4498 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 294: // expr_d: expr_d '(' opt_exprs ')'
#line 893 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 4504 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 295: // expr_d: expr_d '.' member_expr
#line 894 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4510 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 296: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 895 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 4516 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 297: // expr_d: expr_d '[' expr ']'
#line 896 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4522 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 298: // expr_d: expr_d HASATTR member_expr
#line 897 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4528 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 299: // expr_d: expr_d IN expr_d
#line 898 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4534 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 300: // expr_d: expr_d NOT_IN expr_d
#line 899 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__)); }
#line 4540 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 301: // expr_d: expr_d MINUSMINUS
#line 900 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4546 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 302: // expr_d: expr_d PLUSPLUS
#line 901 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4552 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 303: // expr_d: expr_d TRYATTR member_expr
#line 902 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression > ()), std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4558 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 304: // expr_d: expr_e
#line 903 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4564 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 305: // expr_e: CAST type_param_begin type type_param_end '(' expr ')'
#line 905 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                                         { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as < hilti::Type > ()))}, __loc__); }
#line 4570 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 306: // expr_e: BEGIN_ '(' expr ')'
#line 906 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4576 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 307: // expr_e: END_ '(' expr ')'
#line 907 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression > ())}, __loc__); }
#line 4582 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 308: // expr_e: NEW ctor
#line 908 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 4588 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 309: // expr_e: NEW scoped_id
#line 909 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 4594 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 310: // expr_e: NEW scoped_id '(' opt_exprs ')'
#line 910 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[3].value.as < hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 4600 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 311: // expr_e: expr_f
#line 911 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4606 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 312: // expr_f: ctor
#line 913 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as < hilti::Ctor > ()), __loc__); }
#line 4612 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 313: // expr_f: PORT '(' expr ',' expr ')'
#line 914 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::builder::port(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4618 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 314: // expr_f: '-' expr_g
#line 915 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression > ())}, __loc__); }
#line 4624 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 315: // expr_f: '[' expr FOR local_id IN expr ']'
#line 917 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::Expression > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4630 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 316: // expr_f: '[' expr FOR local_id IN expr IF expr ']'
#line 919 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as < hilti::Expression > ()), std::move(yystack_[7].value.as < hilti::Expression > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression > ()),  __loc__); }
#line 4636 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 317: // expr_f: expr_g
#line 920 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4642 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 318: // expr_g: '(' expr ')'
#line 922 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as < hilti::Expression > ())); }
#line 4648 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 319: // expr_g: scoped_id
#line 923 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4654 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 320: // expr_g: DOLLARDOLLAR
#line 924 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedID(std::move("__dd"), __loc__);}
#line 4660 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 321: // expr_g: "$<N>"
#line 925 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { // $N -> $@[N] (with $@ being available internally only, not exposed to users)
                                                   auto captures = hilti::expression::Keyword(hilti::expression::keyword::Kind::Captures, hilti::builder::typeByID("hilti::Captures"), __loc__);
                                                   auto index = hilti::expression::Ctor(hilti::ctor::UnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__), __loc__);
                                                   yylhs.value.as < hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(captures), std::move(index)}, __loc__);
                                                 }
#line 4670 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 322: // member_expr: local_id
#line 931 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4676 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 323: // ctor: "address value"
#line 935 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4682 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 324: // ctor: "address value" '/' "unsigned integer value"
#line 936 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 4688 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 325: // ctor: "bool value"
#line 937 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as < bool > (), __loc__); }
#line 4694 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 326: // ctor: "bytes value"
#line 938 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4700 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 327: // ctor: "port value"
#line 939 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4706 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 328: // ctor: "null value"
#line 940 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 4712 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 329: // ctor: "string value"
#line 941 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as < std::string > (), __loc__); }
#line 4718 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 330: // ctor: const_real
#line 943 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as < double > (), __loc__); }
#line 4724 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 331: // ctor: "unsigned integer value"
#line 944 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 4730 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 332: // ctor: '+' "unsigned integer value"
#line 945 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__), 64, __loc__); }
#line 4736 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 333: // ctor: '-' "unsigned integer value"
#line 946 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__), 64, __loc__); }
#line 4742 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 334: // ctor: OPTIONAL '(' expr ')'
#line 947 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as < hilti::Expression > ()), __loc__); }
#line 4748 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 335: // ctor: INTERVAL '(' const_real ')'
#line 948 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as < double > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4756 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 336: // ctor: INTERVAL '(' const_sint ')'
#line 951 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as < int64_t > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4764 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 337: // ctor: INTERVAL_NS '(' const_sint ')'
#line 954 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as < int64_t > (), hilti::rt::Interval::NanosecondTag()), __loc__); }
#line 4770 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 338: // ctor: TIME '(' const_real ')'
#line 955 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as < double > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4778 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 339: // ctor: TIME '(' const_uint ')'
#line 958 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { try { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as < uint64_t > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 4786 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 340: // ctor: TIME_NS '(' const_uint ')'
#line 961 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as < uint64_t > (), hilti::rt::Time::NanosecondTag()), __loc__); }
#line 4792 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 341: // ctor: "stream" '(' "bytes value" ')'
#line 962 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Stream(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 4798 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 342: // ctor: UINT8 '(' const_uint ')'
#line 964 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as < uint64_t > (), 8, __loc__); }
#line 4804 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 343: // ctor: UINT16 '(' const_uint ')'
#line 965 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as < uint64_t > (), 16, __loc__); }
#line 4810 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 344: // ctor: UINT32 '(' const_uint ')'
#line 966 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as < uint64_t > (), 32, __loc__); }
#line 4816 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 345: // ctor: UINT64 '(' const_uint ')'
#line 967 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as < uint64_t > (), 64, __loc__); }
#line 4822 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 346: // ctor: INT8 '(' const_sint ')'
#line 968 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as < int64_t > (), 8, __loc__); }
#line 4828 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 347: // ctor: INT16 '(' const_sint ')'
#line 969 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as < int64_t > (), 16, __loc__); }
#line 4834 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 348: // ctor: INT32 '(' const_sint ')'
#line 970 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as < int64_t > (), 32, __loc__); }
#line 4840 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 349: // ctor: INT64 '(' const_sint ')'
#line 971 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as < int64_t > (), 64, __loc__); }
#line 4846 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 350: // ctor: list
#line 973 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4852 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 351: // ctor: map
#line 974 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4858 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 352: // ctor: regexp
#line 975 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4864 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 353: // ctor: set
#line 976 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4870 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 354: // ctor: struct_
#line 977 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4876 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 355: // ctor: tuple
#line 978 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4882 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 356: // ctor: vector
#line 979 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = std::move(yystack_[0].value.as < hilti::Ctor > ()); }
#line 4888 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 357: // const_real: "real value"
#line 982 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = yystack_[0].value.as < double > (); }
#line 4894 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 358: // const_real: '+' "real value"
#line 983 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = yystack_[0].value.as < double > (); }
#line 4900 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 359: // const_real: '-' "real value"
#line 984 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < double > () = -yystack_[0].value.as < double > (); }
#line 4906 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 360: // const_sint: "unsigned integer value"
#line 986 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4912 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 361: // const_sint: '+' "unsigned integer value"
#line 987 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4918 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 362: // const_sint: '-' "unsigned integer value"
#line 988 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < int64_t > () = -check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__); }
#line 4924 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 363: // const_uint: "unsigned integer value"
#line 990 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4930 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 364: // const_uint: '+' "unsigned integer value"
#line 991 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4936 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 365: // tuple: '(' opt_tuple_elems1 ')'
#line 993 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4942 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 366: // tuple: TUPLE '(' opt_exprs ')'
#line 994 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 4948 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 367: // opt_tuple_elems1: tuple_elem
#line 997 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4954 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 368: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 998 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4960 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 369: // opt_tuple_elems1: %empty
#line 999 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4966 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 370: // opt_tuple_elems2: tuple_elem
#line 1002 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4972 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 371: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 1003 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as < hilti::Expression > ())}; yylhs.value.as < std::vector<hilti::Expression> > ().insert(yylhs.value.as < std::vector<hilti::Expression> > ().end(), yystack_[0].value.as < std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as < std::vector<hilti::Expression> > ().end()); }
#line 4978 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 372: // opt_tuple_elems2: tuple_elem
#line 1004 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as < hilti::Expression > ())}; }
#line 4984 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 373: // opt_tuple_elems2: %empty
#line 1005 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 4990 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 374: // tuple_elem: expr
#line 1008 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = std::move(yystack_[0].value.as < hilti::Expression > ()); }
#line 4996 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 375: // tuple_elem: NONE
#line 1009 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Expression > () = hilti::expression::Ctor(hilti::ctor::Null(__loc__), __loc__); }
#line 5002 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 376: // list: '[' opt_exprs ']'
#line 1011 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5008 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 377: // list: LIST '(' opt_exprs ')'
#line 1012 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5014 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 378: // list: LIST type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 1014 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5020 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 379: // vector: VECTOR '(' opt_exprs ')'
#line 1016 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5026 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 380: // vector: VECTOR type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 1018 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5032 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 381: // set: SET '(' opt_exprs ')'
#line 1020 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5038 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 382: // set: SET type_param_begin type type_param_end '(' opt_tuple_elems1 ')'
#line 1022 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::Expression> > ()), __loc__); }
#line 5044 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 383: // map: MAP '(' opt_map_elems ')'
#line 1024 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 5050 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 384: // map: MAP type_param_begin type ',' type type_param_end '(' opt_map_elems ')'
#line 1026 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as < hilti::Type > ()), std::move(yystack_[4].value.as < hilti::Type > ()), std::move(yystack_[1].value.as < std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 5056 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 385: // struct_: '[' struct_elems ']'
#line 1028 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as < std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 5062 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 386: // struct_elems: struct_elems ',' struct_elem
#line 1031 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field > ()); }
#line 5068 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 387: // struct_elems: struct_elem
#line 1032 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field > ()) }; }
#line 5074 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 388: // struct_elem: "$-identifier" '=' expr
#line 1034 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(hilti::ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[0].value.as < hilti::Expression > ())); }
#line 5080 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 389: // regexp: re_patterns
#line 1036 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[0].value.as < std::vector<std::string> > ()), {}, __loc__); }
#line 5086 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 390: // re_patterns: re_patterns '|' re_pattern_constant
#line 1039 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 5092 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 391: // re_patterns: re_pattern_constant
#line 1040 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 5098 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 392: // $@8: %empty
#line 1043 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                    { driver->enablePatternMode(); }
#line 5104 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 393: // $@9: %empty
#line 1043 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                             { driver->disablePatternMode(); }
#line 5110 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 394: // re_pattern_constant: '/' $@8 "regular expression value" $@9 '/'
#line 1044 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 5116 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 395: // opt_map_elems: map_elems
#line 1046 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as < std::vector<hilti::ctor::map::Element> > ()); }
#line 5122 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 396: // opt_map_elems: %empty
#line 1047 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 5128 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 397: // map_elems: map_elems ',' map_elem
#line 1049 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as < std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 5134 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 398: // map_elems: map_elem
#line 1050 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as < std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element > ())); }
#line 5140 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 399: // map_elem: expr ':' expr
#line 1052 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                 { yylhs.value.as < hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as < hilti::Expression > (), yystack_[0].value.as < hilti::Expression > ()); }
#line 5146 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 400: // attribute: "attribute"
#line 1056 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5152 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 401: // attribute: "attribute" '=' expr
#line 1057 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[0].value.as < hilti::Expression > ()), __loc__); }
#line 5158 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 402: // opt_attributes: opt_attributes attribute
#line 1060 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as < std::optional<hilti::AttributeSet> > (), yystack_[0].value.as < hilti::Attribute > ()); }
#line 5164 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 403: // opt_attributes: %empty
#line 1061 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
                                                { yylhs.value.as < std::optional<hilti::AttributeSet> > () = {}; }
#line 5170 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"
    break;


#line 5174 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -790;

  const short Parser::yytable_ninf_ = -397;

  const short
  Parser::yypact_[] =
  {
     154,   -38,  -790,    71,   131,  -790,  -790,  -790,  1175,  -790,
    -790,   -57,  -790,  -790,  -790,   -17,  -790,  -790,  -790,  -790,
    -790,  -790,    13,    91,  -790,   121,   129,   157,   168,   204,
     215,   228,    27,   140,  1175,  1740,   267,  1175,   303,   141,
     305,   315,   323,   337,   354,   363,   370,   373,   180,   -49,
    1175,     9,  1175,   409,    58,  -790,  1175,  1175,  -790,  -790,
    -790,  -790,   360,   321,    -4,   188,   198,   237,   253,   336,
     293,   -47,  -790,   432,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,  -790,   330,  -790,  -790,   391,
    -790,  -790,  2056,  -790,    56,    56,    56,    56,    36,    56,
     273,  2056,   377,  2056,  -790,   -49,     9,   439,   379,  -790,
    -790,  -790,  -790,   273,  2056,   485,    42,     0,   273,     0,
       0,     0,     0,   273,  2056,  -790,   381,   382,   383,  -790,
     386,   477,   378,   387,   -64,  -790,   380,  -790,  -790,  -790,
    -790,  -790,  -790,   523,  -790,  -790,  -790,  1175,  1175,  1175,
    1175,  1175,  1175,  -790,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,   131,  1644,  -790,  1644,  -790,   131,   273,  -790,
     131,   374,  1973,  -790,   392,  -790,  -790,   395,  -790,  -790,
    -790,   393,  -790,  -790,  -790,  -790,  -790,    91,    91,   397,
      91,  -790,    91,  -790,  -790,    91,  -790,  -790,  -790,   399,
    -790,    91,  -790,  -790,  -790,  -790,   398,    91,    91,  -790,
    -790,  -790,  -790,  -790,   -81,  -790,  -790,  -790,  -790,  -790,
     403,  -790,   529,   537,   408,   410,   412,   413,   449,   451,
     415,   416,   419,  -790,   420,   -81,   411,   422,   425,  -790,
     165,  -790,   273,   427,   428,   430,   -81,   433,  -790,   456,
     559,   441,   444,   562,   445,   447,   450,   452,   453,   455,
     457,   -81,  -790,  -790,   -29,  -790,   131,  -790,  -790,   589,
    -790,  -790,   459,  -790,  -790,  -790,   321,  -790,  -790,  -790,
     458,    -4,   188,   188,   198,   198,   198,   198,   237,   253,
     336,   293,   293,   -47,   -47,  -790,  -790,  -790,  -790,  -790,
    -790,   528,   582,  -790,   461,   454,   469,  -790,   338,  -790,
    -790,  -790,   475,   480,  -790,   474,   479,   131,   482,  -790,
     483,  -790,  -790,   486,   487,   489,   488,   490,  -790,  -790,
     491,  -790,   846,  1012,  -790,  -790,  -790,  -790,  -790,  -790,
      83,  -790,  -790,   493,  -790,  -790,     0,   131,  2056,  2056,
     621,  2056,  2056,  2056,  -790,  1854,    33,   492,  2056,  2056,
     211,  -790,   494,  -790,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,   496,  -790,  -790,  -790,  2056,   498,
    -790,  -790,  -790,   497,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,   501,  -790,   343,  -790,   571,
    -790,  -790,   500,  -790,  -790,  -790,   273,  -790,  2271,   182,
     230,   507,  -790,  -790,   508,   131,   574,   -18,   348,   510,
     653,   521,  -790,   522,  -790,   574,  -790,  -790,   526,   530,
     574,   482,  -790,   482,   482,  -790,   534,  -790,   519,   527,
     247,  -790,   -81,   -81,   531,   200,   -81,   -81,    21,   532,
     536,   533,   126,  -790,  -790,   539,   540,  -790,   131,    18,
     -81,   -81,  -790,   -49,  -790,  -790,   -81,  -790,   543,   -49,
     -49,   -29,  -790,  -790,  -790,   544,   549,   553,  -790,  -790,
    -790,  -790,  -790,  -790,   612,   131,   187,   550,  -790,  -790,
    -790,  2056,    33,  -790,  -790,  -790,  -790,  -790,   552,   554,
    -790,  -790,   210,   556,   351,   693,   358,   561,  -790,  -790,
     689,   131,  -790,  -790,  -790,  -790,  2056,  -790,  -790,  -790,
     564,  -790,  -790,  2056,  2056,  -790,  -790,   643,   567,   569,
    -790,   131,   572,   131,  -790,   103,   565,  -790,  -790,  -790,
    -790,  -790,  -790,   -26,  -790,  -790,  -790,   575,   576,   573,
    -790,   583,   586,  -790,   -32,  -790,  -790,  -790,   578,   593,
    -790,   361,  -790,  2188,  2188,   595,   724,   596,   -15,   597,
     241,  -790,   591,   601,  -790,  2188,  2188,  -790,  2056,  -790,
     482,  -790,  2056,  2056,   602,  -790,  -790,   -81,  2056,   533,
    -790,  -790,  2056,  2364,    24,   510,  -790,  -790,   603,   600,
    -790,  -790,  -790,  -790,  -790,  1491,  -790,  -790,   377,  -790,
    -790,  -790,  -790,  -790,  -790,   599,  -790,  2056,   606,   703,
    -790,  -790,     4,   705,  -790,  -790,   706,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,  -790,  -790,   613,  -790,   609,
     102,   102,   618,  -790,  -790,   617,   -55,   620,   624,   111,
     533,   131,  -790,   533,    -3,   626,  -790,   627,  -790,  -790,
    -790,    29,   623,    55,  2056,   628,   629,   630,   631,   632,
     140,   183,   141,   633,   634,   192,   635,   636,   637,   639,
     180,  1338,   640,   638,   638,   625,   641,  2188,  -790,   120,
    2188,   644,  2099,  -790,  2188,  -790,  -790,  -790,   645,  -790,
    -790,  -790,   642,     8,  -790,    88,  2188,  -790,  -790,    33,
    -790,  -790,  -790,    57,   646,   648,   131,  -790,    70,  -790,
    -790,  -790,    79,  -790,  -790,  -790,   770,   763,    12,  -790,
       7,    -3,  2056,  2056,  2056,   649,   638,   652,   649,   273,
     638,   651,  -790,  -790,  -790,  -790,  -790,  -790,  -790,   747,
    -790,  -790,  -790,  -790,  -790,   245,  2188,  -790,  -790,  -790,
    -790,   657,   658,   667,  -790,     0,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,   172,  -790,  -790,   203,  -790,   258,   -81,
     -81,   638,   649,   638,  -790,   665,  -790,  -790,   661,    52,
      52,  -790,  -790,  2188,  -790,  -790,   668,  -790,   767,   274,
    -790,    52,   340,  -790,    86,  2056,   673,   678,  -790,  -790,
    -790,   817,  -790,    52,  -790,   680,   800,   800,  -790,  2056,
    -790,  -790,     0,    87,   144,   685,   173,  -790,   -81,   817,
     817,    52,   800,  -790,  -790,   269,   269,   533,    20,  -790,
    -790,  -790,  -790,  -790,   683,   800,   269,   686,   387,  -790,
    -790,   161,  -790,  -790,  -790,   101,   269,  -790,  -790,  -790,
    -790,  -790
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,   243,     0,     0,     2,     3,     4,     0,     1,
       6,     0,     8,   329,   326,   323,   327,   357,   331,   321,
     325,   328,     0,     0,   320,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   243,
       0,   243,     0,     0,     0,   392,     0,     0,     7,   319,
     244,   250,   257,   259,   261,   264,   269,   271,   273,   275,
     278,   281,   286,   293,   304,   311,   317,   312,   330,   355,
     350,   356,   353,   351,   354,   352,   389,   391,    14,     0,
     243,   146,     0,   243,     0,     0,     0,     0,     0,     0,
     243,     0,   243,     0,   291,   243,   243,     0,   309,   308,
     243,   292,   243,   243,     0,     0,     0,     0,   243,     0,
       0,     0,     0,   243,     0,   375,   374,     0,   367,   288,
       0,   249,     0,   246,     0,   387,     0,   358,   332,   359,
     333,   243,   314,     0,   287,   289,   245,     0,     0,     0,
       0,     0,     0,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   301,     0,   302,     0,   243,   243,
       0,     0,   243,   324,     0,   106,   105,     0,   107,   108,
     112,     0,   119,   120,   121,   118,   109,     0,     0,     0,
       0,   110,     0,   111,   113,     0,   133,   114,   115,     0,
     116,     0,   123,   124,   125,   122,   175,     0,     0,   117,
     145,   141,   144,   143,     0,   135,   136,   137,   138,   139,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   249,     0,     0,     0,     0,   395,   398,
       0,   374,   243,     0,     0,     0,     0,     0,   363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   318,   365,   243,   243,     0,   376,   243,     0,
     385,   290,     0,   393,   255,   252,   258,   253,   254,   251,
       0,   260,   262,   263,   267,   268,   265,   266,   270,   272,
     274,   276,   277,   279,   280,   285,   283,   282,   284,   322,
     298,   299,   300,   303,     0,     0,   295,   390,     0,   243,
     243,   243,     0,     0,   243,     0,     0,     0,     0,   224,
     243,    42,    41,   243,     0,     0,     0,     0,   243,   243,
       0,    12,    15,    16,   101,    17,    18,    19,    20,    21,
       0,    13,    69,     0,   104,   306,     0,     0,     0,     0,
       0,     0,     0,     0,   157,     0,    50,     0,     0,     0,
     140,   147,     0,   307,   361,   362,   347,   348,   349,   346,
     335,   336,   337,   377,     0,   243,   383,   243,     0,     0,
     334,   243,   381,     0,   341,   364,   338,   339,   340,   366,
     343,   344,   345,   342,   379,     0,   368,   370,   388,     0,
     248,   386,     0,   243,   294,   297,   243,    37,   243,     0,
       0,     0,    74,    75,     0,     0,   243,     0,     0,   221,
       0,     0,    81,     0,    83,   243,    87,    88,     0,     0,
     243,     0,    46,     0,     0,    33,     0,    68,     0,   163,
       0,   162,     0,     0,     0,     0,     0,     0,     0,     0,
       7,   153,     0,   152,    57,     0,    49,    52,     0,   200,
       0,     0,   243,   243,   399,   397,     0,   310,     0,   243,
     243,   243,   243,   394,   256,     0,     0,     0,    70,   243,
      72,   243,    92,    93,     0,     0,     0,     0,     9,    35,
     243,     0,    50,    40,   223,   225,    80,    82,     0,     0,
      84,    94,     0,     0,     0,    48,     0,     0,    34,   165,
       0,   161,   159,   127,   126,   134,     0,   128,   131,   155,
       0,   156,   148,     0,   151,   149,   174,    58,     0,   403,
     224,     0,   235,     0,   199,   200,     0,   177,   181,   184,
     183,   180,   182,   204,   185,   132,   129,     0,     0,     0,
     313,     0,     0,   371,     0,   296,    39,    38,     0,     0,
     243,     0,   243,   243,   243,     0,     0,     0,     0,     0,
     232,   226,     0,     0,   243,   243,   243,   243,     0,    47,
       0,   243,     0,     0,     0,   164,   160,     0,     0,   154,
     150,    51,     0,   243,     0,   221,   403,   243,     0,     0,
     176,   173,   201,   202,   203,     0,   305,   378,   243,   382,
     380,   243,   315,    71,    73,     0,   243,     0,     0,   243,
     102,   103,     0,    96,    61,    62,    96,    36,    10,    25,
      26,   243,   220,   229,   227,   230,   231,     0,   222,     0,
       0,     0,     0,    91,    90,     0,     0,     0,     0,     0,
     403,   168,   130,   403,    60,     0,   403,   400,   188,   402,
     198,     0,     0,   243,     0,   119,   120,   121,   118,   109,
       0,     0,     0,   114,   116,     0,   123,   124,   125,   122,
       0,   243,   206,   210,   210,     0,     0,   243,    29,     0,
     243,     0,   243,    67,   243,    78,    77,    11,     0,   243,
     219,   243,     0,     0,    98,     0,   243,    23,   243,    50,
      30,    31,   243,     0,     0,     0,   167,   170,     0,   243,
      53,   190,     0,   243,   187,   234,   200,     0,   243,   237,
       0,    60,     0,     0,     0,   206,   210,     0,   206,   243,
     210,   243,   209,   403,   403,   384,   316,    76,   243,    96,
      63,    66,    95,    27,   228,     0,   243,    86,    97,    85,
      89,     0,     0,     0,    22,     0,   166,   169,   158,    59,
     189,   401,   242,   200,   403,   236,   200,   403,     0,     0,
       0,   210,   206,   210,   403,     0,   403,   208,     0,   212,
     212,    28,    79,   243,   100,    24,    56,    32,   403,   200,
     241,   212,   200,   240,     0,     0,   131,   132,   403,   403,
     403,   195,   205,   212,   207,     0,   214,   214,    99,     0,
      55,   403,     0,     0,   200,     0,   200,   186,     0,   196,
     197,   212,   214,   243,   243,   221,   221,    54,    45,   403,
     172,   239,   233,   238,   130,   214,   221,     0,   213,   216,
     191,   215,   218,   192,    44,     0,   221,   193,   211,   217,
     171,   194
  };

  const short
  Parser::yypgoto_[] =
  {
    -790,  -790,  -790,  -790,     6,    19,  -790,  -790,  -790,  -790,
    -790,   650,   654,  -790,  -129,  -790,  -790,  -790,  -790,  -790,
     655,  -790,  -790,  -790,  -790,  -483,  -790,   298,  -790,  -790,
    -790,    89,  -506,  -634,  -790,  -790,  -179,  -610,   193,  -281,
    -790,  -790,   236,  -790,  -410,    60,   -10,  -225,  -790,  -790,
     311,  -790,  -790,  -790,  -790,  -790,   326,  -790,  -790,  -790,
    -790,   125,  -790,  -790,  -395,  -790,  -534,  -790,  -790,  -790,
     116,  -790,  -790,  -790,  -790,  -679,  -790,  -653,  -499,  -564,
    -789,  -790,  -420,  -790,  -790,   314,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,   118,    -2,  -790,  -790,   -88,  -655,  -790,
     292,  -790,   710,   716,   352,   243,   711,   709,   714,   350,
     355,   342,   262,  -790,  -790,   819,   250,   -34,   -35,   270,
    -115,  -790,  -323,   400,  -260,  -790,  -790,  -790,  -790,  -790,
    -790,   604,  -790,  -790,   698,  -790,  -790,   256,  -790,   504,
    -790,  -561
  };

  const short
  Parser::yydefgoto_[] =
  {
      -1,     3,     6,     5,    58,    59,   575,   576,   707,   182,
     341,   630,   631,   344,   496,   345,   346,   347,   348,   349,
     632,   445,   446,   515,   590,   465,   466,   467,   830,   831,
     468,   730,   633,   634,   701,   702,   635,   705,   713,   714,
     352,   353,   221,   222,   223,   461,   362,   372,   225,   462,
     463,   226,   458,   531,   227,   450,   451,   228,   594,   725,
     726,   727,   229,   367,   545,   546,   547,   548,   549,   550,
     551,   747,   552,   553,   615,   750,   752,   753,   826,   845,
     860,   861,   862,   504,   580,   429,   430,   581,   648,   649,
     554,   608,   738,   739,   243,     8,   146,   132,   133,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,   310,    77,    78,   234,
     262,    79,   127,   406,   128,    80,    81,    82,    83,    84,
     134,   135,    85,    86,    87,   143,   412,   247,   248,   249,
     669,   604
  };

  const short
  Parser::yytable_[] =
  {
       7,   109,   264,   351,   266,   267,   268,   269,   486,   503,
      11,   610,   244,    92,   407,   710,   130,   258,   740,   579,
     384,    10,   101,   103,    10,   255,   706,   539,   667,   114,
     265,   393,   667,   621,   786,   270,   -58,   667,   124,   736,
     498,   754,   441,   711,   125,   671,   405,   126,   155,   131,
       4,   712,    17,   231,   108,   168,   765,   863,    17,   258,
     667,    10,    12,   240,   125,   667,   791,   867,   636,   794,
     370,     9,   371,   231,   139,   140,    19,   871,   667,   653,
     654,   261,   736,   740,   279,   156,    88,   667,   184,   718,
     314,   230,   280,   792,   667,   667,   370,   796,  -369,   723,
     246,   464,   728,   251,    24,   732,    10,   169,   253,   667,
     254,   220,   539,   819,   540,   170,   171,   825,  -373,   612,
     220,   441,   220,   711,   622,   499,   613,   614,   640,   641,
     541,   712,   444,   220,    10,   542,   370,   711,   818,   282,
     820,   729,   442,   220,   443,   712,    89,    10,   370,   802,
     558,   290,   224,   539,   543,   278,   561,   562,   767,    90,
     263,   245,   784,   250,   389,  -247,   737,   668,  -179,   629,
    -215,   529,   734,   100,   256,    10,    10,   315,   309,    91,
     354,   539,   539,   309,   271,   670,   309,   358,   359,   858,
     361,   757,   799,   800,   759,   363,   238,   239,   762,   540,
     774,   365,   259,   260,   141,   693,    10,   368,   369,   737,
     770,   444,   539,   778,   864,   541,   232,   233,  -221,  -140,
     542,   407,   780,   811,  -221,  -221,   814,   523,   524,   837,
     850,   527,   528,   821,   532,   823,   772,   535,   769,   543,
     540,   448,   431,    91,   870,   555,   556,   833,   157,   810,
     643,   559,   813,  -178,   721,   722,   541,   839,   840,   841,
     804,   542,   370,   846,   758,  -221,   158,    93,   540,   540,
     848,   370,   251,   408,   534,    94,   410,    10,   856,   371,
     543,   746,   409,   539,   541,   541,   102,   113,   865,   542,
     542,   866,    91,    91,   851,     1,     2,   828,   644,   540,
     610,   827,   610,    95,   645,   646,   508,   502,   543,   543,
    -221,   512,   835,   388,    96,   541,   370,   419,   420,   421,
     542,   809,   424,   853,   842,   488,   123,   489,   485,   110,
     572,   433,    91,   427,   573,    91,   438,   439,   118,   543,
     159,   160,   855,    10,    91,   647,   154,   428,   526,   539,
      97,   370,   812,   584,  -140,  -140,   161,   585,  -140,  -140,
    -140,    98,  -140,   449,  -140,   235,   236,   237,   241,   242,
     540,   460,   662,   490,    99,   491,   104,   220,   220,   111,
     220,   220,   220,   474,   220,   246,   541,   220,   220,   478,
     803,   542,   129,   278,   136,   521,   162,   522,   144,   145,
     294,   295,   296,   297,   163,   147,   815,   220,   183,   370,
     543,   484,   859,   110,   834,   502,   487,   836,   452,   453,
    -247,   455,   456,   457,   497,   137,   138,   313,   470,   471,
     316,   494,   768,   509,   768,   311,   540,   312,   513,   284,
     285,   869,   287,   288,   289,   148,   164,   165,   476,   112,
     703,   115,   541,   166,   167,   139,   140,   542,   149,   150,
     514,   116,   516,   517,   530,   137,   374,   139,   375,   117,
     557,   251,   137,   395,   538,   544,   543,   251,   251,   251,
     564,   417,   418,   118,   151,    10,    12,   568,   181,   569,
    -370,   481,   500,   501,   172,   587,   588,   257,   577,   173,
     119,   571,   591,   592,   152,   626,   627,   292,   293,   120,
     305,   306,   307,   308,   301,   302,   121,   153,   174,   122,
     220,   303,   304,   761,  -396,   252,   175,   449,   272,   273,
     275,   274,   176,   276,   277,   278,   283,    55,   281,   355,
     460,   356,   357,   360,   366,   220,   374,   606,   364,   609,
     373,   544,   220,   220,   375,   376,   385,   377,   177,   378,
     379,   578,   380,   381,   816,   817,   382,   383,   625,   386,
     628,   354,   354,   387,   390,   139,   391,   392,   178,   395,
     394,   694,   652,   354,   354,   655,   597,   179,   396,   658,
     172,   397,   398,   599,   399,   173,   130,   400,   180,   401,
     402,   666,   403,   413,   404,   672,   272,   220,   414,   657,
     415,   220,   220,   854,   174,   416,   246,   220,   422,   696,
     425,   220,   175,   423,   698,   426,  -247,   354,   176,   432,
     434,   436,   454,   437,   692,   435,   447,   440,   482,   708,
     472,   469,   473,   479,   172,   477,   220,   480,   656,   173,
     492,   493,   659,   660,   177,   495,   502,   748,   663,   505,
     808,   795,   664,   483,   506,   507,   519,   724,   174,   510,
     742,   520,   743,   511,   178,   365,   175,   518,   525,   570,
     744,   533,   176,   179,   370,   371,   536,   699,   537,   251,
     560,   565,   566,   220,   180,   354,   567,   574,   354,   582,
     354,   583,   354,   586,   589,   593,   595,   764,   177,   598,
     745,   464,   602,   603,   354,   611,   771,   849,   607,   618,
     773,   623,   616,   617,   319,   320,   321,   779,   178,   638,
     619,   781,   724,   620,   741,   322,   624,   179,   637,   639,
     650,   -43,   544,   323,   642,   674,   697,   324,   180,   798,
     651,   661,   673,   700,   704,   704,   801,   709,   629,   325,
     717,   220,   220,   220,   354,   716,   719,   720,   326,   731,
     735,   733,   755,    10,    94,    95,    96,    97,    98,   115,
     116,   119,   120,   121,   328,   122,   749,   766,   763,   544,
     783,   775,   544,   751,   760,   749,   704,   756,   776,   793,
     805,   354,   788,   789,   790,   806,   330,   797,   331,   332,
     807,   333,   822,   829,   832,   544,   334,   824,   544,   479,
     335,   336,   337,   338,   480,   667,   843,   844,   852,   618,
     787,   -43,   342,   868,   220,   601,   343,   350,   339,   665,
     544,   857,   544,   340,   715,   600,   -15,   596,   220,   -15,
     -15,   777,   782,   -65,   605,   -15,   785,   -15,   -15,   286,
     -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,
     291,   299,   298,   142,   695,   838,   -15,   300,   -15,   317,
       0,   563,   -15,   411,   -15,     0,   -15,     0,     0,   847,
     -15,   475,   -15,     0,     0,     0,   -15,     0,     0,     0,
       0,     0,   -15,     0,     0,   -15,     0,   -15,     0,     0,
       0,   -15,   -15,     0,     0,     0,   -15,   -15,   -15,   -15,
     -15,   -15,     0,     0,     0,     0,   -15,   -15,   -15,     0,
       0,     0,   -15,     0,     0,     0,     0,     0,   -15,     0,
       0,     0,   -15,   -15,     0,     0,   -15,   -15,     0,   -15,
       0,   -15,   -15,     0,   -15,   -15,     0,     0,     0,   -15,
     -15,     0,     0,   -15,   -15,   -15,   -15,   -15,   -15,     0,
       0,     0,     0,   -15,   -15,     0,   -15,   -15,   -15,   -15,
       0,   -15,     0,   -15,     0,     0,   -15,     0,     0,     0,
       0,     0,   -15,     0,     0,     0,     0,     0,     0,     0,
     -15,   -15,     0,     0,   -15,     0,   -15,   -15,     0,   -15,
     -15,   -15,   -16,     0,     0,   -16,   -16,     0,     0,     0,
       0,   -16,     0,   -16,   -16,     0,   -16,   -16,   -16,   -16,
     -16,   -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,
       0,     0,   -16,     0,   -16,     0,     0,     0,   -16,     0,
     -16,     0,   -16,     0,     0,     0,   -16,     0,   -16,     0,
       0,     0,   -16,     0,     0,     0,     0,     0,   -16,     0,
       0,   -16,     0,   -16,     0,     0,     0,   -16,   -16,     0,
       0,     0,   -16,   -16,   -16,   -16,   -16,   -16,     0,     0,
       0,     0,   -16,   -16,   -16,     0,     0,     0,   -16,     0,
       0,     0,     0,     0,   -16,     0,     0,     0,   -16,   -16,
       0,     0,   -16,   -16,     0,   -16,     0,   -16,   -16,     0,
     -16,   -16,     0,     0,     0,   -16,   -16,     0,     0,   -16,
     -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,   -16,
     -16,     0,   -16,   -16,   -16,   -16,     0,   -16,     0,   -16,
       0,     0,   -16,     0,     0,     0,     0,     0,   -16,     0,
       0,     0,     0,     0,     0,     0,   -16,   -16,     0,     0,
     -16,     0,   -16,   -16,     0,   -16,   -16,   -16,    10,    12,
       0,     0,     0,     0,     0,     0,    13,    14,     0,    15,
      16,    17,    18,    19,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,     0,     0,    25,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,    27,    28,    29,    30,
      31,     0,     0,     0,     0,    32,     0,    33,     0,     0,
       0,    34,     0,     0,     0,     0,     0,    35,     0,     0,
       0,     0,    36,     0,     0,    37,    38,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,    43,     0,     0,    44,    45,    46,    47,     0,
       0,     0,    48,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,    50,
      51,     0,     0,    52,     0,    53,    54,     0,    55,    56,
      57,    10,    12,     0,     0,     0,     0,     0,     0,    13,
      14,     0,    15,    16,    17,    18,     0,    20,    21,     0,
       0,     0,   185,     0,   186,     0,     0,   187,     0,   188,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   190,     0,     0,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   675,   676,
     677,   678,   679,    31,   197,   198,     0,   199,    32,     0,
     680,     0,     0,     0,     0,     0,     0,     0,     0,   201,
       0,   125,     0,     0,     0,   681,     0,     0,     0,   203,
       0,     0,     0,     0,     0,   204,     0,   682,     0,     0,
     206,     0,   683,   208,   209,     0,     0,     0,     0,   684,
      42,     0,     0,     0,     0,   685,     0,     0,   686,   687,
     688,   689,   216,     0,     0,   690,   218,   219,     0,     0,
       0,     0,     0,     0,   105,  -369,     0,     0,     0,     0,
       0,     0,     0,   106,    10,    12,     0,     0,    53,   107,
       0,    55,    13,    14,     0,    15,    16,    17,    18,     0,
      20,    21,     0,     0,     0,   185,     0,   186,     0,     0,
     187,     0,   188,     0,   189,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   190,
       0,     0,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   675,   676,   677,   678,   679,    31,   197,   198,     0,
     199,    32,     0,   680,     0,     0,     0,     0,     0,     0,
       0,     0,   201,     0,     0,     0,     0,     0,   681,     0,
       0,     0,   203,     0,     0,     0,     0,     0,   204,     0,
     682,     0,     0,   206,     0,   683,   208,   209,     0,     0,
       0,     0,   684,    42,     0,     0,     0,     0,   685,     0,
       0,   686,   687,   688,   689,   216,     0,     0,   690,   218,
     219,     0,     0,     0,     0,     0,     0,   691,     0,     0,
       0,     0,     0,     0,     0,     0,   106,    10,    12,     0,
       0,    53,   107,     0,    55,    13,    14,     0,    15,    16,
      17,    18,    19,    20,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,    27,    28,    29,    30,    31,
       0,     0,     0,     0,    32,     0,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,     0,     0,     0,
       0,    36,     0,    10,    12,    38,     0,     0,     0,     0,
       0,    13,    14,    39,    15,    16,    17,    18,    40,    20,
      21,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,    43,     0,     0,    44,    45,    46,    47,     0,     0,
       0,    48,     0,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,     0,     0,     0,     0,     0,     0,    51,
       0,     0,     0,     0,    53,    54,     0,    55,     0,     0,
      26,    27,    28,    29,    30,    31,     0,     0,     0,     0,
      32,     0,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,    40,     0,     0,    10,    12,     0,
       0,    41,    42,     0,     0,     0,     0,    43,     0,     0,
      44,    45,    46,    47,     0,     0,     0,    48,   185,     0,
     186,     0,     0,   187,     0,   188,   105,   189,     0,     0,
       0,     0,     0,     0,     0,   106,     0,     0,     0,     0,
      53,   107,   190,    55,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,     0,
     197,   198,     0,   199,     0,     0,   200,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,     0,
       0,   204,     0,   205,     0,     0,   206,     0,   207,   208,
     209,     0,     0,    -5,     0,   210,     0,     0,     0,     0,
       0,   211,   318,     0,   212,   213,   214,   215,   216,     0,
       0,   217,   218,   219,   319,   320,   321,     0,     0,     0,
       0,     0,     0,     0,     0,   322,     0,     0,   459,     0,
       0,   -43,     0,   323,     0,     0,     0,   324,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   325,
       0,     0,   -43,     0,   -43,     0,     0,     0,   326,   327,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   328,     0,     0,     0,     0,    10,
      12,     0,     0,     0,     0,     0,     0,     0,     0,   329,
       0,     0,     0,     0,     0,     0,   330,     0,   331,   332,
     185,   333,   186,     0,     0,   187,   334,   188,     0,   189,
     335,   336,   337,   338,     0,     0,     0,     0,     0,     0,
       0,   -43,     0,     0,   190,     0,     0,   191,   339,     0,
       0,     0,     0,   340,     0,     0,     0,     0,     0,     0,
     319,   320,   321,     0,     0,     0,   192,   193,   194,   195,
     196,   322,   197,   198,     0,   199,     0,   -43,   200,   323,
       0,     0,     0,   324,     0,     0,     0,   201,     0,     0,
       0,     0,     0,   202,     0,   325,     0,   203,     0,     0,
       0,     0,     0,   204,   326,   205,     0,     0,   206,     0,
     207,   208,   209,     0,     0,     0,     0,   210,     0,     0,
     328,     0,     0,   211,     0,     0,   212,   213,   214,   215,
     216,     0,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,   330,     0,   331,   332,     0,   333,     0,   319,
     320,   321,   334,     0,     0,     0,   335,   336,   337,   338,
     322,     0,     0,     0,     0,     0,   -43,   -43,   323,     0,
       0,     0,   324,     0,   339,     0,     0,     0,     0,   340,
       0,     0,     0,     0,   325,     0,     0,     0,     0,   -64,
       0,     0,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   330,     0,   331,   332,   185,   333,   186,     0,     0,
     187,   334,   188,     0,   189,   335,   336,   337,   338,     0,
       0,     0,     0,     0,     0,     0,   -43,     0,     0,   190,
       0,     0,   191,   339,     0,     0,     0,     0,   340,     0,
       0,     0,     0,     0,     0,     0,     0,   629,     0,     0,
       0,   192,   193,   194,   195,   196,     0,   197,   198,     0,
     199,     0,     0,   200,     0,     0,     0,     0,     0,     0,
       0,     0,   201,     0,     0,     0,     0,     0,   202,     0,
       0,     0,   203,     0,     0,     0,     0,     0,   204,     0,
     205,     0,     0,   206,     0,   207,   208,   209,   185,     0,
     186,     0,   210,   187,     0,   188,     0,   189,   211,     0,
       0,   212,   213,   214,   215,   216,     0,     0,   217,   218,
     219,     0,   190,     0,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,     0,
     197,   198,     0,   199,     0,     0,   200,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,     0,
       0,   204,     0,   205,     0,     0,   206,     0,   207,   208,
     209,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,   211,     0,     0,   212,   213,   214,   215,   216,     0,
       0,   217,   218,   219
  };

  const short
  Parser::yycheck_[] =
  {
       2,    35,   117,   182,   119,   120,   121,   122,   418,   429,
       4,   545,   100,    23,   274,   649,     7,    17,   673,   502,
     245,     3,    32,    33,     3,   113,   636,     9,     8,    39,
     118,   256,     8,    65,    27,   123,     3,     8,    48,    27,
      58,   694,    38,    35,    93,   606,   271,    49,    52,    51,
      88,    43,    16,    17,    35,   102,   711,   846,    16,    17,
       8,     3,     4,    98,    93,     8,   745,   856,   574,   748,
     151,     0,   153,    17,    16,    17,    18,   866,     8,   585,
     586,   116,    27,   738,   148,    89,   143,     8,    90,   144,
     178,    93,   156,   746,     8,     8,   151,   750,   147,   660,
     102,    68,   663,   105,    46,   666,     3,   154,   110,     8,
     112,    92,     9,   792,    96,   162,   163,    65,   147,   145,
     101,    38,   103,    35,   156,   143,   152,   153,   143,   144,
     112,    43,   128,   114,     3,   117,   151,    35,   791,   141,
     793,   144,    59,   124,    61,    43,   163,     3,   151,   759,
     473,   153,    92,     9,   136,   148,   479,   480,   150,   146,
     160,   101,   150,   103,   252,   156,   154,   143,   150,   149,
       9,   150,   143,   146,   114,     3,     3,   179,   172,   152,
     182,     9,     9,   177,   124,   605,   180,   197,   198,   844,
     200,   697,   753,   754,   700,   205,   160,   161,   704,    96,
     143,   211,   160,   161,   146,   615,     3,   217,   218,   154,
     716,   128,     9,   143,   848,   112,   160,   161,    57,     8,
     117,   481,   143,   784,    63,    64,   787,   452,   453,   143,
     143,   456,   457,   794,   459,   796,   719,   462,   150,   136,
      96,   356,   330,   152,   143,   470,   471,   808,    60,   783,
       9,   476,   786,   150,   143,   144,   112,   818,   819,   820,
     766,   117,   151,   827,   144,   104,    78,   146,    96,    96,
     831,   151,   274,   275,   148,   146,   278,     3,   842,   153,
     136,   691,   276,     9,   112,   112,   146,   146,   849,   117,
     117,   855,   152,   152,   150,   141,   142,   803,    57,    96,
     834,   800,   836,   146,    63,    64,   435,   146,   136,   136,
     149,   440,   811,   148,   146,   112,   151,   319,   320,   321,
     117,   149,   324,   150,   823,   143,   146,   145,   416,   146,
     143,   333,   152,   327,   147,   152,   338,   339,   146,   136,
     152,   153,   841,     3,   152,   104,    25,   328,   148,     9,
     146,   151,   149,   143,   143,   144,   158,   147,   147,   148,
     149,   146,   151,   357,   153,    95,    96,    97,    98,    99,
      96,   365,   597,   143,   146,   145,    34,   358,   359,    37,
     361,   362,   363,   385,   365,   387,   112,   368,   369,   391,
     145,   117,    50,   148,    52,   148,   159,   150,    56,    57,
     157,   158,   159,   160,   151,    45,   148,   388,    17,   151,
     136,   413,   143,   146,   809,   146,   418,   812,   358,   359,
     147,   361,   362,   363,   426,    16,    17,   177,   368,   369,
     180,   425,   713,   435,   715,   173,    96,   175,   440,   147,
     148,   861,   150,   151,   152,    85,   110,   111,   388,   146,
     629,   146,   112,   160,   161,    16,    17,   117,    98,    99,
     441,   146,   443,   444,   458,    16,    17,    16,    17,   146,
     472,   473,    16,    17,   468,   469,   136,   479,   480,   481,
     482,   143,   144,   146,   124,     3,     4,   489,   158,   491,
     147,   148,   144,   145,    62,   144,   145,    12,   500,    67,
     146,   495,   144,   145,   144,   144,   145,   155,   156,   146,
     168,   169,   170,   171,   164,   165,   146,   157,    86,   146,
     501,   166,   167,   702,   147,   146,    94,   521,   147,   147,
     144,   148,   100,    56,   156,   148,    13,   163,   158,   147,
     534,   146,   149,   146,   146,   526,    17,   541,   149,   543,
     147,   545,   533,   534,    17,   147,   145,   147,   126,   147,
     147,   501,   147,   147,   789,   790,   147,   147,   570,   147,
     572,   573,   574,   148,   147,    16,   148,   147,   146,    17,
     147,   615,   584,   585,   586,   587,   526,   155,   147,   591,
      62,   147,   147,   533,   147,    67,     7,   147,   166,   147,
     147,   603,   147,   145,   147,   607,   147,   588,   147,   590,
     156,   592,   593,   838,    86,   146,   618,   598,   143,   621,
     146,   602,    94,   143,   626,   146,   143,   629,   100,   143,
     143,   143,    11,   143,   615,   146,   143,   146,    67,   641,
     146,   149,   146,   146,    62,   147,   627,   146,   588,    67,
     143,   143,   592,   593,   126,    81,   146,   691,   598,     6,
     775,   749,   602,   163,   143,   143,   147,   661,    86,   143,
     680,   144,   682,   143,   146,   685,    94,   143,   147,    67,
     690,   145,   100,   155,   151,   153,   147,   627,   148,   691,
     147,   147,   143,   674,   166,   697,   143,   147,   700,   147,
     702,   147,   704,   147,    11,   144,    17,   709,   126,   145,
     691,    68,   145,   144,   716,   150,   718,   832,   146,   146,
     722,   143,   147,   147,    21,    22,    23,   729,   146,     5,
     147,   733,   726,   147,   674,    32,   143,   155,   143,   143,
     149,    38,   736,    40,   147,   145,   147,    44,   166,   751,
     149,   149,   149,   147,    49,    49,   758,   144,   149,    56,
     143,   742,   743,   744,   766,   147,   146,   143,    65,   143,
     147,   144,   147,     3,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,    81,   146,   146,   145,   143,   783,
      27,   145,   786,   155,   150,   146,    49,   156,   150,   147,
     143,   803,   742,   743,   744,   147,   103,   156,   105,   106,
     143,   108,   147,   145,    47,   809,   113,   156,   812,   146,
     117,   118,   119,   120,   146,     8,   146,    27,   143,   146,
     741,   128,   182,   147,   815,   537,   182,   182,   135,   603,
     834,   843,   836,   140,   651,   534,     0,   521,   829,     3,
       4,   726,   736,   150,   540,     9,   738,    11,    12,   149,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
     154,   162,   161,    54,   618,   815,    30,   163,    32,   181,
      -1,   481,    36,   279,    38,    -1,    40,    -1,    -1,   829,
      44,   387,    46,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    59,    -1,    61,    -1,    -1,
      -1,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,    96,    97,    -1,    -1,   100,   101,    -1,   103,
      -1,   105,   106,    -1,   108,   109,    -1,    -1,    -1,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,   122,    -1,
      -1,    -1,    -1,   127,   128,    -1,   130,   131,   132,   133,
      -1,   135,    -1,   137,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     154,   155,    -1,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,     0,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,     9,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    -1,    -1,    36,    -1,
      38,    -1,    40,    -1,    -1,    -1,    44,    -1,    46,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    59,    -1,    61,    -1,    -1,    -1,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    -1,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    96,    97,
      -1,    -1,   100,   101,    -1,   103,    -1,   105,   106,    -1,
     108,   109,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,   127,
     128,    -1,   130,   131,   132,   133,    -1,   135,    -1,   137,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   154,   155,    -1,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    -1,    80,    -1,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    97,    -1,    -1,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,   114,
      -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,
      -1,    -1,   127,    -1,    -1,   130,   131,   132,   133,    -1,
      -1,    -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,
     155,    -1,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    -1,    19,    20,    -1,
      -1,    -1,    24,    -1,    26,    -1,    -1,    29,    -1,    31,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    93,    -1,    -1,    -1,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,   107,    -1,   109,    -1,    -1,
     112,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,   121,
     122,    -1,    -1,    -1,    -1,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,    -1,    -1,
      -1,    -1,    -1,    -1,   146,   147,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,     3,     4,    -1,    -1,   160,   161,
      -1,   163,    11,    12,    -1,    14,    15,    16,    17,    -1,
      19,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,
      29,    -1,    31,    -1,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,    -1,   112,    -1,   114,   115,   116,    -1,    -1,
      -1,    -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,     3,     4,    -1,
      -1,   160,   161,    -1,   163,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    -1,    80,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      -1,    97,    -1,     3,     4,   101,    -1,    -1,    -1,    -1,
      -1,    11,    12,   109,    14,    15,    16,    17,   114,    19,
      20,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,   131,   132,   133,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,    -1,   160,   161,    -1,   163,    -1,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,
      80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,    -1,    -1,   114,    -1,    -1,     3,     4,    -1,
      -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,
     130,   131,   132,   133,    -1,    -1,    -1,   137,    24,    -1,
      26,    -1,    -1,    29,    -1,    31,   146,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,
     160,   161,    48,   163,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,   114,   115,
     116,    -1,    -1,     0,    -1,   121,    -1,    -1,    -1,    -1,
      -1,   127,     9,    -1,   130,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,   154,    -1,
      -1,    38,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    59,    -1,    61,    -1,    -1,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,   105,   106,
      24,   108,    26,    -1,    -1,    29,   113,    31,    -1,    33,
     117,   118,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    48,    -1,    -1,    51,   135,    -1,
      -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    32,    76,    77,    -1,    79,    -1,    38,    82,    40,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    56,    -1,   101,    -1,    -1,
      -1,    -1,    -1,   107,    65,   109,    -1,    -1,   112,    -1,
     114,   115,   116,    -1,    -1,    -1,    -1,   121,    -1,    -1,
      81,    -1,    -1,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,    -1,    -1,    -1,    -1,
      -1,    -1,   103,    -1,   105,   106,    -1,   108,    -1,    21,
      22,    23,   113,    -1,    -1,    -1,   117,   118,   119,   120,
      32,    -1,    -1,    -1,    -1,    -1,    38,   128,    40,    -1,
      -1,    -1,    44,    -1,   135,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,   150,
      -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   103,    -1,   105,   106,    24,   108,    26,    -1,    -1,
      29,   113,    31,    -1,    33,   117,   118,   119,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    48,
      -1,    -1,    51,   135,    -1,    -1,    -1,    -1,   140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    -1,    76,    77,    -1,
      79,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,    -1,   112,    -1,   114,   115,   116,    24,    -1,
      26,    -1,   121,    29,    -1,    31,    -1,    33,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,    -1,    48,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,   114,   115,
     116,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139
  };

  const short
  Parser::yystos_[] =
  {
       0,   141,   142,   168,    88,   170,   169,   261,   262,     0,
       3,   171,     4,    11,    12,    14,    15,    16,    17,    18,
      19,    20,    30,    36,    46,    50,    70,    71,    72,    73,
      74,    75,    80,    82,    86,    92,    97,   100,   101,   109,
     114,   121,   122,   127,   130,   131,   132,   133,   137,   146,
     154,   155,   158,   160,   161,   163,   164,   165,   171,   172,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   284,   285,   288,
     292,   293,   294,   295,   296,   299,   300,   301,   143,   163,
     146,   152,   213,   146,   146,   146,   146,   146,   146,   146,
     146,   213,   146,   213,   278,   146,   155,   161,   172,   284,
     146,   278,   146,   146,   213,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   213,    93,   261,   289,   291,   278,
       7,   261,   264,   265,   297,   298,   278,    16,    17,    16,
      17,   146,   282,   302,   278,   278,   263,    45,    85,    98,
      99,   124,   144,   157,    25,    52,    89,    60,    78,   152,
     153,   158,   159,   151,   110,   111,   160,   161,   102,   154,
     162,   163,    62,    67,    86,    94,   100,   126,   146,   155,
     166,   158,   176,    17,   261,    24,    26,    29,    31,    33,
      48,    51,    70,    71,    72,    73,    74,    76,    77,    79,
      82,    91,    97,   101,   107,   109,   112,   114,   115,   116,
     121,   127,   130,   131,   132,   133,   134,   137,   138,   139,
     172,   209,   210,   211,   212,   215,   218,   221,   224,   229,
     261,    17,   160,   161,   286,   286,   286,   286,   160,   161,
     285,   286,   286,   261,   264,   212,   261,   304,   305,   306,
     212,   261,   146,   261,   261,   264,   212,    12,    17,   160,
     161,   285,   287,   160,   287,   264,   287,   287,   287,   287,
     264,   212,   147,   147,   148,   144,    56,   156,   148,   148,
     156,   158,   261,    13,   267,   267,   269,   267,   267,   267,
     261,   270,   271,   271,   272,   272,   272,   272,   273,   274,
     275,   276,   276,   277,   277,   278,   278,   278,   278,   171,
     283,   279,   279,   283,   264,   261,   283,   301,     9,    21,
      22,    23,    32,    40,    44,    56,    65,    66,    81,    96,
     103,   105,   106,   108,   113,   117,   118,   119,   120,   135,
     140,   177,   178,   179,   180,   182,   183,   184,   185,   186,
     187,   203,   207,   208,   261,   147,   146,   149,   213,   213,
     146,   213,   213,   213,   149,   213,   146,   230,   213,   213,
     151,   153,   214,   147,    17,    17,   147,   147,   147,   147,
     147,   147,   147,   147,   214,   145,   147,   148,   148,   264,
     147,   148,   147,   214,   147,    17,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   214,   290,   291,   261,   171,
     261,   298,   303,   145,   147,   156,   146,   143,   144,   261,
     261,   261,   143,   143,   261,   146,   146,   171,   172,   252,
     253,   264,   143,   261,   143,   146,   143,   143,   261,   261,
     146,    38,    59,    61,   128,   188,   189,   143,   287,   171,
     222,   223,   212,   212,    11,   212,   212,   212,   219,   154,
     171,   212,   216,   217,    68,   192,   193,   194,   197,   149,
     212,   212,   146,   146,   261,   306,   212,   147,   261,   146,
     146,   148,    67,   163,   261,   264,   211,   261,   143,   145,
     143,   145,   143,   143,   171,    81,   181,   261,    58,   143,
     144,   145,   146,   249,   250,     6,   143,   143,   181,   261,
     143,   143,   181,   261,   172,   190,   172,   172,   143,   147,
     144,   148,   150,   214,   214,   147,   148,   214,   214,   150,
     171,   220,   214,   145,   148,   214,   147,   148,   171,     9,
      96,   112,   117,   136,   171,   231,   232,   233,   234,   235,
     236,   237,   239,   240,   257,   214,   214,   261,   289,   214,
     147,   289,   289,   290,   261,   147,   143,   143,   261,   261,
      67,   171,   143,   147,   147,   173,   174,   261,   212,   192,
     251,   254,   147,   147,   143,   147,   147,   144,   145,    11,
     191,   144,   145,   144,   225,    17,   223,   212,   145,   212,
     217,   194,   145,   144,   308,   252,   171,   146,   258,   171,
     233,   150,   145,   152,   153,   241,   147,   147,   146,   147,
     147,    65,   156,   143,   143,   261,   144,   145,   261,   149,
     178,   179,   187,   199,   200,   203,   199,   143,     5,   143,
     143,   144,   147,     9,    57,    63,    64,   104,   255,   256,
     149,   149,   261,   199,   199,   261,   212,   172,   261,   212,
     212,   149,   214,   212,   212,   209,   261,     8,   143,   307,
     249,   308,   261,   149,   145,    70,    71,    72,    73,    74,
      82,    97,   109,   114,   121,   127,   130,   131,   132,   133,
     137,   146,   172,   211,   284,   304,   261,   147,   261,   212,
     147,   201,   202,   203,    49,   204,   204,   175,   261,   144,
     200,    35,    43,   205,   206,   205,   147,   143,   144,   146,
     143,   143,   144,   308,   171,   226,   227,   228,   308,   144,
     198,   143,   308,   144,   143,   147,    27,   154,   259,   260,
     265,   212,   213,   213,   213,   172,   211,   238,   284,   146,
     242,   155,   243,   244,   244,   147,   156,   199,   144,   199,
     150,   203,   199,   143,   261,   265,   145,   150,   206,   150,
     199,   261,   192,   261,   143,   145,   150,   228,   143,   261,
     143,   261,   237,    27,   150,   260,    27,   198,   212,   212,
     212,   242,   244,   147,   242,   264,   244,   156,   261,   308,
     308,   261,   204,   145,   199,   143,   147,   143,   287,   149,
     233,   308,   149,   233,   308,   148,   214,   214,   244,   242,
     244,   308,   147,   308,   156,    65,   245,   245,   199,   145,
     195,   196,    47,   308,   231,   245,   231,   143,   212,   308,
     308,   308,   245,   146,    27,   246,   246,   212,   308,   287,
     143,   150,   143,   150,   214,   245,   246,   261,   265,   143,
     247,   248,   249,   247,   200,   308,   246,   247,   147,   249,
     143,   247
  };

  const short
  Parser::yyr1_[] =
  {
       0,   167,   168,   168,   169,   170,   171,   172,   172,   174,
     175,   173,   176,   176,   176,   177,   177,   177,   177,   177,
     177,   177,   178,   179,   179,   180,   180,   180,   181,   181,
     182,   182,   182,   183,   183,   184,   184,   185,   185,   185,
     186,   187,   187,   187,   188,   189,   190,   191,   191,   192,
     192,   193,   193,   194,   195,   196,   196,   197,   197,   198,
     198,   199,   199,   200,   201,   201,   202,   202,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   204,   204,   205,   205,   206,
     206,   207,   207,   207,   208,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     210,   211,   210,   212,   212,   212,   213,   214,   215,   215,
     216,   216,   216,   217,   217,   218,   219,   219,   220,   221,
     222,   222,   222,   223,   223,   225,   224,   226,   226,   227,
     227,   228,   228,   229,   230,   230,   231,   231,   232,   232,
     233,   233,   233,   233,   233,   233,   234,   235,   236,   236,
     236,   237,   237,   237,   237,   238,   238,   238,   239,   240,
     240,   241,   241,   241,   241,   242,   242,   243,   243,   244,
     244,   245,   245,   246,   246,   247,   247,   248,   248,   249,
     250,   250,   251,   251,   253,   254,   252,   255,   255,   255,
     256,   256,   256,   257,   258,   258,   259,   259,   260,   260,
     260,   260,   260,   262,   263,   261,   264,   264,   265,   265,
     266,   267,   267,   267,   267,   267,   267,   267,   268,   268,
     269,   269,   270,   270,   270,   271,   271,   271,   271,   271,
     272,   272,   273,   273,   274,   274,   275,   275,   275,   276,
     276,   276,   277,   277,   277,   277,   277,   278,   278,   278,
     278,   278,   278,   278,   279,   279,   279,   279,   279,   279,
     279,   279,   279,   279,   279,   280,   280,   280,   280,   280,
     280,   280,   281,   281,   281,   281,   281,   281,   282,   282,
     282,   282,   283,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   285,   285,   285,
     286,   286,   286,   287,   287,   288,   288,   289,   289,   289,
     290,   290,   290,   290,   291,   291,   292,   292,   292,   293,
     293,   294,   294,   295,   295,   296,   297,   297,   298,   299,
     300,   300,   302,   303,   301,   304,   304,   305,   305,   306,
     307,   307,   308,   308
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     2,     2,     1,     4,     1,     1,     1,     0,
       0,     3,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     7,     6,     8,     5,     5,     7,     6,     4,
       6,     6,     8,     2,     3,     3,     5,     2,     4,     4,
       3,     1,     1,     0,    10,     9,     0,     1,     0,     1,
       0,     3,     1,     5,     2,     1,     0,     1,     0,     2,
       0,     1,     1,     3,     1,     0,     2,     1,     2,     1,
       3,     5,     3,     5,     2,     2,     7,     6,     6,     8,
       3,     2,     3,     2,     3,     7,     7,     2,     2,     7,
       5,     5,     3,     3,     3,     2,     0,     2,     1,     4,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     4,     4,
       6,     4,     4,     1,     4,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     1,     1,     1,     1,     4,     4,
       3,     2,     1,     1,     3,     4,     2,     0,     5,     4,
       3,     2,     1,     1,     3,     0,     8,     1,     0,     2,
       1,     7,     5,     5,     3,     0,     2,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     7,     4,     3,     5,
       4,     8,     8,     9,    10,     3,     4,     4,     3,     1,
       0,     1,     1,     1,     0,     3,     0,     3,     2,     1,
       0,     4,     0,     2,     0,     1,     1,     2,     1,     4,
       3,     0,     2,     0,     0,     0,     3,     1,     3,     1,
       1,     1,     0,     8,     3,     0,     2,     1,     5,     5,
       3,     3,     2,     0,     0,     3,     1,     0,     3,     1,
       1,     3,     3,     3,     3,     3,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     2,     2,     2,
       3,     2,     2,     1,     4,     3,     6,     4,     3,     3,
       3,     2,     2,     3,     1,     7,     4,     4,     2,     2,
       5,     1,     1,     6,     2,     7,     9,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     2,     1,     2,     3,     4,     1,     3,     0,
       1,     3,     1,     0,     1,     1,     3,     4,     7,     4,
       7,     4,     7,     4,     9,     3,     3,     1,     3,     1,
       3,     1,     0,     0,     5,     1,     0,     3,     1,     3,
       1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"dotted identifier\"", "\"hook identifier\"",
  "\"$-identifier\"", "\"attribute\"", "\"property\"",
  "\"preprocessor directive\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"$<N>\"",
  "\"bool value\"", "\"null value\"", "\"assert\"", "\"assert-exception\"",
  "ADD", "ADDRESS", "AND", "ANY", "ARROW", "AUTO", "BITFIELD", "BEGIN_",
  "BOOL", "BREAK", "BYTES", "CADDR", "CASE", "CAST", "CATCH", "CONST",
  "CONSTANT", "CONTINUE", "DEBUG_", "DECLARE", "DEFAULT", "DELETE",
  "DIVIDEASSIGN", "DOLLARDOLLAR", "DOTDOT", "REAL", "ELSE", "END_", "ENUM",
  "EQ", "EXCEPTION", "EXPORT", "FILE", "FOR", "FOREACH", "FROM",
  "FUNCTION", "GEQ", "GLOBAL", "HASATTR", "HOOK_COMPOSE", "HOOK_PARSE",
  "IF", "IMPORT", "IN", "INOUT", "INT", "INT16", "INT32", "INT64", "INT8",
  "INTERVAL", "INTERVAL_NS", "ITERATOR", "CONST_ITERATOR", "LEQ",
  "\"library type\"", "LIST", "LOCAL", "MAP", "MARK", "CAPTURES",
  "MINUSASSIGN", "MINUSMINUS", "MOD", "MODULE", "NEQ", "NET", "NETWORK",
  "NEW", "NONE", "NOT_IN", "OBJECT", "ON", "OPTIONAL", "OR", "PLUSASSIGN",
  "PLUSPLUS", "PORT", "POW", "PRINT", "PRIORITY", "PRIVATE", "PUBLIC",
  "REGEXP", "RETURN", "SET", "SHIFTLEFT", "SHIFTRIGHT", "SINK", "STOP",
  "\"stream\"", "STRING", "STRUCT", "SWITCH", "\"confirm\"", "\"reject\"",
  "THROW", "TIME", "TIME_NS", "TIMER", "TIMESASSIGN", "TRY", "TRYATTR",
  "TUPLE", "TYPE", "UINT", "UINT16", "UINT32", "UINT64", "UINT8", "UNIT",
  "UNSET", "VAR", "VECTOR", "VIEW", "VOID", "WHILE", "START_MODULE",
  "START_EXPRESSION", "';'", "'='", "':'", "'('", "')'", "','", "'{'",
  "'}'", "'&'", "'<'", "'>'", "'*'", "'['", "']'", "'?'", "'|'", "'^'",
  "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "$accept", "start",
  "start_expr", "module", "local_id", "scoped_id", "dotted_id", "$@1",
  "$@2", "global_scope_items", "global_scope_decl", "type_decl",
  "constant_decl", "local_decl", "local_init_decl", "global_decl",
  "function_decl", "import_decl", "property_decl", "hook_decl",
  "opt_linkage", "function_with_body", "function_without_body",
  "opt_func_flavor", "opt_func_cc", "opt_func_params", "func_params",
  "func_param", "func_result", "opt_func_result", "opt_func_param_kind",
  "opt_init_expression", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "switch_cases", "switch_case", "stmt_decl",
  "stmt_expr", "base_type_no_ref", "reference_type", "base_type", "type",
  "type_param_begin", "type_param_end", "tuple_type", "tuple_type_elems",
  "tuple_type_elem", "struct_type", "struct_fields", "struct_field",
  "enum_type", "enum_labels", "enum_label", "bitfield_type", "$@3",
  "opt_bitfield_bits", "bitfield_bits", "bitfield_bits_spec", "unit_type",
  "opt_unit_params", "unit_items", "opt_unit_items", "unit_item",
  "unit_variable", "unit_sink", "unit_property", "unit_field",
  "unit_field_in_container", "unit_wide_hook", "opt_unit_field_id",
  "opt_unit_field_engine", "opt_unit_field_args", "unit_field_repeat",
  "opt_unit_field_repeat", "opt_unit_field_condition",
  "opt_unit_field_sinks", "opt_unit_item_hooks", "unit_hooks", "unit_hook",
  "opt_unit_hook_params", "opt_unit_hook_attributes", "unit_hook_id",
  "$@4", "$@5", "unit_hook_attribute", "opt_hook_engine", "unit_switch",
  "opt_unit_switch_expr", "unit_switch_cases", "unit_switch_case", "expr",
  "$@6", "$@7", "opt_exprs", "exprs", "expr_0", "expr_1", "expr_2",
  "expr_3", "expr_4", "expr_5", "expr_6", "expr_7", "expr_8", "expr_9",
  "expr_a", "expr_b", "expr_c", "expr_d", "expr_e", "expr_f", "expr_g",
  "member_expr", "ctor", "const_real", "const_sint", "const_uint", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "list", "vector",
  "set", "map", "struct_", "struct_elems", "struct_elem", "regexp",
  "re_patterns", "re_pattern_constant", "$@8", "$@9", "opt_map_elems",
  "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   295,   295,   296,   299,   301,   309,   319,   320,   322,
     324,   322,   329,   331,   333,   337,   338,   339,   340,   341,
     342,   343,   345,   354,   356,   360,   361,   362,   367,   369,
     373,   375,   377,   381,   383,   387,   388,   391,   392,   393,
     396,   404,   405,   406,   411,   418,   425,   427,   433,   437,
     438,   440,   441,   443,   446,   448,   449,   452,   453,   456,
     457,   462,   463,   466,   468,   469,   471,   472,   474,   475,
     476,   477,   478,   479,   481,   482,   483,   485,   487,   489,
     491,   492,   493,   494,   495,   496,   498,   500,   501,   502,
     504,   506,   509,   517,   525,   536,   537,   539,   540,   542,
     543,   545,   546,   547,   550,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   569,   570,
     571,   572,   573,   574,   575,   576,   578,   579,   580,   581,
     583,   584,   585,   587,   589,   591,   592,   593,   594,   595,
     600,   602,   603,   606,   607,   608,   612,   616,   619,   620,
     624,   626,   627,   631,   632,   635,   637,   638,   640,   642,
     644,   645,   646,   649,   650,   654,   653,   659,   661,   664,
     666,   669,   671,   676,   680,   681,   683,   684,   686,   687,
     690,   691,   692,   693,   694,   695,   699,   702,   704,   705,
     707,   710,   716,   719,   722,   726,   728,   730,   733,   736,
     737,   740,   741,   742,   743,   746,   747,   750,   751,   754,
     755,   758,   759,   762,   763,   766,   767,   769,   770,   772,
     776,   777,   780,   782,   784,   786,   784,   789,   790,   791,
     796,   797,   798,   800,   803,   804,   807,   809,   812,   813,
     814,   815,   816,   823,   825,   823,   829,   830,   832,   833,
     835,   838,   839,   840,   841,   842,   843,   844,   846,   847,
     849,   850,   852,   853,   854,   856,   857,   858,   859,   860,
     862,   863,   865,   866,   868,   869,   871,   872,   873,   875,
     876,   877,   879,   880,   881,   882,   883,   885,   886,   887,
     888,   889,   890,   891,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   905,   906,   907,   908,   909,
     910,   911,   913,   914,   915,   916,   918,   920,   922,   923,
     924,   925,   931,   935,   936,   937,   938,   939,   940,   941,
     943,   944,   945,   946,   947,   948,   951,   954,   955,   958,
     961,   962,   964,   965,   966,   967,   968,   969,   970,   971,
     973,   974,   975,   976,   977,   978,   979,   982,   983,   984,
     986,   987,   988,   990,   991,   993,   994,   997,   998,   999,
    1002,  1003,  1004,  1005,  1008,  1009,  1011,  1012,  1013,  1016,
    1017,  1020,  1021,  1024,  1025,  1028,  1031,  1032,  1034,  1036,
    1038,  1040,  1043,  1043,  1043,  1046,  1047,  1049,  1050,  1052,
    1056,  1057,  1060,  1061
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   164,     2,     2,     2,   162,   151,     2,
     146,   147,   154,   160,   148,   161,   166,   163,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   145,   143,
     152,   144,   153,   157,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   155,     2,   156,   159,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   149,   158,   150,   165,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142
    };
    // Last valid token kind.
    const int code_max = 397;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 28 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"
} } } // spicy::detail::parser
#line 6656 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc"

#line 1063 "/builddir/build/BUILD/zeek-5.0.8/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp"


void spicy::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
